/***************************************************************
 * Name:      
 * Purpose:   Core Code for Bilancio Application
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * forked from http://tekeye.biz/2012/about-box-in-android-app
 * Created:   2015-07-01
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

package com.igisw.bilancio;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.pm.PackageManager.NameNotFoundException;
import android.text.SpannableString;
import android.text.util.Linkify;
import android.view.InflateException;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

class AboutBox {

	static String WebAddress = "http://igisw-bilancio.sourceforge.net";
	static String email = "igor.cali0@gmail.com";
	
	static String VersionName(Context context) {
    try {
      return context.getPackageManager().getPackageInfo(context.getPackageName(),0).versionName;
    } catch (NameNotFoundException e) {
      return "Unknown";
    }
  }
  public static void Show(Activity callingActivity) {
    //Use a Spannable to allow for links highlighting
    SpannableString aboutText = new SpannableString(
    	callingActivity.getResources().getString(R.string.about_version) + " " 
    	+ VersionName(callingActivity)+ "\n\n"
    	+ WebAddress + "\n\n" + callingActivity.getString(R.string.about_text) + " " + email);
    //Generate views to pass to AlertDialog.Builder and to set the text
    View about;
    TextView tvAbout;
    try {
      //Inflate the custom view
      LayoutInflater inflater = callingActivity.getLayoutInflater();
      about = inflater.inflate(R.layout.about, (ViewGroup) callingActivity.findViewById(R.id.aboutView));
      tvAbout = (TextView) about.findViewById(R.id.aboutText);
    } catch(InflateException e) {
      //Inflater can throw exception, unlikely but default to TextView if it occurs
      about = tvAbout = new TextView(callingActivity);
    }
    //Set the about text
    tvAbout.setText(aboutText);
    // Now Linkify the text
    Linkify.addLinks(tvAbout, Linkify.ALL);
    //Build and show the dialog
    new AlertDialog.Builder(callingActivity)
      .setTitle(callingActivity.getResources().getString(R.string.about_title) + " " + callingActivity.getString(R.string.app_name))
      .setCancelable(true)
      .setIcon(R.drawable.ic_launcher)
      .setPositiveButton("OK", null)
      .setView(about)
      .show();    //Builder method returns allow for method chaining
  }
}
