/***************************************************************
 * Name:      
 * Purpose:   Core Code for Bilancio Application
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2016-03-27
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

package com.igisw.bilancio;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Locale;

import android.content.Context;
import android.content.SharedPreferences;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteException;
import android.widget.TableRow;
import android.widget.TextView;
import android.widget.Toast;

public class bil_library {

	public static Context appContext;
	
	// TODO: move strings to resources
	public static void Error(int Err, String Opt){
		
		String Msg;
		switch(Err){
			case 1:
				Msg = String.format(appContext.getResources().getString(R.string.error_01), Opt);
				break;
			case 2:
				Msg= String.format(appContext.getResources().getString(R.string.error_02), Opt);
				break;
			case 3:
				Msg = appContext.getResources().getString(R.string.error_03);
				break;
			case 4:
				Msg = appContext.getResources().getString(R.string.error_04);
				break;
			case 5:
				Msg = appContext.getResources().getString(R.string.error_05);
				break;
			case 6:
				Msg = appContext.getResources().getString(R.string.error_06);
				break;
			case 8:
				Msg = appContext.getResources().getString(R.string.error_08);
				break;
			case 9:
				Msg = appContext.getResources().getString(R.string.error_09);
				break;
			case 10:
				Msg = appContext.getResources().getString(R.string.error_10);
				break;
			case 11:
				Msg = String.format(appContext.getResources().getString(R.string.error_11), Opt);
				break;
			case 12:
				Msg = appContext.getResources().getString(R.string.error_12);
				break;
			case 13:
				Msg = appContext.getResources().getString(R.string.error_13);
				break;
			case 14:
				Msg = appContext.getResources().getString(R.string.error_14);
				break;
			case 15:
				Msg = appContext.getResources().getString(R.string.error_15);
				break;
			case 16:
				Msg = appContext.getResources().getString(R.string.error_16);
				break;
			case 17:
				Msg = appContext.getResources().getString(R.string.error_17);
				break;
			case 18:
				Msg = appContext.getResources().getString(R.string.error_18);
				break;
			case 19:
				Msg = appContext.getResources().getString(R.string.error_19);
				break;
			case 20:
				Msg = appContext.getResources().getString(R.string.error_20);
				break;
			case 21:
				Msg = String.format(appContext.getResources().getString(R.string.error_21), Opt);
				break;
			case 22:
				Msg = appContext.getResources().getString(R.string.error_22);
				break;
			case 23:
				Msg = appContext.getResources().getString(R.string.error_23);
				break;
			case 24:
				Msg = appContext.getResources().getString(R.string.error_24);
				break;
			case 25:
				Msg = appContext.getResources().getString(R.string.error_25);
				break;
			/*
			case 26:
				Msg = "You must insert a numeric value!";
				break;
			case 27:
				Msg = "You must insert a value greater than zero!";
				break;
			*/
			case 28:
				Msg = appContext.getResources().getString(R.string.error_28);
				break;
			case 29:
				Msg = appContext.getResources().getString(R.string.error_29);
				break;
			case 30:
				Msg = appContext.getResources().getString(R.string.error_30);
				break;
			case 31:
				Msg = appContext.getResources().getString(R.string.error_31);
				break;
			case 32:
				Msg = appContext.getResources().getString(R.string.error_32);
				break;
			case 33:
				Msg = appContext.getResources().getString(R.string.error_33);
				break;
			case 34:
				Msg = appContext.getResources().getString(R.string.error_34);
				break;
			case 35:
				Msg = appContext.getResources().getString(R.string.error_35);
				break;
			case 36:
				Msg = appContext.getResources().getString(R.string.error_36);
				break;
			case 37:
				Msg = appContext.getResources().getString(R.string.error_37);
				break;
			case 38:
				Msg = appContext.getResources().getString(R.string.error_38);
				break;
			case 39:
				Msg = appContext.getResources().getString(R.string.error_39);
				break;
			case 40:
				Msg = appContext.getResources().getString(R.string.error_40);
				break;
			case 41:
				Msg = String.format(appContext.getResources().getString(R.string.error_41), Opt);
				break;
			/*
			case 42:
				Msg = "You must use this application from Bilancio application!";
				break;
			case 43:
				Msg = "You can convert only one file at a time!";
				break;
			case 44:
				Msg = "Error during the document conversion!";
				break;
			*/
			case 45:
				Msg = String.format(appContext.getResources().getString(R.string.error_45), Opt);
				break;
			case 46:
				Msg = appContext.getResources().getString(R.string.error_46);
				break;
			case 48:
				Msg = String.format(appContext.getResources().getString(R.string.error_48), Opt);
				break;
			default:
				Msg = appContext.getResources().getString(R.string.error_unk);};
	
		//wxBell();	// TODO: implement beep
		Toast.makeText(appContext, Msg, Toast.LENGTH_LONG).show();
	}

	public static String FormDigits(double Val, boolean input){
		// set input to true when the output needs to be machine-readable
		String Ret;
		if(input) Ret = String.format(Locale.US, "%01.2f", Val);
		else Ret = String.format("%01.2f", Val);
		return Ret;}

	/*
	private static boolean Check301(String File){
		boolean Ret;
		int FL;	// FL: file lenght
		byte Buffer[];
		String S = "";
		File file = new File(File);
		FL = (int) file.length();
		FileInputStream fh = null;
		try {
			fh = new FileInputStream(file);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//fh->Seek(0);
		Buffer=new byte[FL + 1];
		try {
			if(fh.read(Buffer, 0, 6) == 6){
				S = new String(Buffer, "UTF-8"); // for UTF-8 encoding
				S = S.substring(0, 6);
			}
			else{
				fh.close();
				//delete fh;
				return false;}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			fh.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//delete fh;
		//delete[] Buffer;
		if(S.compareTo("Bil3.0") == 0) Ret = true;
		else Ret = false;
		return Ret;}
	*/
	
	private static boolean Check302(String File){
		boolean Ret;
		int FL;	// FL: file lenght
		byte Buffer[];
		String S = "";
		File file = new File(File);
		/*
		if(!fh->IsOpened()){
			delete fh;
			return false;}
		*/
		FL = (int) file.length();
		FileInputStream fh = null;
		try {
			fh = new FileInputStream(file);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//fh->Seek(0);
		Buffer = new byte[FL + 1];
		try {
			if(fh.read(Buffer, 0, 6) == 6){
				S = new String(Buffer, "UTF-8"); // for UTF-8 encoding
				S = S.substring(0, 6);
			}
			else{
				fh.close();
				//delete fh;
				return false;}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			fh.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//delete fh;
		//delete[] Buffer;
		//if(S == "Bil302")
		if(S.compareTo("Bil302") == 0) Ret = true;
		else Ret = false;
		return Ret;}

	public static constants.bilFileFormat CheckFileFormat(String File){
		// TODO (igor#1#): TO BE DEBUGGED
		constants.bilFileFormat Ret;
		if(Check302(File)) Ret = constants.bilFileFormat.bilFFORMAT_302;
		//else if(Check301(File)) Ret = constants.bilFileFormat.bilFFORMAT_301;
		else if(Check31(File)) Ret = constants.bilFileFormat.bilFFORMAT_31;
		else Ret = constants.bilFileFormat.bilFFORMAT_UNKNOWN;
		return Ret;}

	public static GregorianCalendar Bil_StrToDate(String S){
	    SimpleDateFormat df = new SimpleDateFormat("dd/MM/yyyy");
	    Date date = new Date();
		try {
			date = df.parse(S);
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	    GregorianCalendar ret = new GregorianCalendar();
	    ret.setTime(date);
		/*if(date.IsValid())*/return ret;
		//return double(NULL);
	}

	public static GregorianCalendar Bil_StrToTime(String S){
	    SimpleDateFormat df = new SimpleDateFormat("HH:mm:ss" /*"H:m:s"*/);
		Date time = new Date() /*null*/;
	    //Date date = new Date() /*null*/;
		try {
			time = df.parse(S);
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	    GregorianCalendar ret = new GregorianCalendar() /*null*/;
	    ret.setTime(time);
		/*if(time.IsValid())*/return ret;
		//return double(NULL);
	}

	public static String Bil_DateToStr(GregorianCalendar D){
	    SimpleDateFormat df = new SimpleDateFormat("dd/MM/yyyy");
	    Date date = D.getTime();
	    String ret = df.format(date);
		return ret;
	}

	public static String Bil_TimeToStr(GregorianCalendar T, boolean save){
		// TODO: rework to show leading zero in hour and minute
		SimpleDateFormat df;
		if(save) df = new SimpleDateFormat("HH:mm:ss" /*"k:m"*/);
		else df = new SimpleDateFormat("HH:mm" /*"k:m"*/);
	    Date time = T.getTime();
	    String ret = df.format(time);
		return ret;
	}

	public static String GetLogString(SharedPreferences Opts, int I){
		if(I>14)return null;

		String RegString = "S";
		if(I < 10) RegString += "0";
		RegString += String.format("%d", I);

		String value = Opts.getString(RegString, "NULL");
		return value;
	}

	public static void getEmptyText(TextView text)
	{
		text.setText(" ");
	    text.setLayoutParams(new TableRow.LayoutParams(TableRow.LayoutParams.MATCH_PARENT, TableRow.LayoutParams.WRAP_CONTENT));
	}
	
	/*
	public static String toCDouble(double v, char dec_sep)
	{
		String s = FormDigits(v);
		return s.replace(dec_sep, '.');
	}
	*/
	
	public static String iUpperCase(String S){
		String C = S.substring(0,1);
		C = C.toUpperCase();
		S = S.substring(1, S.length());
		S = C + S;
		return S;}

	public static void copyAsset(String src, String dest) throws IOException {
		InputStream in = null;
		try {
			in = appContext.getAssets().open(src);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		FileOutputStream out = null;
		try {
			out = new FileOutputStream(dest);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
		    byte[] buffer = new byte[1024];
		    int read;
		    while((read = in.read(buffer)) != -1){
		      out.write(buffer, 0, read);
		    }
	
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static void copyFile(File src, String dest) throws IOException {
		FileInputStream in = null;
		in = new FileInputStream(src);

		FileOutputStream out = null;
		try {
			out = new FileOutputStream(dest);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
		    byte[] buffer = new byte[1024];
		    int read;
		    while((read = in.read(buffer)) != -1){
		      out.write(buffer, 0, read);
		    }
	
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static boolean checkAlarm(GregorianCalendar A){
		int alarm_year, today_year;
		Calendar T = Calendar.getInstance();
		alarm_year = A.get(Calendar.YEAR);
		today_year = T.get(Calendar.YEAR);
		if ((alarm_year - today_year) >= 100) return false;
		else return true;
	}

	private static boolean Check31(String file){
		SQLiteDatabase db = SQLiteDatabase.openDatabase(file, null, SQLiteDatabase.OPEN_READONLY);
		try{

			int version = db.getVersion();
			if(version >= 0) return true;	// 0: pre-existing empty file
											// 1 or greater: schema updates (existing database
											// http://www.tutorialspoint.com/sqlite/sqlite_pragma.htm
			else return false;
		}
		catch(SQLiteException e){
			return false;
		}}
}
