/***************************************************************
 * Name:      
 * Purpose:   Core Code for Bilancio Application
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2016-12-27
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

package com.igisw.bilancio;

import java.util.ArrayList;
import java.util.Currency;
import java.util.List;
import java.util.Locale;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.Uri;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v7.widget.RecyclerView;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;

public class bilviewer extends Activity {
	
	//private TabHost myTabHost;
	private TData Data;
	private SharedPreferences Opts;
	private TableLayout Report;
	private RecyclerView rv;
	private List<lines_wrapper> operations = new ArrayList<>();

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		setContentView(R.layout.viewer);
	    Opts = PreferenceManager.getDefaultSharedPreferences(this);
		Intent intentURI = getIntent();
		Uri uri = null;   
		if (Intent.ACTION_VIEW.equals(intentURI.getAction())) {  
		    if (intentURI!=null) uri = intentURI.getData();   
		    if (uri!=null){   
		    	String path = uri.getPath();
			    Data = new TData(path, null, null);
			    showF();
		    }
		}
	}

	private void showF(){
		
		double val;
		
	    //String str_tmp;
	    Currency curr = Currency.getInstance(Locale.getDefault());
	    
		// Report
		operations.clear();
		int last_date_index = Data.NLin;
		for(int i = Data.NLin - 1; i >= 0 ; i--) {
			while (!Data.Lines.get(i).IsDate) i--;

			val = Double.parseDouble(Data.Lines.get(i).Value);
			operations.add(new lines_wrapper(0, curr.getSymbol() + " " + bil_library.FormDigits(val, false), "",
					bil_library.Bil_DateToStr(Data.Lines.get(i).Date), "", -1));

			for (int j = i + 1; j < last_date_index; j++) {
				int type;
				int opType = -1;
				String val_string;
				String cat_string;
				switch (Data.Lines.get(j).Type) {
					case toGain:
						type = 1;
						opType = R.drawable.greenplus;
						break;
					case toExpe:
						type = 2;
						opType = R.drawable.redminus;
						break;
					case toSetCre:
						type = 3;
						opType = R.drawable.creditnew;
						break;
					case toRemCre:
						type = 4;
						opType = R.drawable.creditremove;
						break;
					case toConCre:
						type = 5;
						opType = R.drawable.creditcondone;
						break;
					case toSetDeb:
						type = 6;
						opType = R.drawable.debitnew;
						break;
					case toRemDeb:
						type = 7;
						opType = R.drawable.debitremove;
						break;
					case toConDeb:
						type = 8;
						opType = R.drawable.debitcondone;
						break;
					case toGetObj:
						type = 9;
						opType = R.drawable.object_received;
						break;
					case toGivObj:
						type = 10;
						opType = R.drawable.object_given;
						break;
					case toLenObj:
						type = 11;
						opType = R.drawable.object_lent;
						break;
					case toBakObj:
						type = 12;
						opType = R.drawable.object_getback;
						break;
					case toBorObj:
						type = 13;
						opType = R.drawable.object_borrow;
						break;
					case toRetObj:
						type = 14;
						opType = R.drawable.object_giveback;
						break;
					default:
						type = -1;
				}
				if (type < 9) {
					val = Double.parseDouble(Data.Lines.get(j).Value);
					val_string = curr.getSymbol() + " " + bil_library.FormDigits(val, false);
				} else val_string = Data.Lines.get(j).Value;
				if (Data.Lines.get(j).CategoryIndex > 0)
					cat_string = Data.CategoryDB.get((int) Data.Lines.get(j).CategoryIndex - 1).Name;
				else cat_string = "";

				operations.add(new lines_wrapper(1, val_string, Data.Lines.get(j).Reason,
						bil_library.Bil_TimeToStr(Data.Lines.get(j).Time, false), cat_string, opType));

			}

			last_date_index = i;

		}

	}

}