/***************************************************************
 * Name:      
 * Purpose:   Header with constants for bilancio
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2016-10-03
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

package com.igisw.bilancio;

public class constants{
	
	final static int dbVersion = 31;	// Bilancio database version

	final static int dbMeta_application_info	= 1;
	final static int dbMeta_default_fund		= 2;
	final static int dbMeta_mobile_export		= 3;
	
	public enum bilFileFormat{
		bilFFORMAT_UNKNOWN,
		//bilFFORMAT_301,	// bilancio 3.0.1 format
		bilFFORMAT_302,	// bilancio 3.0.2 format
		bilFFORMAT_31,	// bilancio 3.1 format
	}
	
	final static String archive_name = "bilancio_master_mobile.bildb";

	// Main db definition

	// Metadata table create statement
	final static String cs_information = "create TABLE Information(" +
			"id INTEGER PRIMARY KEY," +
			"data TEXT);";

	// Funds table create statement
	final static String cs_funds = "create TABLE Funds(" +
			"id INTEGER PRIMARY KEY," +
			"name TEXT," +
			"value REAL);";

	// Credits table create statement
	final static String cs_credits = "CREATE TABLE Credits(" +
			"id INTEGER PRIMARY KEY," +
			"name TEXT," +
			"value REAL);";

	// Debts table create statement
	final static String cs_debts = "CREATE TABLE Debts(" +
			"id INTEGER PRIMARY KEY," +
			"name TEXT," +
			"value REAL);";

	// Loans table create statement
	final static String cs_loans = "CREATE TABLE Loans(" +
			"id INTEGER PRIMARY KEY," +
			"name TEXT," +
			"item TEXT," +
			"alarm INTEGER);";

	// Borrows table create statement
	final static String cs_borrows = "CREATE TABLE Borrows(" +
			"id INTEGER PRIMARY KEY," +
			"name TEXT," +
			"item TEXT," +
			"alarm INTEGER);";

	// Shopping list table create statement
	final static String cs_shoplist = "CREATE TABLE Shoplist(" +
			"id INTEGER PRIMARY KEY," +
			"item TEXT," +
			"alarm INTEGER);";

	// Transactions list table create statement
	final static String cs_transactions = "create TABLE Transactions(" +
			"id INTEGER PRIMARY KEY," +
			"isdate INTEGER," +
			"date INTEGER," +
			"time INTEGER," +
			"type INTEGER," +
			"value TEXT," +
			"reason TEXT," +
			"cat_index INTEGER);";

	// Categories list table create statement
	final static String cs_categories = "create TABLE Categories(" +
			"id INTEGER PRIMARY KEY," +
			"name TEXT," +
			"active INTEGER);";

	// Master db definition

	// Funds table create statement (master)
	final static String cs_funds_master = "create TABLE Funds%s(" +
			"id INTEGER PRIMARY KEY," +
			"name TEXT," +
			"value REAL);";

	// Credits table create statement (master)
	final static String cs_credits_master = "CREATE TABLE Credits%s(" +
			"id INTEGER PRIMARY KEY," +
			"name TEXT," +
			"value REAL);";

	// Debts table create statement (master)
	final static String cs_debts_master = "CREATE TABLE Debts%s(" +
			"id INTEGER PRIMARY KEY," +
			"name TEXT," +
			"value REAL);";

	// Loans table create statement (master)
	final static String cs_loans_master = "CREATE TABLE Loans%s(" +
			"id INTEGER PRIMARY KEY," +
			"name TEXT," +
			"item TEXT," +
			"alarm INTEGER);";

	// Borrows table create statement (master)
	final static String cs_borrows_master = "CREATE TABLE Borrows%s(" +
			"id INTEGER PRIMARY KEY," +
			"name TEXT," +
			"item TEXT," +
			"alarm INTEGER);";

	/*
	// Categories list table create statement (master)
	final static String cs_categories_master = "CREATE TABLE Categories%s(" +
			"id INTEGER PRIMARY KEY," +
			"name TEXT," +
			"active INTEGER);";
	*/

};
