/***************************************************************
 * Name:      
 * Purpose:   Core Code for Bilancio Application
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2016-04-12
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

package com.igisw.bilancio;

import java.util.ArrayList;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ListView;

public class editcategories extends Activity {

	/*
	public AutoCompleteTextView matters_View;
	public Spinner fund_spinner;
	public Spinner category_spinner;
	*/
	private boolean modified;
	private int item_pos;
	private ArrayList<String> categoryList;
	ArrayAdapter<String> categoryAdapter;
	private ImageButton btn;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.categories);
		
		Bundle bundle=getIntent().getExtras();
		
	    categoryList = bundle.getStringArrayList("categories");

	    // Create ArrayAdapter  
	    categoryAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_single_choice, categoryList);
	    // Set the ArrayAdapter as the ListView's adapter.  
	    ListView categoryView = (ListView) findViewById( R.id.CategoryView );
	    categoryView.setAdapter( categoryAdapter );
	    
	    btn = (ImageButton) findViewById( R.id.imageButton2 );
	    btn.setEnabled(false);

	    categoryView.setOnItemClickListener(new OnItemClickListener() {
	        @Override
	        public void onItemClick(AdapterView<?> adapter, View arg1, int position, long arg3) {
	        	btn.setEnabled(position >= 0);
	        	if(position >= 0)item_pos = position;
	        }
	    });
	    
	    modified = false;

	}
	
	public void okBtnClick(View view){
		int ReturnCode = RESULT_CANCELED;
		/*
		
		bil_library.appContext = getApplicationContext();

		TextView value = (TextView) findViewById(R.id.opValue);
		if(value.getText().toString().isEmpty()){
			bil_library.Error(25, "");
			value.requestFocus();
			return;}
		cur = Double.parseDouble(value.getText().toString());
		String matter = matters_View.getText().toString(); 
		if(matter.isEmpty()){
			bil_library.Error(29, "");
			matters_View.requestFocus();
			return;}
		matter = bil_library.iUpperCase(matter);
		matter = matter.trim();
		matters_View.setText(matter);
		
	*/
		// Create intent w/ result
		Intent intent = new Intent();
		Bundle bundle = new Bundle();
	/*
		bundle.putString("fund", fund_spinner.getSelectedItem().toString());
		bundle.putDouble("value", cur);
		bundle.putString("matter", matter);
		bundle.putInt("category", category_spinner.getSelectedItemPosition() -1);
	*/
		bundle.putBoolean("modified", modified);
		if(modified)bundle.putStringArrayList("categories", categoryList);
		intent.putExtras(bundle);
				
		ReturnCode = RESULT_OK;
		setResult(ReturnCode, intent);
		finish();
	}
	
	public void addCategory(View view){
		//int Response  = -1;

 		AlertDialog.Builder alert = new AlertDialog.Builder(this);

		alert.setTitle(this.getResources().getString(R.string.categories_add));

		// Set an EditText view to get user input 
		final EditText input = new EditText(this);
		//input.setTransformationMethod(PasswordTransformationMethod.getInstance());
		alert.setView(input);

		alert.setPositiveButton(getResources().getString(android.R.string.ok), new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int whichButton) {

				String value = input.getText().toString();
				if(!value.isEmpty()){
					value = value.trim();
					value = bil_library.iUpperCase(value);
					boolean Ex = false;
					for(int i = 0; i < categoryList.size(); i++){
						if(categoryList.get(i).compareToIgnoreCase(value) == 0){
							Ex = true;
							break;}}
					if(!Ex){
						categoryList.add(value);
						modified = true;}}
				
		  }
		});

		alert.setNegativeButton(getResources().getString(R.string.dialog_cancel), new DialogInterface.OnClickListener() {
		  public void onClick(DialogInterface dialog, int whichButton) {
		    // Canceled.
			//return false;
		  }
		});
		
		alert.show();

		//return Response;
		
	}

	public void removeCategory(View view){
		categoryList.remove(item_pos);
		categoryAdapter.notifyDataSetChanged();
		modified = true;
	}
}
