/***************************************************************
 * Name:      
 * Purpose:   Core Code for Bilancio Application
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2016-12-27
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

package com.igisw.bilancio;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.text.NumberFormat;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Currency;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.Locale;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.TaskStackBuilder;
import android.content.ContentValues;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.content.pm.PackageManager.NameNotFoundException;
import android.graphics.Bitmap;
import android.graphics.Bitmap.CompressFormat;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.media.RingtoneManager;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.preference.PreferenceManager;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.Html;
import android.text.method.DigitsKeyListener;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.Surface;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.DatePicker;
import android.widget.DatePicker.OnDateChangedListener;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.TabHost;
import android.widget.TabHost.TabSpec;
import android.widget.TextView;
import android.widget.Toast;

public class mainactivity extends Activity {

	private boolean HasAlarms = false;
	final int MainTimerInt = 600000;
	final int CHART_TAB = 7;	// Chart tab index
	
	private int fund_pos, credit_pos, debt_pos, lent_pos, borrowed_pos,
		shop_pos;
	
	private TabHost myTabHost;
	private TData Data;
	private String document;
	private String tmp_string;
	private ListView fundView, creditView, debtView, lentView, borrowedView,
		shopView;
	private ArrayAdapter<String> fundAdapter, creditAdapter, debtAdapter,
		lentAdapter, borrowedAdapter, shopAdapter;
	private SharedPreferences Opts;
	private DatePicker calendar;
	private ImageButton btn_removeFund, btn_editFund,
		btn_removeCredit, btn_condoneCredit,
		btn_removeDebt, btn_condoneDebt,
		btn_getbackObj, btn_givebackObj,
		btn_delShop;
	private ArrayList<String> fundList;
	private Handler timer;
	private RecyclerView rv;
	private List<lines_wrapper> operations = new ArrayList<>();

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		// String model = android.os.Build.MODEL;	// Development model: "LG-P692"
		// float density = getResources().getDisplayMetrics().density;	// http://stackoverflow.com/questions/5099550/how-to-check-an-android-device-is-hdpi-screen-or-mdpi-screen
		
		setContentView(R.layout.mainview);
		
		new SimpleEula(this).show(); 
		
	     Opts = PreferenceManager.getDefaultSharedPreferences(this);
		// Recuperation du TabHost
		myTabHost = (TabHost) findViewById(R.id.tabhost);
		// Before adding tabs, it is imperative to call the method setup()
		myTabHost.setup();

		// Adding tabs
		// tab1 settings
		TabSpec spec = myTabHost.newTabSpec("tab_creation");
		// text and image of tab
		spec.setIndicator(getResources().getString(R.string.dashboard)/*,getResources().getDrawable(android.R.drawable.ic_menu_add)*/);
		// specify layout of tab
		spec.setContent(R.id.onglet1);
		// adding tab in TabHost
		myTabHost.addTab(spec);

		// Fund tab
		myTabHost.addTab(myTabHost.newTabSpec("tab_inser").setIndicator(getResources().getString(R.string.funds)).setContent(R.id.onglet2));
	    btn_removeFund = (ImageButton) findViewById( R.id.removeFund );
	    btn_editFund = (ImageButton) findViewById( R.id.editFund );
	    btn_removeFund.setEnabled(false);
	    btn_editFund.setEnabled(false);
		
	    // Credit tab
		myTabHost.addTab(myTabHost.newTabSpec("tab_inser").setIndicator(getResources().getString(R.string.credits)).setContent(R.id.onglet4));
	    btn_removeCredit = (ImageButton) findViewById( R.id.removeCredit );
	    btn_condoneCredit = (ImageButton) findViewById( R.id.condoneCredit );
	    btn_removeCredit.setEnabled(false);
	    btn_condoneCredit.setEnabled(false);

	    // Debts tab
	    myTabHost.addTab(myTabHost.newTabSpec("tab_inser").setIndicator(getResources().getString(R.string.debts)).setContent(R.id.onglet5));
	    btn_removeDebt = (ImageButton) findViewById( R.id.delDebt );
	    btn_condoneDebt = (ImageButton) findViewById( R.id.condoneDebt );
	    btn_removeDebt.setEnabled(false);
	    btn_condoneDebt.setEnabled(false);

	    //myTabHost.addTab(myTabHost.newTabSpec("tab_inser").setIndicator(getResources().getString(R.string.operations)/*,getResources().getDrawable(android.R.drawable.ic_menu_edit)*/).setContent(R.id.onglet3));
		
	    // Objects tab
	    myTabHost.addTab(myTabHost.newTabSpec("tab_inser").setIndicator(getResources().getString(R.string.objects)).setContent(R.id.onglet6));
	    btn_getbackObj = (ImageButton) findViewById(R.id.getbackObj);
	    btn_givebackObj = (ImageButton) findViewById(R.id.givebackObj);
	    btn_getbackObj.setEnabled(false);
	    btn_givebackObj.setEnabled(false);

	    myTabHost.addTab(myTabHost.newTabSpec("tab_inser").setIndicator(getResources().getString(R.string.report)).setContent(R.id.onglet7));
		rv = (RecyclerView)findViewById(R.id.rv);
		LinearLayoutManager llm = new LinearLayoutManager(getApplicationContext());
		rv.setLayoutManager(llm);
		recycler_adapter adapter = new recycler_adapter(operations);
		rv.setAdapter(adapter);

	    // Shoplist tab
	    myTabHost.addTab(myTabHost.newTabSpec("tab_inser").setIndicator(getResources().getString(R.string.shoplist)).setContent(R.id.onglet8));
	    btn_delShop = (ImageButton) findViewById(R.id.delShopItem);
	    btn_delShop.setEnabled(false);

	    for(int i = 0; i < 7; i++){
	    	TextView tv =  (TextView) myTabHost.getTabWidget().getChildAt(i).findViewById(android.R.id.title); 
		    tv.setAllCaps(false);
		    myTabHost.getTabWidget().getChildAt(i).setPadding(0,0,0,0);
	    }
	    
		calendar = (DatePicker) findViewById( R.id.Calendar );
		calendar.init(calendar.getYear(), calendar.getMonth(), calendar.getDayOfMonth(),
			new OnDateChangedListener() {
		   
			   @Override
			   public void onDateChanged(DatePicker arg0, int arg1, int arg2, int arg3) {
				   giveDateTime();
			   }
			}
		);
		
		//boolean load_direct_doc = true;
		if(savedInstanceState != null){
			/*
			// Restore temporary document
			if(savedInstanceState.getBoolean("modified")){
				Data = new TData(this.getCacheDir() + "/temp.bil", this, null);
				Data.FileData.Modified = true;
				showF();
				load_direct_doc = false;
			}
			*/

			// Restore active tab
			myTabHost.setCurrentTab(savedInstanceState.getInt("tabindex"));
		}

		document = Opts.getString("GDDoc", "NULL");

		if(document == "NULL")
		{
			// Browse for file or launch wizard
			startActivityForResult(new Intent(getApplicationContext(), documentselection.class), 100);
		}
		else
		{
			/*if(load_direct_doc)*/ openDocument();

			Bundle bundle = getIntent().getExtras();
		    if(bundle != null){
	
				int kind = bundle.getInt("kind");
				int index = bundle.getInt("index");
				boolean snooze_all = bundle.getBoolean("snooze_all");
				int year = bundle.getInt("year");
				int month = bundle.getInt("month");
				int day = bundle.getInt("day");

				ContentValues cv = new ContentValues();

				//int i;
				GregorianCalendar cal = (GregorianCalendar) GregorianCalendar.getInstance();
				cal.set(year, month, day);
				
				switch(kind){
					case 1:
						Data.Lent.get(index).Alarm = cal;
						cv.clear();
						cv.put("alarm", cal.getTimeInMillis() / 1000);
						Data.database.update("Loans", cv, "id = " + String.format("%d", Data.Lent.get(index).Id), null);
						if(snooze_all)
						{
							boolean res;
							do{
								res = doChecks(true, 1, cal);
							}
							while(res);
						}
						Data.FileData.Modified = true;
						break;
					case 2:
						Data.Borrowed.get(index).Alarm = cal;
						cv.clear();
						cv.put("alarm", cal.getTimeInMillis() / 1000);
						Data.database.update("Borrows", cv, "id = " + String.format("%d", Data.Borrowed.get(index).Id), null);
						if(snooze_all)
						{
							boolean res;
							do{
								res = doChecks(true, 2, cal);
							}
							while(res);
						}
						Data.FileData.Modified = true;
						break;
					case 3:
						Data.ShopItems.get(index).Alarm = cal;
						cv.clear();
						cv.put("alarm", cal.getTimeInMillis() / 1000);
						Data.database.update("Shoplist", cv, "id = " + String.format("%d", Data.ShopItems.get(index).Id), null);
						if(snooze_all)
						{
							boolean res;
							do{
								res = doChecks(true, 3, cal);
							}
							while(res);
						}
						Data.FileData.Modified = true;
						break;
				}
				if(Data.FileData.Modified)showF();

		    }
			// Start timer to check alarms
		    HasAlarms = Data.HasAlarms();
			timer = new Handler();
			if(HasAlarms) new Thread(new Task()).start();
		}
		
	}

	/*
	@Override
	protected void onStart(){
		super.onStart();
		if(document == "NULL")
		{
			//startActivityForResult(new Intent(this, documentselection.class), 100);
		}
	}
	*/
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
	    MenuInflater inflater = getMenuInflater();
	    inflater.inflate(R.menu.mainmenu, menu);
	    return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
	    // Handle item selection
		
		Intent browserIntent;
		
	    switch (item.getItemId()) {
	    	case R.id.editcategories:
	    		EditCategoriesClick();
	    		return true;
	    
	        case R.id.options:
	        	startActivity(new Intent(this, mainoptions.class));
	            return true;

	        case R.id.setTotal:
	        	SetTotalClick();
	        	return true;
	            
	        case R.id.defaultFund:
	        	DefaultFundClick();
	        	return true;

 	        case R.id.about:
 	        	AboutBox.Show(mainactivity.this);
	            return true;
	            
 	        case R.id.help:
 	        	String guideAddress = "http://igisw-bilancio.sourceforge.net/android/guide/31/" + getResources().getString(R.string.lang) + "/help/bilancio-android.html";
 	        	browserIntent = new Intent(Intent.ACTION_VIEW, Uri.parse(guideAddress));
				startActivity(browserIntent);
				return true;

 	        case R.id.donate:
 	        	String donateAddress = "http://igisw-bilancio.sourceforge.net/donation.html";
 	        	browserIntent = new Intent(Intent.ACTION_VIEW, Uri.parse(donateAddress));
				//browserIntent.setClassName("com.android.browser", "com.android.browser.BrowserActivity");
				startActivity(browserIntent);
				return true;
				
 	        case R.id.bugReport:
 	        	
 	        	String bugAddress = "https://bugs.launchpad.net/bilancio";
 	        	browserIntent = new Intent(Intent.ACTION_VIEW, Uri.parse(bugAddress));
				startActivity(browserIntent);
				return true;

 	        case R.id.exportArchive:
 	        	File fMaster = this.getDatabasePath(constants.archive_name);
 	        	if(fMaster.exists()){
 	        		String dest = Data.FileData.FileName.getParent();
 	        		dest = dest + "/" + constants.archive_name;
 	        		try {
						bil_library.copyFile(fMaster, dest);
					} catch (IOException e) {
						// TODO Blocco catch generato automaticamente
						e.printStackTrace();
					}
 	        		Toast.makeText(getApplicationContext(), getResources().getString(R.string.export_archive_complete), Toast.LENGTH_LONG).show();

 	        	}
 	        	return true;

	        default:
	            return super.onOptionsItemSelected(item);
	    }
	}

	/*
	public void saveClick (View view){

		if(Data.FileData.Modified) Data.SaveToFile(false, document);
		return;
		
	}
	*/
	
	// TODO (igor#1#): To be restored when SQL encryption is available
	/*
	public void passwordClick(View view){
		Data.ModPass();
	}
	*/
	
	@Override
	//public void onPause(){
	public boolean onKeyDown (int keyCode, KeyEvent event){
		//super.onPause();
		if(keyCode == KeyEvent.KEYCODE_HOME /*&& event.getRepeatCount() == 0*/){
			/*
			if(Data.FileData.Modified){
				Data.SaveToFile(false, backupFile);
				Data.FileData.Modified = true;
			}
			else{
				File f = new File(backupFile);
				if(f.exists())f.delete();
			}
			//return true;
			 */
		}
		//else if(keyCode == KeyEvent.KEYCODE_BACK) onBackPressed();
		return super.onKeyDown(keyCode, event);
	}
	
	@Override
	public void onBackPressed(){

		if(Data != null && Data.FileData.Modified){
	 		AlertDialog.Builder alert = new AlertDialog.Builder(this);
	
	 		alert.setTitle(getResources().getString(R.string.app_name));
			alert.setMessage(getResources().getString(R.string.file_changed));

			alert.setPositiveButton(getResources().getString(android.R.string.ok), new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int whichButton) {
				Data.database.execSQL("RELEASE rollback;");
				Data.FileData.Modified = false;
				if(HasAlarms) moveTaskToBack(true);
				else{
					Data.database.close();
					finish();
				}
				}
			});
	
			alert.setNegativeButton(getResources().getString(R.string.dialog_no), new DialogInterface.OnClickListener() {
			  public void onClick(DialogInterface dialog, int whichButton) {
				  Data.FileData.Modified = false;
				  //Data.database.execSQL("ROLLBACK;");
				  if(HasAlarms) moveTaskToBack(true);
				  else{
					  onBackPressed();
					  Data.database.close();
					  finish();
				  }
			  }
			});
			
			alert.setNeutralButton(getResources().getString(R.string.dialog_cancel), new DialogInterface.OnClickListener() {
				  public void onClick(DialogInterface dialog, int whichButton) {
					  //
				  }
				});
			alert.show();
		}
		else{
			Data.database.close();
			super.onBackPressed();
		}
	}
	
	@Override
	public void onSaveInstanceState(Bundle outState) {
	   super.onSaveInstanceState(outState);
	   
		if(document != "NULL"){
			/*
			// Save temporary document
		   boolean changed = Data.FileData.Modified;
		   if(changed){
			   String temp_file = this.getCacheDir() + "/temp.bil";
			   Data.SaveToFile(false, temp_file);
		   }
		   outState.putBoolean("modified", changed);
			*/


			// Save active tab
			outState.putInt("tabindex", myTabHost.getCurrentTab());
	   }
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		if(! isFinishing())
			Data.database.close();	// close the database on orientation change
	}

	public void operation(int Op){
		int i;
		if(Op == 0 || Op > 2) return;
		giveDateTime();
		
		Bundle bundle = new Bundle();
		Intent intent = new Intent(this, operation.class);
		
		if(Op == 1){
			bundle.putBoolean("change_labels", false);
			if(Data.UpdateMatters(TData.TOpType.toGain)){
				bundle.putStringArrayList("matters", Data.MattersBuffer);
			}}
		else{
			bundle.putBoolean("change_labels", true);
			if(Data.UpdateMatters(TData.TOpType.toExpe)){
				bundle.putStringArrayList("matters", Data.MattersBuffer);
			}}
		
		// Parse funds
		ArrayList<String> funds = new ArrayList<String>();
		for(i = 0; i < Data.NFun /*- 1*/; i++)funds.add(Data.Funds.get(i).Name);
		bundle.putStringArrayList("funds", funds);
		
		// Default fund index
		for(i = 0; i < funds.size(); i++)if(funds.get(i).compareToIgnoreCase(Data.FileData.DefFund) == 0){
			bundle.putInt("defaultfundindex", i);
			break;}
		
		// Parse categories
		ArrayList<String> categories = new ArrayList<String>();
		categories.add("-");
		for(i = 0; i < /*Data.CategoryDB.size()*/Data.NCat; i++)categories.add(Data.CategoryDB.get(i).Name);
		bundle.putStringArrayList("categories", categories);
		
		intent.putExtras(bundle);
		
		if(Op == 1) startActivityForResult(intent, 1);
		else startActivityForResult(intent, 2);

	}

	public void profitClick(View view){
		operation(1);
	}
	
	public void expenseClick(View view){
		operation(2);
	}
	
	private void giveDateTime(){
	    int day = calendar.getDayOfMonth();
	    int month = calendar.getMonth();
	    int year =  calendar.getYear();
	    Data.Day.set(year, month, day, 0, 0, 0);
	}
	
	@Override
    public void onActivityResult(int requestCode,int resultCode, Intent data)
    {
		super.onActivityResult(requestCode, resultCode, data);
		if(resultCode != RESULT_OK) return;
		Bundle bundle = null;
		if(requestCode != 100) bundle = data.getExtras();
		
		int IDef = -1, IExi = -1;
		double value, Fon = -1, Def = -1, Val = -1, Tot1 = -1, Fou = -1;
		String obj, per;
		GregorianCalendar Alm;
		
		switch(requestCode){
			case 100:	// Browse document
				document = Opts.getString("GDDoc", "NULL");
				if(document != "NULL") openDocument();
				break;
	
			case 1:	// Gain
			case 2:	// Expense
				bil_library.appContext = getApplicationContext();
				
				int i;
				double Tot = -1;
				String Fund = null, OpValue;
				String SelFund = bundle.getString("fund");
				Val = bundle.getDouble("value");
				OpValue = bil_library.FormDigits(Val, true);
				for(i = 0; i < Data.NFun /*- 1*/; i++)if(Data.Funds.get(i).Name.compareToIgnoreCase(SelFund) == 0){
					Fund = Data.Funds.get(i).Name;
					Fon = Data.Funds.get(i).Value;
					break;}
				Tot = Data.GetTot(TData.TTypeVal.tvFou);
				if(Fon == -1 || Tot == -1){
					bil_library.Error(10, "");
					return;}
				switch(requestCode){
					case 1:
						//OpValue = bil_library.FormDigits(Val, false);
						Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toGain, OpValue,
							bundle.getString("matter"), (long) bundle.getInt("category"));
						for(i = 0; i < Data.NFun /*-1*/; i++)if(Data.Funds.get(i).Name.compareTo(Fund) == 0){
							Data.Funds.get(i).Value += Val;
							Data.changeFundValue(TData.TTypeVal.tvFou, Data.Funds.get(i).Id, Data.Funds.get(i).Value);
							break;}
						//Data.SetTot(TData.TTypeVal.tvFou, Data.GetTot(TData.TTypeVal.tvFou) + Val);
						break;
					case 2:
						if(Val > Fon){
							bil_library.Error(13, "");
							return;}
						//OpValue = bil_library.FormDigits(Val, false);
						String MatValue = bundle.getString("matter");
						Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toExpe, OpValue,
								MatValue, (long) bundle.getInt("category"));
						for(i = 0; i < Data.NFun /*-1*/; i++)if(Data.Funds.get(i).Name.compareTo(Fund) == 0){
							Data.Funds.get(i).Value -= Val;
							Data.changeFundValue(TData.TTypeVal.tvFou, Data.Funds.get(i).Id, Data.Funds.get(i).Value);
							break;}
						//Data.SetTot(TData.TTypeVal.tvFou, Data.GetTot(TData.TTypeVal.tvFou) - Val);
						if((Fon - Val == 0) && Fund != Data.FileData.DefFund){
							String Msg = String.format(getResources().getString(R.string.fund_exhaust), SelFund);
							tmp_string = Fund;
							
					 		AlertDialog.Builder alert = new AlertDialog.Builder(this);

							alert.setTitle(getResources().getString(R.string.app_name));
							alert.setMessage(Msg);

							// Set an EditText view to get user input 
							//final EditText input = new EditText(this);
							//input.setTransformationMethod(PasswordTransformationMethod.getInstance());
							//alert.setView(input);

							alert.setPositiveButton(getResources().getString(android.R.string.ok), new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog, int whichButton) {
									for(int i = 0;i < Data.NFun /*-1*/; i++)if(Data.Funds.get(i).Name.compareTo(/*Fund*/tmp_string) == 0){
										Data.delValue(TData.TTypeVal.tvFou, i);
										break;}
							  }
							});

							alert.setNegativeButton(getResources().getString(R.string.dialog_no), new DialogInterface.OnClickListener() {
							  public void onClick(DialogInterface dialog, int whichButton) {
							    // Canceled.
								//return false;
							  }
							});
							
							alert.show();

						}
						remove_obtained_shopitem(MatValue.toLowerCase());
				}
				showF();
				/*
				OperationEnd:
				delete OperationF;
				UpdateMenu();
				 */

				break;
			
			case 3: // Categories edited
				if(bundle.getBoolean("modified")){
					/*
					Data.FileData.Modified = true;
					*/

					ArrayList<String> CategoryList = bundle.getStringArrayList("categories");

					/*
					boolean exists;
					int x, E = -1;	// x: pointer in Data->Lines
								// E: pointer to existing value
					String value_string;

					// Check removed items
					for(i = Data.CategoryDB.size() - 1; i >= 0; i--){
						exists = false;
						value_string = Data.CategoryDB.get(i).Name;
						for (x = 0; x < CategoryList.size(); x++)if(value_string.compareTo(CategoryList.get(x)) == 0){
							exists = true;
							E = x;
							break;}
						if(exists){
							for(x = 0; x < Data.NLin; x++) if(Data.Lines.get(x).CategoryIndex == i)Data.Lines.get(x).CategoryIndex = E;}
						else{
							for(x = 0; x < Data.NLin; x++) if(Data.Lines.get(x).CategoryIndex == i)Data.Lines.get(x).CategoryIndex = -1;
							Data.CategoryDB.remove(i);}}

					// Check added items
					for(i = 0; i < CategoryList.size(); i++){
						exists = false;
						value_string = CategoryList.get(i);
						for(x = 0; x < Data.CategoryDB.size(); x++) if(value_string.compareTo(Data.CategoryDB.get(x).Name) == 0){
							exists = true;
							break;}
						if(! exists)Data.CategoryDB.add(value_string);}

					*/
					
					Data.updateCategories(CategoryList);
					
					Data.FileData.Modified = true;
					showF();					
				}
				break;
			
			case 4:  // Add fund
				//int Ch = 0;
				Def = 0;
				String fund = bundle.getString("fund");
				value = bundle.getDouble("value");
				
				Tot = Data.GetTot(TData.TTypeVal.tvFou);
				for(i = 0; i < Data.NFun /*- 1*/; i++)if(Data.Funds.get(i).Name.compareToIgnoreCase(fund) == 0){
					//Fon = Data.Funds.get(i).Value;
					bil_library.Error(11, fund);
					//Ch=1;
					return;
				}
				else if(Data.Funds.get(i).Name.compareToIgnoreCase(Data.FileData.DefFund) == 0)Def = Data.Funds.get(i).Value;

				if(value > Def){
					bil_library.Error(12, "");
					return;}

				Data.setDefaultFundValue(Def - value);

				if(! Data.addValue(TData.TTypeVal.tvFou, -1, fund, value)){
					bil_library.Error(10, "");
					return;}
				showF();
				break;
				
			case 5:	// add credit
				String credit = bundle.getString("credit");
				Val = bundle.getDouble("value");
				for(i = 0; i < Data.NFun /*-1*/; i++)
					if(Data.Funds.get(i).Name.compareToIgnoreCase(Data.FileData.DefFund) == 0){
						IDef = i;
						Def = Data.Funds.get(i).Value;
						break;}
				Tot = Data.GetTot(TData.TTypeVal.tvFou);
				Tot1 = Data.GetTot(TData.TTypeVal.tvCre);
				if((Def == -1) || (Tot == -1) || (Tot1 == -1)){
					bil_library.Error(18, "");
					return;}
				if(Def < Val){
					bil_library.Error(19, "");
					return;}
				Data.addValue(TData.TTypeVal.tvCre, -1, credit, Val);
				Data.setDefaultFundValue(Data.Funds.get(IDef).Value - Val);
				//Data.SetTot(TData.TTypeVal.tvFou, Data.GetTot(TData.TTypeVal.tvFou) - Val);
				/*
				if(SCredDeb->SysTimeCheckhttp://stackoverflow.com/questions/10600670/sqlitedatabase-query-method->IsChecked())S=wxDateTime(bilGetTime());
				else S=Data->Hour;
				*/
				Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toSetCre, bil_library.FormDigits(Val, true), credit, -1);
				showF();
				/*
				UpdateMenu();
				EndNewCredit1Click:delete SCredDeb;
				*/
				break;
			
			case 6:	// remove credit
				for(i = 0; i < Data.NFun /*-1*/; i++)
					if(Data.Funds.get(i).Name.compareToIgnoreCase(Data.FileData.DefFund) == 0){
						IDef = i;
						Def = Data.Funds.get(i).Value;
						break;}
				Tot = Data.GetTot(TData.TTypeVal.tvFou);
				for(i = 0; i < Data.NCre /*-1*/; i++)
					if(Data.Credits.get(i).Name.compareToIgnoreCase(Data.Credits.get(credit_pos).Name) == 0){
						IExi = /*i*/ Data.Credits.get(i).Id;
						Fou = Data.Credits.get(i).Value;
						break;}
				Tot1 = Data.GetTot(TData.TTypeVal.tvCre);
				if((Def == -1) || (Tot == -1) || (Fou == -1) || (Tot1 == -1)){
					bil_library.Error(18, "");
					return;}
				if(bundle.getBoolean("total")){
					Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toRemCre, bil_library.FormDigits(Fou, true), Data.Credits.get(credit_pos).Name, -1);
					Data.delValue(TData.TTypeVal.tvCre, IExi);
					Data.setDefaultFundValue(Data.Funds.get(IDef).Value + Fou);
					//Data.SetTot(TData.TTypeVal.tvFou, Data.GetTot(TData.TTypeVal.tvFou) + Fou);
				}
				else{
					double Par = bundle.getDouble("value");
					if(Par > Fou){
						bil_library.Error(21, getResources().getString(R.string.credit_term));
						return;}
					Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toRemCre, bil_library.FormDigits(Par, true), Data.Credits.get(credit_pos).Name, -1);
					//Data.Credits.get(IExi).Value -= Par;

					/*
					ContentValues cv = new ContentValues();
					cv.put("value", Fou - Par);
					Data.database.update("Credits", cv, "id = " + String.format("%d", IExi), null);
					*/
					Data.changeFundValue(TData.TTypeVal.tvCre, IExi, Fou - Par);

					//Data.SetTot(TData.TTypeVal.tvCre, Data.GetTot(TData.TTypeVal.tvCre) - Par);
					Data.setDefaultFundValue(Data.Funds.get(IDef).Value + Par);
					//Data.SetTot(TData.TTypeVal.tvFou, Data.GetTot(TData.TTypeVal.tvFou) + Par);
					Data.parseDatabase();
				}
				showF();
				/*
				UpdateMenu();http://stackoverflow.com/questions/10600670/sqlitedatabase-query-method
				EndRemoveCredit1Click:
				delete RCredDeb;
				*/
				break;
				
			case 7:	// Condone credit
				int ICre = -1;
				double Cre = -1;
				for(i = 0; i < Data.NCre /*-1*/; i++)
					if(Data.Credits.get(i).Name.compareToIgnoreCase(Data.Credits.get(credit_pos).Name) == 0){
						ICre = /*i*/ Data.Credits.get(i).Id;
						Cre = Data.Credits.get(i).Value;
						break;}
				Tot = Data.GetTot(TData.TTypeVal.tvCre);
				if(Cre == -1 || Tot == -1){
					bil_library.Error(10, "");
					return;}
				if(bundle.getBoolean("total")){
					Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toConCre, bil_library.FormDigits(Cre, true), Data.Credits.get(credit_pos).Name, -1);
					Data.delValue(TData.TTypeVal.tvCre, ICre);}
				else{
					double Par = bundle.getDouble("value");
					if(Par > Cre){
						bil_library.Error(21, getResources().getString(R.string.credit_term));
						return;}
					Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toConCre, bil_library.FormDigits(Par, true), Data.Credits.get(credit_pos).Name, -1);
					//Data.Credits.get(ICre).Value -= Par;

					/*
					ContentValues cv = new ContentValues();
					cv.put("value", Cre - Par);
					Data.database.update("Credits", cv, "id = " + String.format("%d", ICre), null);
					*/
					Data.changeFundValue(TData.TTypeVal.tvCre, ICre, Cre - Par);

					//Data.SetTot(TData.TTypeVal.tvCre, Data.GetTot(TData.TTypeVal.tvCre) - Par);
					Data.parseDatabase();
				}
				showF();
				/*
				UpdateMenu();
				EndCondoneCredit1Click:
				delete RCredDeb;
				*/
				break;
				
			case 8:	// add debt
				String debt = bundle.getString("debt");
				Val = bundle.getDouble("value");
				for(i = 0; i < Data.NFun /*-1*/; i++)
					if(Data.Funds.get(i).Name.compareToIgnoreCase(Data.FileData.DefFund) == 0){
						IDef = i;
						Def = Data.Funds.get(i).Value;
						break;}
				Tot = Data.GetTot(TData.TTypeVal.tvFou);
				Tot1 = Data.GetTot(TData.TTypeVal.tvDeb);
				if((Def == -1) || (Tot == -1) || (Tot1 == -1)){
					bil_library.Error(18, "");
					return;}
				/*
				if(Def < Val){
					bil_library.Error(19, "");
					return;}
				*/
				Data.addValue(TData.TTypeVal.tvDeb, -1, debt, Val);
				Data.setDefaultFundValue(Data.Funds.get(IDef).Value + Val);
				//Data.SetTot(TData.TTypeVal.tvFou, Data.GetTot(TData.TTypeVal.tvFou) + Val);
				Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toSetDeb, bil_library.FormDigits(Val, true), debt, -1);
				showF();
				break;
			
			case 9:	// remove debt
				for(i = 0; i < Data.NFun /*-1*/; i++)
					if(Data.Funds.get(i).Name.compareToIgnoreCase(Data.FileData.DefFund) == 0){
						IDef = i;
						Def = Data.Funds.get(i).Value;
						break;}
				Tot = Data.GetTot(TData.TTypeVal.tvFou);
				for(i = 0; i < Data.NDeb /*-1*/; i++)
					if(Data.Debts.get(i).Name.compareToIgnoreCase(Data.Debts.get(debt_pos).Name) == 0){
						IExi = /*i*/ Data.Debts.get(i).Id;
						Fou = Data.Debts.get(i).Value;
						break;}
				Tot1 = Data.GetTot(TData.TTypeVal.tvDeb);
				if((Def == -1) || (Tot == -1) || (Fou == -1) || (Tot1 == -1)){
					bil_library.Error(18, "");
					return;}
				if(bundle.getBoolean("total")){
				    if(Fou > Def){
						bil_library.Error(24, "");
						return;}
				    Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toRemDeb, bil_library.FormDigits(Fou, true), Data.Debts.get(debt_pos).Name, -1);
					Data.delValue(TData.TTypeVal.tvDeb, IExi);
					Data.setDefaultFundValue(Data.Funds.get(IDef).Value - Fou);
					//Data.SetTot(TData.TTypeVal.tvFou, Data.GetTot(TData.TTypeVal.tvFou) - Fou);
				}
				else{
					double Par = bundle.getDouble("value");
					if(Par > Fou){
						bil_library.Error(21, getResources().getString(R.string.debt_term));
						return;}
					if(Par > Def){
						bil_library.Error(24, "");
						return;}
					Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toRemDeb, bil_library.FormDigits(Par, true), Data.Debts.get(debt_pos).Name, -1);
					//Data.Debts.get(IExi).Value -= Par;

					/*
					ContentValues cv = new ContentValues();
					cv.put("value", Fou - Par);
					Data.database.update("Debts", cv, "id = " + String.format("%d", IExi), null);
					*/
					Data.changeFundValue(TData.TTypeVal.tvDeb, IExi, Fou - Par);

					//Data.SetTot(TData.TTypeVal.tvDeb, Data.GetTot(TData.TTypeVal.tvDeb) - Par);
					Data.setDefaultFundValue(Data.Funds.get(IDef).Value - Par);
					//Data.SetTot(TData.TTypeVal.tvFou, Data.GetTot(TData.TTypeVal.tvFou) - Par);
					Data.parseDatabase();
				}
				showF();
				break;
				
			case 10:	// Condone debt
				int IDeb = -1;
				double Deb = -1;
				for(i = 0; i < Data.NDeb /*-1*/; i++)
					if(Data.Debts.get(i).Name.compareToIgnoreCase(Data.Debts.get(debt_pos).Name) == 0){
						IDeb = /*i*/ Data.Debts.get(i).Id;
						Deb = Data.Debts.get(i).Value;
						break;}
				Tot = Data.GetTot(TData.TTypeVal.tvDeb);
				if(Deb == -1 || Tot == -1){
					bil_library.Error(10, "");
					return;}
				if(bundle.getBoolean("total")){
					Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toConDeb, bil_library.FormDigits(Deb, true), Data.Debts.get(debt_pos).Name, -1);
					Data.delValue(TData.TTypeVal.tvDeb, IDeb);}
				else{
					double Par = bundle.getDouble("value");
					if(Par > Deb){
						bil_library.Error(21, getResources().getString(R.string.debt_term));
						return;}
					Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toConDeb, bil_library.FormDigits(Par, true), Data.Debts.get(debt_pos).Name, -1);
					//Data.Debts.get(IDeb).Value -= Par;

					/*
					ContentValues cv = new ContentValues();
					cv.put("value", Deb - Par);
					Data.database.update("Debts", cv, "id = " + String.format("%d", IDeb), null);
					*/
					Data.changeFundValue(TData.TTypeVal.tvDeb, IDeb, Deb - Par);

					//Data.SetTot(TData.TTypeVal.tvDeb, Data.GetTot(TData.TTypeVal.tvDeb) - Par);
					Data.parseDatabase();
				}
				showF();
				break;
				
			case 11:	// Get object
				obj = bundle.getString("object");
				Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toGetObj, obj, bundle.getString("person"), -1);
				
				remove_obtained_shopitem(obj.toLowerCase());
				Data.parseDatabase();
				showF();
				break;
			
			case 12:	// Give object
				obj = bundle.getString("object");
				Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toGivObj, obj, bundle.getString("person"), -1);
				Data.parseDatabase();
				showF();
				break;
			
			case 13:	// Lend object
				obj = bundle.getString("object");
				per = bundle.getString("person");
				Alm = (GregorianCalendar) GregorianCalendar.getInstance();
				Alm.set(bundle.getInt("year"), bundle.getInt("month"), bundle.getInt("day"));
				Data.addObject(TData.TObjType.toPre, -1, per, obj, Alm);
				Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toLenObj, obj, per, -1);
				//Data.parseDatabase();
				showF();
				break;

			case 14:	// Borrow object
				obj = bundle.getString("object");
				per = bundle.getString("person");
				Alm = (GregorianCalendar) GregorianCalendar.getInstance();
				Alm.set(bundle.getInt("year"), bundle.getInt("month"), bundle.getInt("day"));
				Data.addObject(TData.TObjType.toInP, -1, per, obj, Alm);
				Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toBorObj, obj, per, -1);
				//Data.parseDatabase();
				showF();
				break;

			case 15:	// Add shop item
				obj = bundle.getString("object");
				boolean item_new = true;
				for(i = 0; i < Data.NSho; i++){
					if(Data.ShopItems.get(i).Name.compareToIgnoreCase(obj) == 0){
						bil_library.Error(48, obj);
						item_new = false;
						break;
					}
				}
				if(item_new){
					Alm = (GregorianCalendar) GregorianCalendar.getInstance();
					Alm.set(bundle.getInt("year"), bundle.getInt("month"), bundle.getInt("day"));
					Data.addShopItem(-1, obj, Alm);
					showF();}
				break;
				
			default:
		}

    }

	private void showF(){

		// lock orientation if needed to avoid change loss in the database
		// TODO (igor#1#): rework for tablets which have different natural orientation
		if(Data.FileData.Modified) {
			int orientation = this.getRequestedOrientation();
			int rotation = ((WindowManager) this.getSystemService(
					Context.WINDOW_SERVICE)).getDefaultDisplay().getRotation();
			switch (rotation) {
				case Surface.ROTATION_90:
					orientation = ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE;
					break;
				case Surface.ROTATION_180:
					orientation = ActivityInfo.SCREEN_ORIENTATION_REVERSE_PORTRAIT;
					break;
				case Surface.ROTATION_270:
					orientation = ActivityInfo.SCREEN_ORIENTATION_REVERSE_LANDSCAPE;
					break;
				default:
					orientation = ActivityInfo.SCREEN_ORIENTATION_PORTRAIT;
					break;
			}

			this.setRequestedOrientation(orientation);
		}
		else this.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_UNSPECIFIED);

		double val;
	    String str_tmp;
	    Currency curr = Currency.getInstance(Locale.getDefault());
	    TextView total_view;
	    // Funds tab
	    // Find the ListView resource.   
	    fundView = (ListView) findViewById( R.id.FundView );
	    
	    fundList = new ArrayList<String>();
	    //fundList.addAll(Arrays.asList(test));
	    for(int i = 0; i < Data.NFun; i++){
	    	str_tmp = Data.Funds.get(i).Name + /*" ( "*/ "<br><small>" + curr.getSymbol(/*Locale.getDefault()*/) + " ";
	    	str_tmp += bil_library.FormDigits(Data.Funds.get(i).Value, false) + "</small>";
	    	//str_tmp += " )";
	    	fundList.add(str_tmp);
	    }
	    // Create ArrayAdapter  
	    fundAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_single_choice, fundList)
	    {
		    @Override
		    public View getView(int position, View convertView, ViewGroup parent) {
		        TextView textView = (TextView) super.getView(position, convertView, parent);
				if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.N)
		        	textView.setText(Html.fromHtml(textView.getText().toString(), Html.FROM_HTML_MODE_COMPACT));
				else textView.setText(Html.fromHtml(textView.getText().toString()));
		        return textView;
		    }
		};
        // Set the ArrayAdapter as the ListView's adapter.  
	    fundView.setAdapter( fundAdapter );
	    total_view = (TextView) findViewById(R.id.total_fund);
	    str_tmp = getResources().getString(R.string.total) + "<br><small>" + curr.getSymbol() + " ";
	    str_tmp += bil_library.FormDigits(Data.Tot_Funds, false) + "</small>";
		if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.N)
	    	total_view.setText(Html.fromHtml(str_tmp, Html.FROM_HTML_MODE_COMPACT));
		else total_view.setText(Html.fromHtml(str_tmp));
	    
	    fundView.setOnItemClickListener(new OnItemClickListener() {
	        @Override
	        public void onItemClick(AdapterView<?> adapter, View arg1, int position, long arg3) {
	        	boolean enabled = true;
	        	if(position >= 0){
	        		if(Data.Funds.get(position).Name.compareToIgnoreCase(Data.FileData.DefFund) == 0)enabled = false;
	        	}
	        	btn_removeFund.setEnabled(enabled);
	        	btn_editFund.setEnabled(enabled);
	        	if(position >= 0) fund_pos = position;
	        }
	    });

		// Credits tab
	    // Find the ListView resource.   
	    creditView = (ListView) findViewById( R.id.CreditView ); 
	    ArrayList<String> creditList = new ArrayList<String>();
	    for(int i = 0; i < Data.NCre; i++){
	    	str_tmp = Data.Credits.get(i).Name + /*" ( "*/ "<br><small>" + curr.getSymbol() + " ";
	    	str_tmp += bil_library.FormDigits(Data.Credits.get(i).Value, false) + "</small>";
	    	//str_tmp += " )";
	    	creditList.add(str_tmp);
	    }
	    // Create ArrayAdapter  
	    creditAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_single_choice, creditList)
	    {
		    @Override
		    public View getView(int position, View convertView, ViewGroup parent) {
		        TextView textView = (TextView) super.getView(position, convertView, parent);
				if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.N)
		        	textView.setText(Html.fromHtml(textView.getText().toString(), Html.FROM_HTML_MODE_COMPACT));
				else textView.setText(Html.fromHtml(textView.getText().toString()));
		        return textView;
		    }
		};
	    // Set the ArrayAdapter as the ListView's adapter.  
	    creditView.setAdapter( creditAdapter );
	    total_view = (TextView) findViewById(R.id.total_credit);
	    str_tmp = getResources().getString(R.string.total) + "<br><small>" + curr.getSymbol() + " ";
	    str_tmp += bil_library.FormDigits(Data.Tot_Credits, false) + "</small>";
		if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.N)
	    	total_view.setText(Html.fromHtml(str_tmp, Html.FROM_HTML_MODE_COMPACT));
		else total_view.setText(Html.fromHtml(str_tmp));
	    if(creditView.getCount() < 1){
        	btn_removeCredit.setEnabled(false);
        	btn_condoneCredit.setEnabled(false);}

	    creditView.setOnItemClickListener(new OnItemClickListener() {
	        @Override
	        public void onItemClick(AdapterView<?> adapter, View arg1, int position, long arg3) {
	        	boolean enabled = (position >= 0);
	        	btn_removeCredit.setEnabled(enabled);
	        	btn_condoneCredit.setEnabled(enabled);
	        	if(position >= 0) credit_pos = position;
	        }
	    });

	    // Debts tab
	    // Find the ListView resource.   
	    debtView = (ListView) findViewById( R.id.DebtView ); 
	    ArrayList<String> debtList = new ArrayList<String>();
	    for(int i = 0; i < Data.NDeb; i++){
	    	str_tmp = Data.Debts.get(i).Name + /*" ( "*/ "<br><small>" + curr.getSymbol() + " ";
	    	str_tmp += bil_library.FormDigits(Data.Debts.get(i).Value, false) + "</small>";
	    	//str_tmp += " )";
	    	debtList.add(str_tmp);
	    }
	    // Create ArrayAdapter  
	    debtAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_single_choice, debtList)
	    {
		    @Override
		    public View getView(int position, View convertView, ViewGroup parent) {
		        TextView textView = (TextView) super.getView(position, convertView, parent);
				if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.N)
		        	textView.setText(Html.fromHtml(textView.getText().toString(), Html.FROM_HTML_MODE_COMPACT));
				else textView.setText(Html.fromHtml(textView.getText().toString()));
		        return textView;
		    }
		};
	    // Set the ArrayAdapter as the ListView's adapter.  
	    debtView.setAdapter( debtAdapter );
	    total_view = (TextView) findViewById(R.id.total_debt);
	    str_tmp = getResources().getString(R.string.total) + "<br><small>" + curr.getSymbol() + " ";
	    str_tmp += bil_library.FormDigits(Data.Tot_Debts, false) + "</small>";
		if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.N)
	    	total_view.setText(Html.fromHtml(str_tmp, Html.FROM_HTML_MODE_COMPACT));
		else total_view.setText(Html.fromHtml(str_tmp));
	    if(debtView.getCount() < 1){
        	btn_removeDebt.setEnabled(false);
        	btn_condoneDebt.setEnabled(false);}
	    
	    debtView.setOnItemClickListener(new OnItemClickListener() {
	        @Override
	        public void onItemClick(AdapterView<?> adapter, View arg1, int position, long arg3) {
	        	boolean enabled = (position >= 0);
	        	btn_removeDebt.setEnabled(enabled);
	        	btn_condoneDebt.setEnabled(enabled);
	        	if(position >= 0) debt_pos = position;
	        }
	    });

	    // Objects tab
	    // Find the Lent ListView resource.   
	    lentView = (ListView) findViewById( R.id.LentView ); 
	    ArrayList<String> lentList = new ArrayList<String>();
	    for(int i = 0; i < Data.NLen; i++){
	    	str_tmp = Data.Lent.get(i).Object + "<br><small>" + Data.Lent.get(i).Name + "</small>";
	    	//str_tmp += bil_library.FormDigits(Data.Debts.get(i).Value);
	    	//str_tmp += " )";
	    	lentList.add(str_tmp);
	    }
	    // Create ArrayAdapter  
	    lentAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_single_choice, lentList)
	    {
		    @Override
		    public View getView(int position, View convertView, ViewGroup parent) {
		        TextView textView = (TextView) super.getView(position, convertView, parent);
				if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.N)
					textView.setText(Html.fromHtml(textView.getText().toString(), Html.FROM_HTML_MODE_COMPACT));
				else textView.setText(Html.fromHtml(textView.getText().toString()));
		        return textView;
		    }
		};
	    // Set the ArrayAdapter as the ListView's adapter.  
	    lentView.setAdapter( lentAdapter );
	    if(lentView.getCount() < 1){
        	btn_getbackObj.setEnabled(false);}
	    
	    lentView.setOnItemClickListener(new OnItemClickListener() {
	        @Override
	        public void onItemClick(AdapterView<?> adapter, View arg1, int position, long arg3) {
	        	boolean enabled = (position >= 0);
	        	btn_getbackObj.setEnabled(enabled);
	        	if(position >= 0) lent_pos = position;
	        }
	    });

	    // Find the Borrowed ListView resource.   
	    borrowedView = (ListView) findViewById( R.id.BorrowedView ); 
	    ArrayList<String> borrowedList = new ArrayList<String>();
	    for(int i = 0; i < Data.NBor; i++){
	    	str_tmp = Data.Borrowed.get(i).Object + "<br><small>" + Data.Borrowed.get(i).Name + "</small>";
	    	borrowedList.add(str_tmp);
	    }
	    // Create ArrayAdapter  
	    borrowedAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_single_choice, borrowedList)
	    {
		    @Override
		    public View getView(int position, View convertView, ViewGroup parent) {
		        TextView textView = (TextView) super.getView(position, convertView, parent);
				if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.N)
		        	textView.setText(Html.fromHtml(textView.getText().toString(), Html.FROM_HTML_MODE_COMPACT));
				else textView.setText(Html.fromHtml(textView.getText().toString()));
		        return textView;
		    }
		};
	    // Set the ArrayAdapter as the ListView's adapter.  
	    borrowedView.setAdapter( borrowedAdapter );
	    if(borrowedView.getCount() < 1){
        	btn_givebackObj.setEnabled(false);}
	    
	    borrowedView.setOnItemClickListener(new OnItemClickListener() {
	        @Override
	        public void onItemClick(AdapterView<?> adapter, View arg1, int position, long arg3) {
	        	boolean enabled = (position >= 0);
	        	btn_givebackObj.setEnabled(enabled);
	        	if(position >= 0) borrowed_pos = position;
	        }
	    });

		// Report
		operations.clear();
		int last_date_index = Data.NLin;
		for(int i = Data.NLin - 1; i >= 0 ; i--) {
			while (!Data.Lines.get(i).IsDate) i--;

			val = Double.parseDouble(Data.Lines.get(i).Value);
			operations.add(new lines_wrapper(0, curr.getSymbol() + " " + bil_library.FormDigits(val, false), "",
					bil_library.Bil_DateToStr(Data.Lines.get(i).Date), "", -1));

			for (int j = i + 1; j < last_date_index; j++) {
				int type;
				int opType = -1;
				String val_string;
				String cat_string;
				switch (Data.Lines.get(j).Type) {
					case toGain:
						type = 1;
						opType = R.drawable.greenplus;
						break;
					case toExpe:
						type = 2;
						opType = R.drawable.redminus;
						break;
					case toSetCre:
						type = 3;
						opType = R.drawable.creditnew;
						break;
					case toRemCre:
						type = 4;
						opType = R.drawable.creditremove;
						break;
					case toConCre:
						type = 5;
						opType = R.drawable.creditcondone;
						break;
					case toSetDeb:
						type = 6;
						opType = R.drawable.debitnew;
						break;
					case toRemDeb:
						type = 7;
						opType = R.drawable.debitremove;
						break;
					case toConDeb:
						type = 8;
						opType = R.drawable.debitcondone;
						break;
					case toGetObj:
						type = 9;
						opType = R.drawable.object_received;
						break;
					case toGivObj:
						type = 10;
						opType = R.drawable.object_given;
						break;
					case toLenObj:
						type = 11;
						opType = R.drawable.object_lent;
						break;
					case toBakObj:
						type = 12;
						opType = R.drawable.object_getback;
						break;
					case toBorObj:
						type = 13;
						opType = R.drawable.object_borrow;
						break;
					case toRetObj:
						type = 14;
						opType = R.drawable.object_giveback;
						break;
					default:
						type = -1;
				}
				if (type < 9) {
					val = Double.parseDouble(Data.Lines.get(j).Value);
					val_string = curr.getSymbol() + " " + bil_library.FormDigits(val, false);
				} else val_string = Data.Lines.get(j).Value;
				if (Data.Lines.get(j).CategoryIndex > 0)
					cat_string = Data.CategoryDB.get((int) Data.Lines.get(j).CategoryIndex - 1).Name;
				else cat_string = "";

				operations.add(new lines_wrapper(1, val_string, Data.Lines.get(j).Reason,
						bil_library.Bil_TimeToStr(Data.Lines.get(j).Time, false), cat_string, opType));

			}

			last_date_index = i;

		}

		// Shoplist tab
		int thisYear, alarmYear;
		thisYear = Calendar.getInstance().get(Calendar.YEAR);
		GregorianCalendar alarmCalendar;
		
	    // Find the ListView resource.   
	    shopView = (ListView) findViewById( R.id.ShopView ); 
	    ArrayList<String> shopList = new ArrayList<String>();
	    for(int i = 0; i < Data.NSho; i++){
	    	alarmCalendar = Data.ShopItems.get(i).Alarm;
	    	alarmYear = alarmCalendar.get(Calendar.YEAR);
	    	str_tmp = Data.ShopItems.get(i).Name + "<br><small>";
	    	if((alarmYear - thisYear) < 80) str_tmp +=  bil_library.Bil_DateToStr(alarmCalendar);
	    	else str_tmp += getResources().getString(R.string.alarm_none);
	    	str_tmp += "</small>";
	    	shopList.add(str_tmp);
	    }
	    // Create ArrayAdapter  
	    shopAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_single_choice, shopList)
	    {
		    @Override
		    public View getView(int position, View convertView, ViewGroup parent) {
		        TextView textView = (TextView) super.getView(position, convertView, parent);
				if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.N)
					textView.setText(Html.fromHtml(textView.getText().toString(), Html.FROM_HTML_MODE_COMPACT));
				else textView.setText(Html.fromHtml(textView.getText().toString()));
		        return textView;
		    }
		};
	    // Set the ArrayAdapter as the ListView's adapter.  
	    shopView.setAdapter( shopAdapter );
	    if(shopView.getCount() < 1){
        	btn_delShop.setEnabled(false);}
	    
	    shopView.setOnItemClickListener(new OnItemClickListener() {
	        @Override
	        public void onItemClick(AdapterView<?> adapter, View arg1, int position, long arg3) {
	        	boolean enabled = (position >= 0);
	        	btn_delShop.setEnabled(enabled);
	        	if(position >= 0) shop_pos = position;
	        }
	    });
		
		/*
		TrendChart->Show(ShowTrendChart());
		FundChart->Show(ShowFundChart());
		if(TrendChart->IsShown()||FundChart->IsShown())*/paintChart();
		
		int prevTab = myTabHost.getCurrentTab();
		myTabHost.setCurrentTab(CHART_TAB);
		myTabHost.invalidate();
		myTabHost.setCurrentTab(prevTab);
		myTabHost.invalidate();
	}

	public void EditCategoriesClick(){
		/*
		int i;
		String curstr, SelFund, OpValue, MatValue;
		String Fund;
		double Fon = -1, Tot = -1, Val;
		giveDateTime();
		*/
		
		Bundle bundle = new Bundle();
		
		Intent intent = new Intent(this, editcategories.class);
		
		ArrayList<String> cats = new ArrayList<String>();
		cats.clear();
		for(int i = 0; i < Data.NCat; i++) cats.add(Data.CategoryDB.get(i).Name);
		bundle.putStringArrayList("categories", /*Data.CategoryDB*/ cats);
		
		intent.putExtras(bundle);
		
		startActivityForResult(intent, 3);

	}

	public void FundOperation(int Op){
		if(Op == 0 || Op > 3) return;
		int i /*, Ch=0*/;
		//int j;
		double /*Def = -1, Tot = -1, NFun,*/ Fon = -1;
		if(Op > 1 && Data.NFun /*- 1*/ < 2){
			if(Op == 2) bil_library.Error(8, null);
			else bil_library.Error(9, null);
			return;}

		switch(Op){
		case 1:
			//Bundle bundle = new Bundle();
			Intent intent = new Intent(this, fund_add.class);
			startActivityForResult(intent, 4);
			break;
		case 2:
			Fon = Data.Funds.get(fund_pos).Value;
			int id = Data.Funds.get(fund_pos).Id;
			
			for(i = 0; i < Data.NFun; i++)if(Data.Funds.get(i).Name.compareToIgnoreCase(Data.FileData.DefFund) == 0){
				Data.setDefaultFundValue(Data.Funds.get(i).Value + Fon);
				break;}

			//for(i=0;i<Data->NFun-1;i++)if(Data->Funds[i].Name.CmpNoCase(OPF->Name->GetValue())==0){
			Data.delValue(TData.TTypeVal.tvFou, /*fund_pos*/id);
			
			/*
			Data.SetTot(TData.TTypeVal.tvFou, Data.GetTot(TData.TTypeVal.tvFou) + Fon);
			//	break;}
			fundList.remove(fund_pos);
			fundAdapter.notifyDataSetChanged();
			Data.FileData.Modified = true;
			*/
			showF();
			break;
		case 3:
			AlertDialog.Builder alert = new AlertDialog.Builder(this);
			alert.setTitle(getResources().getString(R.string.app_name));
			alert.setMessage(String.format(this.getResources().getString(R.string.fund_reset),
					Data.Funds.get(fund_pos).Name));

			// Set an EditText view to get user input 
			final EditText input = new EditText(this);
			input.setKeyListener(new DigitsKeyListener(false, true));
			input.setText(bil_library.FormDigits(Data.Funds.get(fund_pos).Value, true));
			alert.setView(input);

			alert.setPositiveButton(getResources().getString(android.R.string.ok), new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int whichButton) {
					
					/*
					String value = input.getText().toString();
					if(!value.isEmpty()){
						value = bil_library.iUpperCase(value);
						boolean Ex = false;
						for(int i = 0; i < categoryList.size(); i++){
							if(categoryList.get(i).compareTo(value) == 0){
								Ex = true;
								break;}}
						if(!Ex){
							categoryList.add(value);
							modified = true;}}
					*/
					
					double Fon = Data.Funds.get(fund_pos).Value;
					double NFun = Double.parseDouble(input.getText().toString());
					double Tot = Data.GetTot(TData.TTypeVal.tvFou);
					
					for(int i = 0; i < Data.NFun /*- 1*/; i++)if(Data.Funds.get(i).Name.compareToIgnoreCase(Data.FileData.DefFund) == 0){
						double Def = Data.Funds.get(i).Value;
						if(NFun < Fon){
							//Data.Funds.get(i).Value = Def + Fon - NFun;
							Data.setDefaultFundValue(Def + Fon - NFun);
						}
						else{
							if(Tot < (NFun - Fon)){
								bil_library.Error(13, "");
								return;}
							if(Def < (NFun - Fon)){
								bil_library.Error(24, "");
								return;}
		                    //Data.Funds.get(i).Value = Def - NFun + Fon;
							Data.setDefaultFundValue(Def - NFun + Fon);
						}}
					//else if(Data.Funds.get(i).Name.compareToIgnoreCase(fundView.getItemAtPosition(fund_pos).toString()) == 0)
					else if(i == fund_pos) {
						Data.Funds.get(i).Value = NFun;
						Data.changeFundValue(TData.TTypeVal.tvFou, Data.Funds.get(i).Id, Data.Funds.get(i).Value);
					}
					Data.FileData.Modified = true;
					showF();
				}
			});

			alert.setNegativeButton(getResources().getString(R.string.dialog_cancel), new DialogInterface.OnClickListener() {
			  public void onClick(DialogInterface dialog, int whichButton) {
			    // Canceled.
				//return false;
			  }
			});
			
			alert.show();
			//if(Data.FileData.Modified) ShowF();
			
			break;
		}
		
		/*
		TOPF *OPF=new TOPF(this);
		OPF->InitLabels(Op+1);
		if(Op>1){
			for(i=0;i<Data->NFun-1;i++)if(Data->Funds[i].Name!=Data->FileData.DefFund)
				OPF->Name->Append(Data->Funds[i].Name);
			if(Op==3)
				for(j=0;j<OPF->Name->GetCount();j++)
					for(int k=0;k<Data->NFun-1;k++)
						if(OPF->Name->GetString(j)==Data->Funds[k].Name){
						  OPF->AddValue(FormDigits(Data->Funds[k].Value));
							break;}
			OPF->Name->Select(0);
			wxCommandEvent evt(wxEVT_NULL,0);
			if(Op==3)OPF->NameChange(evt);}
		*/

		/*
		if(OPF->ShowModal()!=wxID_OK)goto FundOperationEnd;
		if(Op!=2)OPF->Val->GetValue().ToDouble(&NFun);
		switch(Op){
			case 2:
				break;
			case 3:
}
		FundOperationEnd:
		delete OPF;
		UpdateMenu();
		*/
	}

	public void NewFundClick(View view){
		FundOperation(1);}

	public void RemoveFundClick(View view){
		FundOperation(2);}

	public void ResetFundClick(View view){
		FundOperation(3);}

	public void SetTotalClick(){
		/*
		if(OldTot == -1){ // This condition should never happen
			bil_library.Error(6, "");
			return;}
		*/
		
		AlertDialog.Builder alert = new AlertDialog.Builder(this);
		alert.setTitle(getResources().getString(R.string.app_name));
		alert.setMessage(this.getResources().getString(R.string.fund_settotal));

		// Set an EditText view to get user input 
		final EditText input = new EditText(this);
		input.setKeyListener(new DigitsKeyListener(false, true));
		input.setText(bil_library.FormDigits(Data.GetTot(TData.TTypeVal.tvFou), true));
		alert.setView(input);

		alert.setPositiveButton(getResources().getString(android.R.string.ok), new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int whichButton) {
				
				/*
				double Fon = Data.Funds.get(fund_pos).Value;
				double NFun = Double.parseDouble(input.getText().toString());
				double Tot = Data.GetTot(Data.typeVal.tvFou);
				
				for(int i = 0; i < Data.NFun - 1; i++)if(Data.Funds.get(i).Name.compareToIgnoreCase(Data.FileData.DefFund) == 0){
					double Def = Data.Funds.get(i).Value;
					if(NFun < Fon){
						Data.Funds.get(i).Value = Def + Fon - NFun;
					}
					else{
						if(Tot < (NFun - Fon)){
							bil_library.Error(13, "");
							return;
							//goto FundOperationEnd;
						}
	                    Data.Funds.get(i).Value = Def - NFun + Fon;}}
				//else if(Data.Funds.get(i).Name.compareToIgnoreCase(fundView.getItemAtPosition(fund_pos).toString()) == 0)
				else if(i == fund_pos) Data.Funds.get(i).Value = NFun;
				Data.FileData.Modified = true;
				ShowF();
				*/

				int i, IP = -1;
				double OldTot, Tot, Pre = -1;	// OldTot: previous total value
				// Tot: new total value
				// Pre: Default fund value
				OldTot = Data.GetTot(TData.TTypeVal.tvFou);
				String curstr = input.getText().toString();
				Tot = Double.parseDouble(curstr);
				
				bil_library.appContext = getApplicationContext();
				
				if(OldTot > Tot){
					bil_library.Error(17, "");
					return;}
				for(i = 0; i < Data.NFun /*- 1*/; i++)if(Data.Funds.get(i).Name.compareToIgnoreCase(Data.FileData.DefFund) == 0){
					Pre = Data.Funds.get(i).Value;
					IP = i;
					break;}
				if(IP > -1){
					Data.Funds.get(IP).Value = Pre + Tot - OldTot;
					Data.changeFundValue(TData.TTypeVal.tvFou, Data.Funds.get(IP).Id, Data.Funds.get(IP).Value);
				}
				else{
					String def = getResources().getString(R.string.default_name);
					Data.addValue(TData.TTypeVal.tvFou, -1, def, Tot);
					//Data.FileData.DefFund = def;
					Data.setDefaultFund(def);
				}
				//Data.SetTot(TData.TTypeVal.tvFou, Tot);
				Data.FileData.Modified = true;
				showF();
			}
		});

		alert.setNegativeButton(getResources().getString(R.string.dialog_cancel), new DialogInterface.OnClickListener() {
		  public void onClick(DialogInterface dialog, int whichButton) {
		    // Canceled.
			//return false;
		  }
		});
		
		alert.show();
		
	}

	public void DefaultFundClick(){
		int i;

        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        //builder.setTitle(getResources().getString(R.string.app_name));
        builder.setTitle(this.getResources().getString(R.string.fund_default_choose));
        
        ArrayList<String> list = new ArrayList<String>();
        for(i = 0; i < Data.NFun /*-1*/; i++) list.add(Data.Funds.get(i).Name);
        final CharSequence[] items = list.toArray(new CharSequence[list.size()]);
        //items.ch
        
        builder.setItems(items, new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int item) {
                // Do something with the selection
        		Data.setDefaultFund(items[item].toString());
            }
        });
        AlertDialog alert = builder.create();
        alert.show();

	}

	public void NewCreditClick(View view){
		Intent intent = new Intent(this, credit_add.class);
		startActivityForResult(intent, 5);
	}

	public void RemoveCreditClick(View view){
		Bundle bundle = new Bundle();
		bundle.putInt("labels", 0);
		bundle.putDouble("max_value", Data.Credits.get(credit_pos).Value);
		Intent intent = new Intent(this, remcreddeb.class);
		intent.putExtras(bundle);		
		startActivityForResult(intent, 6);
	}
	
	public void CondoneCreditClick(View view){
		Bundle bundle = new Bundle();
		bundle.putInt("labels", 1);
		bundle.putDouble("max_value", Data.Credits.get(credit_pos).Value);
		Intent intent = new Intent(this, remcreddeb.class);
		intent.putExtras(bundle);		
		startActivityForResult(intent, 7);
	}
	
	public void NewDebtClick(View view){

		Intent intent = new Intent(this, debt_add.class);
		startActivityForResult(intent, 8);
	}

	public void RemoveDebtClick(View view){
		Bundle bundle = new Bundle();
		bundle.putInt("labels", 2);
		bundle.putDouble("max_value", Data.Debts.get(debt_pos).Value);
		Intent intent = new Intent(this, remcreddeb.class);
		intent.putExtras(bundle);		
		startActivityForResult(intent, 9);
	}
	
	public void CondoneDebtClick(View view){
		Bundle bundle = new Bundle();
		bundle.putInt("labels", 3);
		bundle.putDouble("max_value", Data.Debts.get(debt_pos).Value);
		Intent intent = new Intent(this, remcreddeb.class);
		intent.putExtras(bundle);		
		startActivityForResult(intent, 10);
	}

	public void receivedClick(View view){
		Bundle bundle = new Bundle();
		bundle.putInt("labels", 1);
		Intent intent = new Intent(this, object_add.class);
		intent.putExtras(bundle);		
		startActivityForResult(intent, 11);
	}

	public void giftedClick(View view){
		Bundle bundle = new Bundle();
		bundle.putInt("labels", 2);
		Intent intent = new Intent(this, object_add.class);
		intent.putExtras(bundle);		
		startActivityForResult(intent, 12);
	}

	public void LendClick(View view){
		//ObjectOperation(3);
		
		Bundle bundle = new Bundle();
		bundle.putInt("labels", 3);
		Intent intent = new Intent(this, object_add.class);
		intent.putExtras(bundle);		
		startActivityForResult(intent, 13);
	}

	public void getBackClick(View view){
		int id = Data.Lent.get(lent_pos).Id;
		String obj = Data.Lent.get(lent_pos).Name;
		String per = Data.Lent.get(lent_pos).Object;
		Data.delObject(TData.TObjType.toPre, /*lent_pos*/ id);
		Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toBakObj, obj, per, -1);
		showF();
	}

	public void BorrowClick(View view){
		Bundle bundle = new Bundle();
		bundle.putInt("labels", 4);
		Intent intent = new Intent(this, object_add.class);
		intent.putExtras(bundle);		
		startActivityForResult(intent, 14);
	}

	public void giveBackClick(View view){
		int id = Data.Borrowed.get(borrowed_pos).Id;
		String obj = Data.Borrowed.get(borrowed_pos).Name;
		String per = Data.Borrowed.get(borrowed_pos).Object;
		Data.delObject(TData.TObjType.toInP, /*borrowed_pos*/ id);
		Data.addOper(-1, Data.Day, new GregorianCalendar(), TData.TOpType.toRetObj, obj, per, -1);
		showF();
	}

	public void addShopItemClick(View view){
		Bundle bundle = new Bundle();
		bundle.putInt("labels", 5);
		Intent intent = new Intent(this, object_add.class);
		intent.putExtras(bundle);		
		startActivityForResult(intent, 15);
	}
	
	public void delShopItemClick(View view){
		int id = Data.ShopItems.get(shop_pos).Id;
		Data.delShopItem(/*shop_pos*/id);
		showF();
	}

	private void openDocument(){
		bil_library.appContext = getApplicationContext();

		File f = new File(document);
		if(! f.exists())
			startActivity(new Intent(this, documentselection.class));
		
	 	// Document memory-space creation
		Data = new TData(document, this, null); // Progress bar is set after frame creation
		/* TODO: to be implemented
		Data.Progress = frame->Progress;
		frame->UpdateCalendar();
		*/
		
		Data.frame = this;

		// TODO (igor#1#): To be restored when SQL encryption is available
		/*
		if(Data.FileData.Access.compareTo(Opts.getString("GPassword", "NULL")) != 0)
		{
			Toast.makeText(getApplicationContext(), getResources().getString(R.string.error_04), Toast.LENGTH_LONG).show();
			return;
		}
		*/
		
		showF();
	
	}
	
	public void TextConvClick(View view){
		//StatusBar->SetStatusText(_("Document conversion i progress..."),0);
		//Data->DocExport(false,wxEmptyString,wxEmptyString);

		File Ch1 = null, Ch2 = null;
		//String hm;

	    //hm=::wxGetHomeDir()+L"/tmp/bil";
	    File outputDir = this.getCacheDir(); // context being the Activity pointer
	    		
		//Ch1=::wxFileName::CreateTempFileName(hm);
	    try {
			Ch1 = File.createTempFile("prefix", ".bil", outputDir);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		/*
	    if(Ch1.IsEmpty()){
			Error(44,wxEmptyString);
			StatusBar->SetStatusText(wxEmptyString,0);
			::wxEndBusyCursor();
			return;}
		*/
	    try {
			Ch2 = File.createTempFile("prefix", ".bil", outputDir);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		/*
	    if(Ch2.IsEmpty()){
			Error(44,wxEmptyString);
			StatusBar->SetStatusText(wxEmptyString,0);
			::wxEndBusyCursor();
			return;}
		*/
	    
	    /*
		wxBitmap bmp=FundChart->CopyBackbuffer();
		bmp.SaveFile(Ch1,wxBITMAP_TYPE_BMP);
		bmp=TrendChart->CopyBackbuffer();
		bmp.SaveFile(Ch2,wxBITMAP_TYPE_BMP);
		*/

	    saveChart(R.id.fund_graph, Ch1);
	    saveChart(R.id.trend_graph, Ch2);
	    
		Data.XMLExport(Ch1, Ch2);

		// Remove temporary chart files
		/*
		::wxRemoveFile(Ch1);
		::wxRemoveFile(Ch2);

		StatusBar->SetStatusText(wxEmptyString,0);
		*/
		
		Toast.makeText(getApplicationContext(), getResources().getString(R.string.xml_completed), Toast.LENGTH_LONG).show();
	}

	private void remove_obtained_shopitem(String obj){
		for(int i = 0; i < Data.NSho; i++){
			//S1=Data->ShopItems[i].Name.MakeLower();
			if(obj.compareToIgnoreCase(Data.ShopItems.get(i).Name) == 0){
				String Msg = String.format(getResources().getString(R.string.shoplist_bought), Data.ShopItems.get(i).Name);
				final int tmp_int = i;
				//shop_pos = i;
				
		 		AlertDialog.Builder alert = new AlertDialog.Builder(this);

		 		alert.setTitle(getResources().getString(R.string.app_name));
				alert.setMessage(Msg);

				// Set an EditText view to get user input 
				//final EditText input = new EditText(this);
				//input.setTransformationMethod(PasswordTransformationMethod.getInstance());
				//alert.setView(input);

				alert.setPositiveButton(getResources().getString(android.R.string.ok), new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int whichButton) {
						Data.delShopItem(tmp_int);
						showF();
				  }
				});

				alert.setNegativeButton(getResources().getString(R.string.dialog_no), new DialogInterface.OnClickListener() {
				  public void onClick(DialogInterface dialog, int whichButton) {
				    // Canceled.
					//return false;
				  }
				});
				
				alert.show();

			}
		}
		
	}

	private void paintChart(){
		
		int i;
		String color;

		if(/*ShowFundChart()*/true){
			// Fund Chart construction
			int cindex = 0;	// colour array index
			PieSlice slice;
			PieGraph FundPlot = (PieGraph)findViewById(R.id.fund_graph);
			/*
			FundPlot->Set3DView(true);
			FundPlot->SetEllipticAspect(.6);
			double fundvalues[Data->NFun-1];
			wxString fundnames[Data->NFun-1];
			wxColour colours[Data->NFun-1];
			*/
			
			FundPlot.removeSlices();
			
			for(i = 0; i < Data.NFun /*-1*/; i++){
				slice  = new PieSlice();
				switch(cindex){
					case 1:
						color = "#FFFF99";
						break;
					case 2:
						color = "#3DEB3D";
						break;
					case 3:
						color = "#FF0000";
						break;
					case 4:
						color = "#00FF00";
						break;
					case 5:
						color = "#0000FF";
						break;
					default:
						color = "#99CCFF";
						cindex = 0;}
				cindex++;
				slice.setColor(Color.parseColor(color));
				slice.setValue((float) Data.Funds.get(i).Value);
				//fundnames[i]=Data->Funds[i].Name;
				FundPlot.addSlice(slice);
			}
			//FundPlot.setInnerCircleRatio(30);
			//FundPlot.setPadding(5);

			/*
			CategorySimpleDataset* dataset = new CategorySimpleDataset(fundnames, WXSIZEOF(fundnames));
			dataset->AddSerie(_("Funds"),fundvalues, WXSIZEOF(fundvalues));
			// colour array initialization
			i=0;
			ColorScheme* colorScheme = new ColorScheme(colours, WXSIZEOF(colours)); FundPlot->SetDataset(dataset);
			FundPlot->SetColorScheme(colorScheme);
			FundChart->SetChart(new Chart(FundPlot, _("Fund Chart")));
			*/
			
		}
		
		if(/*ShowTrendChart()*/ true){
			// Trend chart construction
			GregorianCalendar month = Data.Day;
			month.set(Calendar.MONTH, (int) Data.FileData.Month);
			int number_of_days = /*Data.Day.*/month.getActualMaximum(Calendar.DAY_OF_MONTH);
			double trendvalues[] = new double[number_of_days];
			for(i = 0; i < number_of_days; i++) trendvalues[i] = -1;
			//const wxChar *trenddates[number_of_days];
			//time_t times[WXSIZEOF(trenddates)];
			//GregorianCalendar LastDate = new GregorianCalendar(), dt;
			double	LastValue = 0, MinValue = 0, MaxValue = 0;
			int j = 0;
			
			NumberFormat nf = NumberFormat.getInstance(Locale.getDefault());
			String value;
			
			for(i = 0; i < Data.NLin /*-1*/; i++){
				if(Data.IsDate(i)){
					j = Data.Lines.get(i).Date.get(Calendar.DAY_OF_MONTH) - 1;
					//LastDate = Data.Lines.get(i).Date;
					//LastValue = Double.parseDouble(Data.Lines.get(i).Value);
					
					// Robustness code to handle localized or unlocalized strings
					
					value = Data.Lines.get(i).Value;
					if(value.indexOf(".") > -1) LastValue = Double.parseDouble(value);
					else{
						try {
							LastValue = nf.parse(value).doubleValue();
						} catch (ParseException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					}
					trendvalues[j] = LastValue;
					//times[j]=LastDate.GetTicks();
					}}

			boolean found_before = false, found_after;
			int k;
			for(i = 0; i < number_of_days; i++){
				if(trendvalues[i] == -1){
					if(found_before){
						found_after = false;
						for(k = i + 1; k < number_of_days; k++)
							if(trendvalues[k] != -1){
								found_after = true;
								break;}

						if(found_after) trendvalues[i] = trendvalues[ i - 1];
						else trendvalues[i] = 0;}
					else trendvalues[i] = 0;
					//dt = wxDateTime(i+1, m, Data->FileData.Year, 0, 0, 0, 0);
					//times[i] = dt.GetTicks();
				}
				else found_before = true;}

			Line l = new Line();
			LinePoint p;
			for(i = 0; i < number_of_days; i++){
				p = new LinePoint();
				p.setX(i);
				p.setY(trendvalues[i]);
				l.addPoint(p);
			}
			l.setColor(Color.parseColor("#000000"));

			LineGraph li = (LineGraph)findViewById(R.id.trend_graph);

			/*
			XYPlot *trendplot = new XYPlot();
			wxColour color_trend = wxColour(0, 0, 0);
			XYLineRenderer *renderer_trend=new XYLineRenderer();
			renderer_trend->SetSerieColour(0,&color_trend);
			TimeSeriesDataset *dataset1 = new TimeSeriesDataset(trendvalues, times, WXSIZEOF(trendvalues));
			dataset1->SetRenderer(renderer_trend);
			trendplot->AddDataset(dataset1);
			*/
			
			if(! Data.FileData.ReadOnly){
				// trend addition
				// TODO (igor#1#): To be improved when wxFreeChart adds support for different colours in TimeDataset
				/*
				double trend_trend_values[number_of_days+1];
				const wxChar *trend_trend_dates[number_of_days+1];
				time_t times_trend[WXSIZEOF(trend_trend_dates)];
				for(i=0; i<= j; i++){
					trend_trend_values[i] = trendvalues[i];
					times_trend[i] = times[i];}
				*/
				double currenttotal = Data.GetTot(TData.TTypeVal.tvFou);
				/*
				trend_trend_values[j+1] = currenttotal;
				times_trend[j+1] = LastDate.GetTicks();			// set during main Trend construction loop
				dt = wxDateTime::Today();
				for(i = j+2; i < number_of_days; i++){
					trend_trend_values[i] = currenttotal;
					times_trend[i] = dt.GetTicks();}
				wxColour color_trend_trend;
				*/
				if(LastValue == currenttotal) color = "#FFFF00";
				else if(LastValue < currenttotal) color = "#006400";
				else color = "#FF0000";
				l.setColor(Color.parseColor(color));
				
				/*
				renderer_trend->SetSerieColour(0,&color_trend_trend);
				TimeSeriesDataset *dataset2 = new TimeSeriesDataset(trend_trend_values, times_trend, WXSIZEOF(trend_trend_values));
				dataset2->SetRenderer(renderer_trend);
				trendplot->AddDataset(dataset2);
				*/
				
				if(/*trend_*/trendvalues[j] < MinValue) MinValue = /*trend_*/trendvalues[j];
				if(/*trend_*/trendvalues[j] > MaxValue) MaxValue = /*trend_*/trendvalues[j];}

			li.addLine(l);

			/*
			NumberAxis *leftAxis = new NumberAxis(AXIS_LEFT);
			DateAxis *bottomAxis = new DateAxis(AXIS_BOTTOM);
			bottomAxis->SetVerticalLabelText(true);
			bottomAxis->SetDateFormat(L"%d/%m");
			*/
			
			// Set y scale
			if(MinValue==0){
				for(i = 0; i < j; i++)if(trendvalues[i] > 0){
					MinValue = trendvalues[i];
					break;}}
			if(MaxValue==0)MaxValue=trendvalues[0];
			for(i=1;i<j;i++){
				if((trendvalues[i] != -1) && (trendvalues[i] < MinValue)) MinValue=trendvalues[i];
				if(trendvalues[i]>MaxValue)MaxValue=trendvalues[i];}
			/*int*/double pp = 0, num;
			double res = MinValue;
			while(res >= 1){
				res = res / 10;
				if(res >= 1)pp++;}
			pp = Math.pow(10, pp);
			num = MinValue / pp;
			if(num > 1) num--;
			MinValue = num * pp;
			pp = 0;
			res = MaxValue;
			while(res >= 1){
				res = res / 10;
				if(res >= 1)pp++;}
			pp = Math.pow(10, pp);
			num = MaxValue / pp + 1;
			MaxValue=num * pp;

			li.setRangeY((float) MinValue, (float) MaxValue);
			li.setLineToFill(0);

			/*
			trendplot->AddAxis(leftAxis);
			trendplot->AddAxis(bottomAxis);
			trendplot->LinkDataVerticalAxis(0, 0);
			trendplot->LinkDataHorizontalAxis(0, 0);
			if(! Data->FileData.ReadOnly){
				trendplot->LinkDataVerticalAxis(1, 0);
				trendplot->LinkDataHorizontalAxis(1, 0);}
			TrendChart->SetChart(new Chart(trendplot, _("Trend Chart")));
		*/
			
		}
	}

	private void alarm_notification(int kind, int index, String text)
	{
		Notification.Builder mBuilder =
		        new Notification.Builder(this)
				.setLargeIcon(BitmapFactory.decodeResource(getResources(),R.drawable.ic_launcher))
		        .setContentTitle(getResources().getString(R.string.alarm))
		        .setContentText(text)
		        .setSound(RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION))
		        ;
        if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP){
        	mBuilder.setColor(0xff35ff);
        	mBuilder.setSmallIcon(R.drawable.ic_launcher_white);
        }
        else
        	mBuilder.setSmallIcon(R.drawable.ic_launcher);

		// Creates an explicit intent for an Activity in your app
		Bundle bundle = new Bundle();
		Intent resultIntent = new Intent(this, alarm.class);
		bundle.putInt("kind", kind);
		bundle.putInt("index", index);
		bundle.putString("message", text);
		resultIntent.putExtras(bundle);
		// The stack builder object will contain an artificial back stack for the
		// started Activity.
		// This ensures that navigating backward from the Activity leads out of
		// your application to the Home screen.
		TaskStackBuilder stackBuilder = TaskStackBuilder.create(this);
		// Adds the back stack for the Intent (but not the Intent itself)
		stackBuilder.addParentStack(mainactivity.class);
		// Adds the Intent that starts the Activity to the top of the stack
		stackBuilder.addNextIntent(resultIntent);
		PendingIntent resultPendingIntent =
		        stackBuilder.getPendingIntent(
		            0/*16*/,
		            PendingIntent.FLAG_UPDATE_CURRENT
		        );
		mBuilder.setContentIntent(resultPendingIntent);
		NotificationManager mNotificationManager =
		    (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);

		Notification notif = mBuilder.build();
		if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
			int smallIconViewId = getResources().getIdentifier("right_icon", "id", android.R.class.getPackage().getName());

		    if (smallIconViewId != 0) {
		        if (notif.contentIntent != null)
		            notif.contentView.setViewVisibility(smallIconViewId, View.INVISIBLE);
		
		        if (notif.headsUpContentView != null)
		            notif.headsUpContentView.setViewVisibility(smallIconViewId, View.INVISIBLE);
		
		        if (notif.bigContentView != null)
		            notif.bigContentView.setViewVisibility(smallIconViewId, View.INVISIBLE);
		    }
		}
		
		// mId allows you to update the notification later on.
		mNotificationManager.notify(/*mId*/10000, notif);
	}
	
	class Task implements Runnable {
		@Override
		public void run() {
			if(HasAlarms){
				timer.postDelayed(new Runnable() {
					@Override
					public void run() {
						doChecks(false, -1, null);
					}
				}, MainTimerInt);
			}
		}
	}

	private boolean doChecks(boolean auto, int kind, GregorianCalendar cal)
	{

		if(isConnected(this)) return false;
		
		// Following line is for safety reason (the file could be updated by cloud tools after being loaded)
		//Data->LoadFromFile(true,Data->FileData.FileName,wxEmptyString,true);

		int result;
		result = Data.checkLentObjects();
		if(result >= 0){
			if(auto && (kind == 1))
			{
				Data.Lent.get(result).Alarm = cal;
				ContentValues cv = new ContentValues();
				//cv.clear();
				cv.put("alarm", cal.getTimeInMillis() / 1000);
				Data.database.update("Loans", cv, "id = " + String.format("%d", Data.Lent.get(result).Id), null);
			}
			else alarm_notification(1, result,
					String.format(getResources().getString(R.string.alarm_detail_lent), Data.Lent.get(result).Name)
					/*,
					Data.ShopItems.get(result).Alarm*/
			);
			return true;
		}

		result = Data.checkBorrowedObjects();
		if(result >= 0){
			if(auto && (kind == 2)) {
				Data.Borrowed.get(result).Alarm = cal;
				ContentValues cv = new ContentValues();
				//cv.clear();
				cv.put("alarm", cal.getTimeInMillis() / 1000);
				Data.database.update("Borrows", cv, "id = " + String.format("%d", Data.Borrowed.get(result).Id), null);
			}
			else alarm_notification(2, result,
					String.format(getResources().getString(R.string.alarm_detail_borrowed), Data.Borrowed.get(result).Name)
					/*,
					Data.ShopItems.get(result).Alarm*/
			);
			return true;
		}

		result = Data.checkShopList();
		if(result >= 0){
			if(auto && (kind == 3))
			{
				Data.ShopItems.get(result).Alarm = cal;
				ContentValues cv = new ContentValues();
				//cv.clear();
				cv.put("alarm", cal.getTimeInMillis() / 1000);
				Data.database.update("Shoplist", cv, "id = " + String.format("%d", Data.ShopItems.get(result).Id), null);
			}
			else alarm_notification(3, result,
					String.format(getResources().getString(R.string.alarm_detail_shoplist), Data.ShopItems.get(result).Name)
					/*,
					Data.ShopItems.get(result).Alarm*/
			);
			return true;
		}
		//if(Data->FileData.Modified)Data->SaveToFile(true, false, Data->FileData.FileName);
		
		return false;
	}

	private void saveChart(int id, File filename){
	    View plot = this.findViewById(id);
	    plot.setDrawingCacheEnabled (true);
	    plot.buildDrawingCache(true);
	    Bitmap b = Bitmap.createBitmap(plot.getDrawingCache());
	    OutputStream os = null;
		try {
			os = new FileOutputStream(filename);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		b.compress(CompressFormat.PNG, 100, os);
		plot.destroyDrawingCache();
	    //pictureToSave.writeToStream(os);
	    try {
			os.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	
	private /*static*/ boolean isConnected(Context context) {
		if(isDebuggable(this)) return false;
        Intent intent = context.registerReceiver(null, new IntentFilter("android.hardware.usb.action.USB_STATE"));
        return intent.getExtras().getBoolean("connected");
    }
	
	// TODO: comment this routine and calls for release builds
	private boolean isDebuggable(Context ctx)
	{
	    boolean debuggable = false;
	 
	    PackageManager pm = ctx.getPackageManager();
	    try
	    {
	        ApplicationInfo appinfo = pm.getApplicationInfo(ctx.getPackageName(), 0);
	        debuggable = (0 != (appinfo.flags & ApplicationInfo.FLAG_DEBUGGABLE));
	    }
	    catch(NameNotFoundException e)
	    {
	        /*debuggable variable will remain false*/
	    }
	     
	    return debuggable;
	}

}
