/***************************************************************
 * Name:      
 * Purpose:   Core Code for Bilancio Application
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2015-06-28
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

package com.igisw.bilancio;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.TextView;

public class object_add extends Activity {

	private boolean return_contact, return_reminder;
	public TextView caption, obj_label, per_label;
	public EditText objText, perText;
	public CheckBox almCheck;
	public DatePicker almText;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.objects_add);
		
		return_contact = true;
		return_reminder = false;
		
        caption = (TextView) findViewById(R.id.Caption);
        obj_label = (TextView) findViewById(R.id.LObj);
		objText = (EditText) findViewById(R.id.Obj);
        per_label = (TextView) findViewById(R.id.LPer);
		perText = (EditText) findViewById(R.id.Per);
		almCheck = (CheckBox) findViewById(R.id.AlmCB);
		almCheck.setOnCheckedChangeListener(new OnCheckedChangeListener()
		{
			@Override
		    public void onCheckedChanged(CompoundButton buttonView, boolean isChecked)
		    {
				almText.setEnabled(isChecked);
		    }
		});	
		almText = (DatePicker) findViewById(R.id.Alarm);
		
		almText.setEnabled(false);
		
		Bundle bundle=getIntent().getExtras();
		
		int labels = bundle.getInt("labels");
		switch(labels){
			case 1:
				hideAlarm();
				break;
			case 2:	// Gift object
				caption.setText(getResources().getString(R.string.object_give));
				obj_label.setText(getResources().getString(R.string.object_given_name));
				per_label.setText(getResources().getString(R.string.object_receiver));
				hideAlarm();
				break;
			case 3: // Lend object
				caption.setText(getResources().getString(R.string.object_lend));
				obj_label.setText(getResources().getString(R.string.object_lent_name));
				per_label.setText(getResources().getString(R.string.object_receiver));
				return_reminder = true;
				break;
			case 4: // Borrow object
				caption.setText(getResources().getString(R.string.object_borrow));
				obj_label.setText(getResources().getString(R.string.object_borrow_name));
				per_label.setText(getResources().getString(R.string.object_donor));
				return_reminder = true;
				break;
			case 5: // Add shop item
				caption.setText(getResources().getString(R.string.shoplist_caption));
				obj_label.setText(getResources().getString(R.string.shoplist_item));
				per_label.setVisibility(View.GONE);
				perText.setVisibility(View.GONE);
				return_contact = false;
				return_reminder = true;
				//break;

		}

	}
	
	public void okBtnClick(View view){
		//double cur;
		int ReturnCode = RESULT_CANCELED;
		
		bil_library.appContext = getApplicationContext();

		String obj = objText.getText().toString();
		String per;
		if(return_contact){
			per = perText.getText().toString();
		}
		else per = "";
		//TextView value = (TextView) findViewById(R.id.opValue);
		if(obj.isEmpty()){
			bil_library.Error(32, "");
			objText.requestFocus();
			return;}
		
		if(return_contact){
			if(per.isEmpty()){
				bil_library.Error(33, "");
				perText.requestFocus();
				return;}
		}
		
		// Create intent w/ result
		Intent intent = new Intent();
		Bundle bundle = new Bundle();
		obj = bil_library.iUpperCase(obj);
		obj = obj.trim();
		bundle.putString("object", obj);
		if(per != ""){
			per = bil_library.iUpperCase(per);
			per = per.trim();
		}
		bundle.putString("person", per);
		if(return_reminder){
			bundle.putInt("day", almText.getDayOfMonth());
			bundle.putInt("month", almText.getMonth());
			int year = almText.getYear();
			if(! almCheck.isChecked()) year += 100;
			bundle.putInt("year", year);
		}
		
		intent.putExtras(bundle);
				
		ReturnCode = RESULT_OK;
		setResult(ReturnCode, intent);
		finish();
	}
	
	private void hideAlarm(){
		almCheck.setVisibility(View.GONE);
		almText.setVisibility(View.GONE);
	}
	
}
