/***************************************************************
 * Name:      
 * Purpose:   Core Code for Bilancio Application
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2016-08-11
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

package com.igisw.bilancio;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.AutoCompleteTextView;
import android.widget.Spinner;
import android.widget.TextView;

public class operation extends Activity {

	public AutoCompleteTextView matters_View;
	public Spinner fund_spinner;
	public Spinner category_spinner;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.operation);
		
		Bundle bundle=getIntent().getExtras();
		
		if(bundle.getBoolean("change_labels")){
	        TextView caption = (TextView) findViewById(R.id.Caption);
			caption.setText(getResources().getString(R.string.expense_caption));
	        TextView fund_label = (TextView) findViewById(R.id.fundLabel);
			fund_label.setText(getResources().getString(R.string.expense_fund));
	        TextView value_label = (TextView) findViewById(R.id.valueLabel);
			value_label.setText(getResources().getString(R.string.expense_value));
	        TextView reason_label = (TextView) findViewById(R.id.reasonLabel);
			reason_label.setText(getResources().getString(R.string.expense_reason));
	        TextView category_label = (TextView) findViewById(R.id.categoryLabel);
			category_label.setText(getResources().getString(R.string.expense_category));
		}

        // Autocomplete matters
		ArrayAdapter<String> matters_adapter = new ArrayAdapter<String>(this,
            android.R.layout.simple_dropdown_item_1line, bundle.getStringArrayList("matters"));
        matters_View = (AutoCompleteTextView)
            findViewById(R.id.Matter);
        matters_View.setAdapter(matters_adapter);

        // Fill spinner w/ funds
        fund_spinner = (Spinner) findViewById(R.id.Fund);
        ArrayAdapter<String> funds_adapter = new ArrayAdapter<String>(this,
             android.R.layout.simple_spinner_item, bundle.getStringArrayList("funds"));
        funds_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        fund_spinner.setAdapter(funds_adapter);
        fund_spinner.setSelection(bundle.getInt("defaultfundindex"));

        // Fill spinner w/ categories
        category_spinner = (Spinner) findViewById(R.id.Category);
        ArrayAdapter<String> categories_adapter = new ArrayAdapter<String>(this,
             android.R.layout.simple_spinner_item, bundle.getStringArrayList("categories"));
        categories_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        category_spinner.setAdapter(categories_adapter);

	}
	
	public void okBtnClick(View view){
		double cur;
		int ReturnCode = RESULT_CANCELED;
		
		bil_library.appContext = getApplicationContext();

		TextView value = (TextView) findViewById(R.id.opValue);
		if(value.getText().toString().isEmpty()){
			bil_library.Error(25, "");
			value.requestFocus();
			return;}
		/*
		wxString v=CheckValue(OpValue->GetValue());
		if(v.IsEmpty()){
			bil_library.Error(26, "");
			//Focus(2);
			return;}
		else OpValue->SetValue(v);
		*/
		cur = Double.parseDouble(value.getText().toString());
		/*
		OpValue->GetValue().ToDouble(&cur);
		if(cur<0){
			Error(27,wxEmptyString);
	    Focus(2);
	    return;}
		*/
		String matter = matters_View.getText().toString(); 
		if(matter.isEmpty()){
			bil_library.Error(29, "");
			matters_View.requestFocus();
			return;}
		//matters_View.setText(bil_library.iUpperCase(matters_View.getText().toString()));
		matter = bil_library.iUpperCase(matter);
		matter = matter.trim();
		//matters_View.setText(matter);
		
		// Create intent w/ result
		Intent intent = new Intent();
		Bundle bundle = new Bundle();
		bundle.putString("fund", fund_spinner.getSelectedItem().toString());
		bundle.putDouble("value", cur);
		bundle.putString("matter", matter);
		bundle.putInt("category", category_spinner.getSelectedItemPosition()/* -1*/);
		intent.putExtras(bundle);
				
		ReturnCode = RESULT_OK;
		setResult(ReturnCode, intent);
		finish();
	}
}
