/***************************************************************
 * Name:
 * Purpose:   Core Code for Bilancio Application
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2016-12-27
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

package com.igisw.bilancio;

import android.support.v7.widget.CardView;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.List;

public class recycler_adapter extends RecyclerView.Adapter<recycler_adapter.ViewHolder>{

    public static final int DATE = 0;
    public static final int OPER = 1;

    List<lines_wrapper> operations;

    public static class ViewHolder extends RecyclerView.ViewHolder {
        public ViewHolder(View v) {
            super(v);
        }
    }

    public class DateViewHolder extends ViewHolder {

        CardView cv;
        TextView reportTime;
        TextView reportValue;

        public DateViewHolder(View itemView) {
            super(itemView);
            this.cv = (CardView)itemView.findViewById(R.id.cv);
            this.reportTime = (TextView)itemView.findViewById(R.id.report_date);
            this.reportValue = (TextView)itemView.findViewById(R.id.report_total);
        }
    }

    public class OperationViewHolder extends ViewHolder {

        CardView cv;
        TextView reportValue;
        TextView reportReason;
        TextView reportTime;
        TextView reportCategory;
        ImageView reportIcon;

        public OperationViewHolder(View itemView) {
            super(itemView);
            this.cv = (CardView)itemView.findViewById(R.id.cv);
            this.reportValue = (TextView)itemView.findViewById(R.id.report_value);
            this.reportReason = (TextView)itemView.findViewById(R.id.report_reason);
            this.reportTime = (TextView)itemView.findViewById(R.id.report_time);
            this.reportCategory = (TextView)itemView.findViewById(R.id.report_category);
            this.reportIcon = (ImageView)itemView.findViewById(R.id.report_icon);
        }
    }

    public recycler_adapter(List<lines_wrapper> operations){
        this.operations = operations;
    }

    @Override
    public int getItemCount() {
        return operations.size();
    }

    @Override
    public ViewHolder onCreateViewHolder(ViewGroup viewGroup, int viewType) {
        View v;
        if(viewType == DATE){
            v = LayoutInflater.from(viewGroup.getContext()).inflate(R.layout.cardview_date, viewGroup, false);
            return new DateViewHolder(v);
        }
        else {
            v = LayoutInflater.from(viewGroup.getContext()).inflate(R.layout.cardview_operation, viewGroup, false);
            return new OperationViewHolder(v);
        }
    }

    @Override
    public void onBindViewHolder(ViewHolder viewHolder, int i) {
        if(viewHolder.getItemViewType() == DATE){
            DateViewHolder holder = (DateViewHolder) viewHolder;
            holder.reportTime.setText(operations.get(i).time);
            holder.reportValue.setText(operations.get(i).value);
        }
        else {
            OperationViewHolder holder = (OperationViewHolder) viewHolder;
            holder.reportValue.setText(operations.get(i).value);
            holder.reportReason.setText(operations.get(i).reason);
            holder.reportTime.setText(operations.get(i).time);
            holder.reportCategory.setText(operations.get(i).category);
            holder.reportIcon.setImageResource(operations.get(i).iconId);
        }
    }

    @Override
    public void onAttachedToRecyclerView(RecyclerView recyclerView) {
        super.onAttachedToRecyclerView(recyclerView);
    }

    @Override
    public int getItemViewType(int position) {
        return operations.get(position).type;
    }
}
