/***************************************************************
 * Name:      
 * Purpose:   Core Code for Bilancio Application
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2015-07-20
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

package com.igisw.bilancio;
 
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RadioGroup.OnCheckedChangeListener;
import android.widget.TextView;
 
public class remcreddeb extends Activity {
 
  private RadioGroup radioGroup;
  //private RadioButton radioSexButton;
  //private Button btnDisplay;
  private EditText edittext;
  private TextView label;
  private RadioButton total, partial;
  
  private int labels;
  private double max_value;
 
  @Override
  public void onCreate(Bundle savedInstanceState) {
	super.onCreate(savedInstanceState);
	setContentView(R.layout.remove_creddeb);
 
	label = (TextView) findViewById(R.id.Caption);
	total = (RadioButton) findViewById(R.id.total);
	partial = (RadioButton) findViewById(R.id.partial);
	
	Bundle bundle = getIntent().getExtras();
	labels = bundle.getInt("labels");
	initLabels(labels);
	max_value = bundle.getDouble("max_value");
	
	addListenerOnButton();
 
  }
 
  public void addListenerOnButton() {
	  edittext = (EditText) findViewById(R.id.editText);
	  edittext.setEnabled(false);
	  radioGroup = (RadioGroup) findViewById(R.id.radioGroup);
	
	radioGroup.setOnCheckedChangeListener(new OnCheckedChangeListener() {

		@Override
		public void onCheckedChanged(RadioGroup group, int checkedId) {
			boolean enabled = (checkedId == R.id.partial);
			edittext.setEnabled(enabled);
		}
		
	});
	
  }
  
	public void okBtnClick(View view){
		double cur = -1;
		int ReturnCode = RESULT_CANCELED;
		
		bil_library.appContext = getApplicationContext();

		if(edittext.isEnabled()){
			if(edittext.getText().toString().isEmpty()){
				bil_library.Error(25, "");
				edittext.requestFocus();
				return;}

			cur = Double.parseDouble(edittext.getText().toString());

		if(cur > max_value){
			String Opt;
			switch(labels){
				case 2:
				case 3:
					Opt = getResources().getString(R.string.debt_term);
					break;
				default:
					Opt = getResources().getString(R.string.credit_term);
			}
			bil_library.Error(21, Opt);
			edittext.requestFocus();
			return;}
		}
		
		// Create intent w/ result
		Intent intent = new Intent();
		Bundle bundle = new Bundle();
		bundle.putBoolean("total", ! edittext.isEnabled());
		bundle.putDouble("value", cur);
		intent.putExtras(bundle);
				
		ReturnCode = RESULT_OK;
		setResult(ReturnCode, intent);
		finish();
	}

	private void initLabels(int value) {
		switch(value){
			case 1:	// Condone credit
				label.setText(getResources().getString(R.string.credit_condone2));
				total.setText(getResources().getString(R.string.condone_total));
				partial.setText(getResources().getString(R.string.condone_partially));
				break;
			case 2:	// Remove debt
				label.setText(getResources().getString(R.string.debt_delete));
				break;
			case 3:	// Condone debt
				label.setText(getResources().getString(R.string.debt_condone2));
				total.setText(getResources().getString(R.string.condone_total));
				partial.setText(getResources().getString(R.string.condone_partially));
				break;
			default:
		}
	}
	
}

