;	Bilancio
;	Last modify 18/11/2016

Unicode True

; Include
!include "include\locales.nsi"
!include "include\version.nsi"
;	!include "${igiLogoScriptPath}\igiLogoInstall.nsi"	; Necessary to install igiLogo
;	!include "InstallerFiles\Include\PrevInst.nsi"		; Necessary to VPatch
!include "include\dump.nsi"
;!include "include\dfe.nsi"
;	!include "InstallerFiles\Include\Windows_ver.nsi"
!include "include\registry.nsh"
!insertmacro COPY_REGISTRY_KEY
;__________________________________

;Installer attributes
!ifdef ALPHA
	Name "Bilancio ${MAJ_VER_str}.${MIN_VER_str}.${RELEASE_str}.${BUILD_str} alpha"
	OutFile "Bilancio_${MAJ_VER_str}_${MIN_VER_str}_${RELEASE_str}_${BUILD_str}_a.exe"
!else
	!ifdef BETA
		Name "Bilancio ${MAJ_VER_str}.${MIN_VER_str}.${RELEASE_str}.${BUILD_str} beta"
		OutFile "Bilancio_${MAJ_VER_str}_${MIN_VER_str}_${RELEASE_str}_${BUILD_str}_b.exe"
	!else
		!ifDef RC
			Name "Bilancio ${MAJ_VER_str}.${MIN_VER_str}.${RELEASE_str}.${BUILD_str} Release Candidate"
			OutFile "Bilancio_${MAJ_VER_str}_${MIN_VER_str}_${RELEASE_str}_${BUILD_str}_rc.exe"
		!else
			Name "Bilancio ${MAJ_VER_str}.${MIN_VER_str}.${RELEASE_str}.${BUILD_str}"
			OutFile "Bilancio_${MAJ_VER_str}_${MIN_VER_str}_${RELEASE_str}_${BUILD_str}.exe"
		!endif
	!endif
!endif
RequestExecutionLevel admin

Icon "media\install.ico"
AutoCloseWindow true
InstProgressFlags smooth colored
CRCCheck force
ShowInstDetails nevershow
ShowUninstDetails nevershow
SetOverwrite ifdiff
!ifdef ALPHA
	Caption "Bilancio ${MAJ_VER_str}.${MIN_VER_str} alpha"
!else
	!ifdef BETA
		!ifdef DEBUG
			Caption "Bilancio ${MAJ_VER_str}.${MIN_VER_str} beta - DEBUG"
		!else
			Caption "Bilancio ${MAJ_VER_str}.${MIN_VER_str} beta"
		!endif
	!else
		Caption "Bilancio ${MAJ_VER_str}.${MIN_VER_str}"
	!endif
!endif

; License files
LicenseLangString License ${LANG_ENGLISH} "..\license\en\license.txt"
LicenseLangString License ${LANG_ITALIAN} "..\license\it\licenza.txt"
LicenseData $(License)
LicenseForceSelection checkbox
;XPStyle on

!ifdef BETA
	InstallDir $PROGRAMFILES\Bilancio_beta
!else
	InstallDir $PROGRAMFILES\Bilancio
!endif
BrandingText /TRIMRIGHT "igiSW"

InstType $(TypicalInstallation)
InstType $(MinimumInstallation)
InstType $(CompleteInstallation)
InstType /COMPONENTSONLYONCUSTOM
;_______________________________________________________________________

;Version Info
VIProductVersion "${MAJ_VER}.${MIN_VER}.${RELEASE}.${BUILD}"
VIAddVersionKey "ProductName" "Bilancio"
VIAddVersionKey "Comments" ""
VIAddVersionKey "CompanyName" "igiSW"
VIAddVersionKey "FileDescription" "Budget Management Utility"
VIAddVersionKey "FileVersion" "${MAJ_VER_str}.${MIN_VER_str}.${RELEASE_str}.${BUILD_str}"
VIAddVersionKey "LegalCopyright" " Igor Cal <igor.cali0@gmail.com>"
;________________________________________________________________________

;Uninstaller attributes
UninstallIcon "media\uninstall.ico"
UninstallButtonText $(uiText)
UninstallCaption $(uiCaption)
UninstallSubCaption 0 $(uiSub0)
UninstallSubCaption 1 $(uiSub1)
UninstallSubCaption 2 $(uiSub2)
;________________________________________________________________________

;Installer pages
Page license
Page components "" ShowComp
Page directory
Page instfiles
;________________________________________________________________________

;Uninstaller pages
UninstPage uninstConfirm
UninstPage InstFiles
;___________________

;Variables
;	Var BilTrayInstalled
;	Var ConvInstalled	; Preparation
;	Var UpdateInstalled
;	Var WizInstalled
Var HelpInstalled
Var LangFlags	; bit 1: English installed
		; bit 2: Italian installed
;Var OS
Var InstallType
;_______________

Section "-Main"
	;Initialisation
	;StrCpy $BilTrayInstalled 0
	;StrCpy $ConvInstalled 0	;Preparation
	;StrCpy $UpdateInstalled 0
	;StrCpy $WizInstalled 0
	StrCpy $HelpInstalled 0
	StrCpy $LangFlags 1

	SetOutPath $INSTDIR
	DetailPrint "[Mingw libraries]"
	File "${Files}\libgcc_s_dw2-1.dll"
	File "${Files}\libstdc++-6.dll"
	DetailPrint "[Sqlite3 library]"
	File "${Files}\sqlite3.dll"

	DetailPrint "[wxWidgets libraries]"
	File "${Files}\wxbase30u_gcc_custom.dll"
	File "${Files}\wxmsw30u_adv_gcc_custom.dll"
	File "${Files}\wxmsw30u_aui_gcc_custom.dll"
	File "${Files}\wxmsw30u_core_gcc_custom.dll"
	File "${Files}\wxcode_msw30u_freechart.dll"
	File "${Files}\wxcode_msw30u_wxsqlite3.dll"

	DetailPrint "[Main]"

;	Push "Bilancio 2.3"
;	Call InstalligiLogo

;	IfErrors Err0
;	DetailPrint "Common files:			OK"
;	GoTo Main1
;	Err0:
;	DetailPrint "Common files:			KO!"
;	Main1:

	SetOutPath $INSTDIR
;	Call ClearAutoLog

;	Call GetWindowsVersion
;	Pop $0
;	StrCpy $OS $0

	File "${Files}\igilogo.dll"
;	Call ClearAutoLog
	File "${Files}\igibil.dll"
;	Call ClearAutoLog
	File "${Files}\igiberr.dll"
;	Call ClearAutoLog
	File "${Files}\bilopt.dll"
;	Call ClearAutoLog
	File "${Files}\bilancio.exe"
;	Call ClearAutoLog

	IfErrors Err1
	DetailPrint "Files bilancio:			OK"
	GoTo Main2
	Err1:
	DetailPrint "Files bilancio:			KO!"

;	Main2:
;	StrCmp $OS "XP" XP_OS

	;Code for OS different than WindowsXP--------------------
	;--------------------------------------------------------

;	XP_OS:

	Main2:
	StrCmp $LANGUAGE ${LANG_ENGLISH} 0 +3
	File "..\license\en\license.txt"
;	Call ClearAutoLog
	StrCmp $LANGUAGE ${LANG_ITALIAN} 0 +3
	File "..\license\it\licenza.txt"
;	Call ClearAutoLog

	File "..\license\gpl.txt"
;	Call ClearAutoLog

;	SetOutPath $INSTDIR\Thanks
;	Call ClearAutoLog
;	File "${Files}\Thanks\*.txt"
;	Call ClearAutoLog
;	Call ClearAutoLog
;	File "${Files}\Thanks\*.ico"
;	Call ClearAutoLog
;	Call ClearAutoLog

	SetOutPath $INSTDIR
	SetRebootFlag true
	DetailPrint "[Alarm]"

	File "${Files}\biltray.exe"
;	StrCpy $BilTrayInstalled 1
;	Call ClearAutoLog
	IfErrors Err2
	DetailPrint "BilTray:			OK"
	GoTo Alarm2
	Err2:
	DetailPrint "Biltray:			KO!"

	Alarm2:
	File "${Files}\alarm_clock.wav"
;	Call ClearAutoLog
	IfErrors Err3
	DetailPrint "Wave:				OK"
	GoTo AlarmEnd
	Err3:
	DetailPrint "Wave:				KO!"

	AlarmEnd:
	DetailPrint ""

	DetailPrint "[Wizard]"

	File "${Files}\bilwizard.dll"
;	StrCpy $WizInstalled 1
;	Call ClearAutoLog
	IfErrors Err4
	DetailPrint "BilWiz:				OK"
	GoTo Alarm3
	Err4:
	DetailPrint "BilWiz:				KO!"
	Alarm3:

	DetailPrint ""

	DetailPrint "[Update]"

	File "${Files}\BilUpdate.dll"
;	StrCpy $UpdateInstalled 1
;	Call ClearAutoLog
	IfErrors Err5
	DetailPrint "BilUpdate:			OK"
	GoTo Update2
	Err5:
	DetailPrint "BilUpdate:			KO!"
	Update2:

	DetailPrint ""

	DetailPrint "[XML files]"
	SetOutPath $INSTDIR\data
	File "${Files}\data\*"
	SetOutPath $INSTDIR\data\en
	File "${Files}\data\en\*"
	SetOutPath $INSTDIR\data\it
	File "${Files}\data\it\*"

	DetailPrint "[wget]"
	SetOutPath $INSTDIR\wget
	File "${Files}\wget\*"	

;	CreateDirectory "$INSTDIR\Update"
;	Call ClearAutoLog

	DetailPrint ""
SectionEnd


Section "-Dummy"	; To be removed whenever a real Section diversify minimum Typical
			; and Complete installation types
	SectionIn 3
SectionEnd

Section $(HelpFile)
	SectionIn 1 3
	DetailPrint "[Help]"

	SetOutPath $INSTDIR
;	Call ClearAutoLog

	; English
	File "${Files}\bilancio-msw_en.html"
;	Call ClearAutoLog

	SetOutPath $INSTDIR\images
	File "${Files}\images\*"	
	SetOutPath $INSTDIR\en\images
	File "${Files}\en\images\*"	

	StrCpy $HelpInstalled 1
;	IntOp $LangFlags $LangFlags | 1
	IfErrors Err1

	DetailPrint "Help file:			OK"
	DetailPrint ""
	Return
	Err1:
	DetailPrint "Help file:			KO!"
	DetailPrint ""
SectionEnd

;SectionGroup /e $(Utilities)

	;Preparation
	Section -$(Conv)
		SectionIn 1 3
		DetailPrint "[bilconvert]"

		SetOutPath $INSTDIR
		File "${Files}\bilconvert.exe"
	;	StrCpy $ConvInstalled 1
	;	Call ClearAutoLog
		IfErrors Err1
		DetailPrint "bilconvert:				OK"
		Goto ConvOK
		Err1:
		DetailPrint "bilconvert:				KO!"
		ConvOK:

		DetailPrint ""
	SectionEnd

;SectionGroupEnd

SectionGroup /e $(LanguagePackets)

;	Section "-English_guide"
;		SectionIn 1 2 3
;		DetailPrint "[LANGUAGE: ENGLISH]"
;
;		DetailPrint "English language pack:		OK"
;		DetailPrint ""
;		Return
;		DetailPrint "English language pack:		KO!"
;		DetailPrint ""
;	SectionEnd

	Section $(Language_ITA)
		SectionIn 3
		DetailPrint "[LANGUAGE: ITALIAN]"

		; Help
		StrCmp $HelpInstalled "1" +1 NoHelp
		SetOutPath $INSTDIR
;		Call ClearAutoLog
		File "${Files}\bilancio-msw_it.html"
;		Call ClearAutoLog

		SetOutPath $INSTDIR\it\images
		File "${Files}\it\images\*"	

		IntOp $LangFlags $LangFlags | 2
		IfErrors Err1

		NoHelp:
		CreateDirectory "$INSTDIR\it"
;		Call ClearAutoLog
		SetOutPath "$INSTDIR\it"
;		Call ClearAutoLog
		File "${Files}\it\bilancio.mo"
;		Call ClearAutoLog
		IfErrors Err1
		DetailPrint "Italian language pack:		OK"
		DetailPrint ""
		Return
		Err1:
		DetailPrint "Italian language pack:		KO!"
		DetailPrint ""
	SectionEnd

SectionGroupEnd

Section "-Shortcuts"
	StrCpy $0 ""
	DetailPrint "[SHORTCUTS]"
	SetShellVarContext current
	CreateDirectory '$SMPROGRAMS\Bilancio'
;	Call ClearAutoLog
	IfFileExists '$SMPROGRAMS\Bilancio\*.*' +1 Err
	DetailPrint "Shortcut folder:		OK"
	CreateShortCut "$SMPROGRAMS\Bilancio\Bilancio.lnk" "$INSTDIR\Bilancio.exe"
	IfErrors Err1
;	Call ClearAutoLog
	DetailPrint "Bilancio:			OK"
	GoTo Short1
	Err1:
;	Call ClearAutoLog
	DetailPrint "Bilancio:			KO!"
	StrCpy $0 "ERR"
	Short1:
;	IntCmp $BilTrayInstalled 1 +1 Short2
;	CreateShortCut "$SMSTARTUP\biltray.lnk" "$INSTDIR\biltray.exe"
;	IfErrors Err2
;	Call ClearAutoLog
;	DetailPrint "BilTray shortcut:		OK"
;	GoTo Short2
;	Err2:
;	Call ClearAutoLog
;	DetailPrint "BilTray shortcut:		KO!"
;	StrCpy $0 "ERR"
;	Short2:
	StrCmp $LANGUAGE ${LANG_ENGLISH} 0 +2
	CreateShortCut "$SMPROGRAMS\Bilancio\License.lnk" "$INSTDIR\License.txt"
	StrCmp $LANGUAGE ${LANG_ITALIAN} 0 +2
	CreateShortCut "$SMPROGRAMS\Bilancio\Licenza.lnk" "$INSTDIR\Licenza.txt"
	IfErrors Err3
;	Call ClearAutoLog
	DetailPrint "License:			OK"
	GoTo Short3
	Err3:
;	Call ClearAutoLog
	DetailPrint "License:			KO!"
	StrCpy $0 "ERR"
	Short3:
;	IntCmp $HelpInstalled +1 Short4
;	StrCmp $LANGUAGE ${LANG_ENGLISH} 0 +2
;	CreateShortCut "$SMPROGRAMS\Bilancio\Bilancio Guide.lnk" "$INSTDIR\Bilancio_ENG.chm"
;	StrCmp $LANGUAGE ${LANG_ITALIAN} 0 +2
;	CreateShortCut "$SMPROGRAMS\Bilancio\Guida di Bilancio.lnk" "$INSTDIR\Bilancio_ITA.chm"
;	IfErrors Err4
;	DetailPrint "Guide:				OK"
;	GoTo Short4
;	Err4:
;	DetailPrint "Guide:				KO!"
;	StrCpy $0 "ERR"
;	Short4:
	StrCmp $0 "ERR" Err +1
	DetailPrint ""
	Return

	Err:
;	Call ClearAutoLog
	DetailPrint "Shortcuts:			KO!"
	Call ErrLOG
	DetailPrint ""
SectionEnd

Section "-Registry"
	DetailPrint "[REGISTRY]"
	WriteRegStr "HKLM" "${SW_Key}" "Path" "$INSTDIR"
	IfErrors Err1
	DetailPrint "Installation path:		OK"
	GoTo Reg2
	Err1:
	DetailPrint "Installation path:		KO!"
	Reg2:
;	Preparation
;	WriteRegDWord "HKLM" "${SW_Key}" "Conv" "$ConvInstalled"
;	IfErrors Err2
;	DetailPrint "Conv:				OK"
;	GoTo Reg3
;	Err2:
;	DetailPrint "Conv:				KO!"
;	Reg3:
;	WriteRegDWord "HKLM" "${SW_Key}" "Tray" "$BilTrayInstalled"
;	IfErrors Err3
;	DetailPrint "BilTray:			OK"
;	GoTo Reg4
;	Err3:
;	DetailPrint "BilTray:			KO!"
;	Reg4:

;	WriteRegDWord "HKLM" "${SW_Key}" "Update" "$UpdateInstalled"
;	IfErrors Err11
;	DetailPrint "Update:				OK"
;	Goto Reg11
;	Err11:
;	DetailPrint "Update:				KO!"

;	Reg11:
;	WriteRegDWord "HKLM" "${SW_Key}" "Wiz" "$WizInstalled"
;	IfErrors Err4
;	DetailPrint "Wizard:				OK"
;	GoTo Reg12
;	Err4:
;	DetailPrint "Wizard:				KO!"

;	Reg12:
;	WriteRegDWord "HKLM" "${SW_Key}" "Help" "$HelpInstalled"
;	IfErrors Err12
;	DetailPrint "Help:				OK"
;	GoTo Reg5
;	Err12:
;	DetailPrint "Help:				KO!"

;	Reg5:
;	WriteRegDWORD "HKLM" "${SW_Key}" "MajVer" "${MAJ_VER}"
;	IfErrors ErrVersion
;	WriteRegDWORD HKLM "${SW_Key}" "MinVer" "${MIN_VER}"
;	IfErrors ErrVersion
;	WriteRegDWORD "HKLM" "${SW_Key}" "RelVer" "${RELEASE}"
;	IfErrors ErrVersion
;	WriteRegDWORD "HKLM" "${SW_Key}" "BuiVer" "${BUILD}"
;	IfErrors ErrVersion
;	DetailPrint "Version Info:			OK"
;	Goto GUID
;	ErrVersion:
;	DetailPrint "Version Info:			KO!"

;	GUID:
;	ClearErrors
;	ReadRegStr $0 "HKLM" "${SW_Key}" "GUID"
;	IfErrors +1 Inst
;	Call CreateGUID
;	Pop $0	;contains GUID
;	WriteRegStr "HKLM" "${SW_Key}" "GUID" $0
;	IfErrors ErrGUID
;	DetailPrint "GUID:				OK"
;	Goto Inst
;	ErrGUID:	
;	DetailPrint "GUID:				KO!"

	; Install type storage
;	Inst:
	WriteRegDWORD "HKLM" "${SW_Key}" "InstallType" $InstallType

	; Installed Languages
	WriteRegDWORD "HKLM" "${SW_Key}" "Languages" $LangFlags

	;Class:
	WriteRegStr "HKCR" ".bil" "" "bil_file"
	IfErrors ErrClass
	StrCmp $LANGUAGE ${LANG_ENGLISH} 0 +2
	WriteRegStr "HKCR" "bil_file" "" "Bilancio document"
	StrCmp $LANGUAGE ${LANG_ITALIAN} 0 +2
	WriteRegStr "HKCR" "bil_file" "" "$\"Documento di Bilancio$\""
	IfErrors ErrClass
	WriteRegStr "HKCR" "bil_file\DefaultIcon" "" "$INSTDIR\bilancio.exe,1"
	IfErrors ErrClass
	WriteRegStr "HKCR" "bil_file\Shell\Open\Command" "" "$\"$INSTDIR\bilancio.exe$\" $\"%1$\""
	IfErrors ErrClass
	DetailPrint "Class:				OK"
	DetailPrint ""
	Goto Version
	ErrClass:
	DetailPrint "Class:				KO!"
	DetailPrint ""
	Version:
	Call SaveInstallerVersion

	; Update HKCU registry for previous installations
	; v3.0
	ReadRegStr $0 "HKCU" "SOFTWARE\igiSW\Bilancio\3.0" "FirstRun"
	StrCmp $0 "" HKCUDone +1
	${COPY_REGISTRY_KEY} "HKCU" "SOFTWARE\igiSW\Bilancio\3.0" "HKCU" "${SW_Key}"
	Goto HKCUDone
	HKCUDone:
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\igiSW_Bilancio0300"
SectionEnd

Function SaveInstallerVersion
	WriteRegDWord "HKLM" "${SW_Key}" "InstallerVersion" "${REG_VER}"
FunctionEnd

Section "-Control Panel"
	;Control Panel
	DetailPrint "[CONTROL PANEL]"
	!ifdef ALPHA
		WriteRegStr HKLM Software\Microsoft\Windows\CurrentVersion\Uninstall\igiSW_Bilancio${MAJ_VER_str}${MIN_VER_str} DisplayName "Bilancio ${MAJ_VER_str}.${MIN_VER_str} alpha"
	!else
		!ifdef BETA
			WriteRegStr HKLM Software\Microsoft\Windows\CurrentVersion\Uninstall\igiSW_Bilancio${MAJ_VER_str}${MIN_VER_str} DisplayName "Bilancio ${MAJ_VER_str}.${MIN_VER_str} beta"
		!else
			WriteRegStr HKLM Software\Microsoft\Windows\CurrentVersion\Uninstall\igiSW_Bilancio${MAJ_VER_str}${MIN_VER_str} DisplayName "Bilancio ${MAJ_VER_str}.${MIN_VER_str}"
		!endif
	!endif
	IfErrors Err1
	DetailPrint "Registry key:			OK"
	GoTo Reg2
	Err1:
	DetailPrint "Registry key:			KO!"
	GoTo RegEnd
	Reg2:
	WriteRegStr HKLM Software\Microsoft\Windows\CurrentVersion\Uninstall\igiSW_Bilancio${MAJ_VER_str}${MIN_VER_str} UninstallString "$INSTDIR\Uninst.exe"
	IfErrors Err2
	DetailPrint "Uninstall key:			OK"
	GoTo Reg3
	Err2:
	DetailPrint "Uninstall key:			KO!"
	Reg3:
	WriteRegDWORD HKLM Software\Microsoft\Windows\CurrentVersion\Uninstall\igiSW_Bilancio${MAJ_VER_str}${MIN_VER_str} NoModify 1
	WriteRegStr HKLM Software\Microsoft\Windows\CurrentVersion\Uninstall\igiSW_Bilancio${MAJ_VER_str}${MIN_VER_str} ModifyPath "FALSE"
	WriteRegStr HKLM Software\Microsoft\Windows\CurrentVersion\Uninstall\igiSW_Bilancio${MAJ_VER_str}${MIN_VER_str} DisplayIcon "$INSTDIR\bilancio.exe"
	WriteRegStr HKLM Software\Microsoft\Windows\CurrentVersion\Uninstall\igiSW_Bilancio${MAJ_VER_str}${MIN_VER_str} Publisher "igiSW"
	WriteRegStr HKLM Software\Microsoft\Windows\CurrentVersion\Uninstall\igiSW_Bilancio${MAJ_VER_str}${MIN_VER_str} DisplayVersion "${MAJ_VER_str}.${MIN_VER_str}.${RELEASE_str}.${BUILD_str}"
	WriteRegStr HKLM Software\Microsoft\Windows\CurrentVersion\Uninstall\igiSW_Bilancio${MAJ_VER_str}${MIN_VER_str} URLInfoAbout "https://launchpad.net/bilancio"
	RegEnd:
	DetailPrint ""
SectionEnd

Section "-UI"
	;Uninstaller
	DetailPrint "[UNINSTALL]"
	WriteUninstaller $INSTDIR\Uninst.exe
	IfErrors Err1
;	Call ClearAutoLog
	DetailPrint "Uninstaller:			OK"
	GoTo Un2
	Err1:
;	Call ClearAutoLog
	DetailPrint "Uninstaller:			KO!"
	Un2:
	SetShellVarContext current
	;Call ClearAutoLog
	StrCmp $LANGUAGE ${LANG_ENGLISH} 0 +2
	CreateShortCut "$SMPROGRAMS\Bilancio\Uninstall.lnk" "$INSTDIR\Uninst.EXE"
	StrCmp $LANGUAGE ${LANG_ITALIAN} 0 +2
	CreateShortCut "$SMPROGRAMS\Bilancio\Disinstalla.lnk" "$INSTDIR\Uninst.EXE"
;	Call ClearAutoLog
	IfErrors Err2
	DetailPrint "Uninstall shortcut:		OK"
	Goto UIEnd
	Err2:
	DetailPrint "Uninstall shortcut:		KO!"
	UIEnd:
	DetailPrint ""
	Call SaveLOG
;	IntCmp $BilTrayInstalled 1 RunTray +1
;	Return
;	RunTray:
	Exec "$INSTDIR\biltray.exe"
SectionEnd

Section "Uninstall"
	SetAutoClose true
	;Shortcuts
	SetShellVarContext current
	Delete "$SMPROGRAMS\Bilancio\*"
	RMDir "$SMPROGRAMS\Bilancio"
;	Delete "$SMSTARTUP\Biltray.lnk"
	;Common files
;	Call un.UninstalligiLogo
	;Program
	SetOutPath "$TEMP"
	RMDir /r /REBOOTOK "$INSTDIR"
	;Classes
	DeleteRegKey HKCR ".bil"
	DeleteRegKey HKCR "bil_file"
	;Control Panel
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\igiSW_Bilancio${MAJ_VER_str}${MIN_VER_str}"
	MessageBox MB_OK $(Success)
SectionEnd

;Function ClearAutoLog
;	Push "1"
;	Call DeleteFromEnd
;FunctionEnd

Function ErrLOG
	Call SaveLOG
	Abort $(InstallKO)
FunctionEnd

Function SaveLOG
	GetTempFileName $0
	Push $0
	Call DumpLog
	IfFileExists "$INSTDIR\install.log" +1 Save
	Delete "$INSTDIR\install.log"
	Save:
	Rename $0 "$INSTDIR\install.log"
FunctionEnd

Function .onInit
	;Language selection dialog

	Push ""
	Push ${LANG_ENGLISH}
	Push English
	Push ${LANG_ITALIAN}
	Push Italiano
	Push A ; A means auto count languages
	       ; for the auto count to work the first empty push (Push "") must remain
	LangDLL::LangDialog "Installer Language" "Please select the language of the installer"

	Pop $LANGUAGE
	StrCmp $LANGUAGE "cancel" 0 +2
	Abort

	; Update HKLM registry for previous installations
	; v3.0
	ReadRegStr $0 "HKLM" "SOFTWARE\igiSW\Bilancio\3.0" "Path"
	StrCmp $0 "" UpdateDone +1
	${COPY_REGISTRY_KEY} "HKLM" "SOFTWARE\igiSW\Bilancio\3.0" "HKLM" "${SW_Key}"
	Goto UpdateDone

	UpdateDone:
	StrCpy $InstallType 0
	Call CheckInstallationParameters

;	Call CheckPrevInstallation	;To install patches only.
;	Pop $0
;	StrCmp $0 "Patched" +1 +3
;	MessageBox MB_OK $(PatchInstalled)
;	Quit
	Return
FunctionEnd

Function .onInstFailed
	MessageBox MB_OK $(InstallUncomplete)
	Quit
FunctionEnd

Function .onSelChange
	GetCurInstType $InstallType
FunctionEnd

Function un.onUninstFailed
	MessageBox MB_OK $(UninstallUncomplete)
	Quit
FunctionEnd

Function CheckInstallationParameters
	; Last installation path check
	ReadRegStr $0 "HKLM" "${SW_Key}" "Path"
	StrCmp $0 "" +1 AlreadyInstalled
	StrCpy $INSTDIR "$PROGRAMFILES\Bilancio"
	Goto Type
	AlreadyInstalled:
	StrCpy $INSTDIR $0

	; Last installation type check
	Type:
	ReadRegStr $0 "HKLM" "${SW_Key}" "InstallType"
	StrCmp $0 "" +1 RestoreType
	Return
	RestoreType:
	StrCpy $InstallType $0
FunctionEnd

;	Function CreateGUID
;		System::Call 'ole32::CoCreateGuid(g .s)'
;	FunctionEnd

Function ShowComp
	SetCurInstType $InstallType	; to be fixed
FunctionEnd
