/***************************************************************
 * Name:      bilancio.h
 * Purpose:   Code for Bilancio Application Class
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2017-01-08
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

#ifndef BILANCIOAPP_H
	#define BILANCIOAPP_H

	#ifdef __WXMSW__
			#include "../platformsetup.h"
	#endif // __WXMSW__

	class BilApp : public wxApp{
		private:
			// Non-GUI components
			wxSingleInstanceChecker *m_checker_bilancio;	// checks if another instance is already running
			#ifndef __WXMSW__
				void CheckTimerFire( wxTimerEvent& event );
			#endif // __WXMSW__
		public:
			// Routines
			virtual bool OnInit();
			int OnExit();
	};

	WXIMPORT wxLanguage FindLang(void);
	WXIMPORT void Error(/*wxFileConfig *INI,LANGID L,*/int Err,wxString Opt);
	WXIMPORT bool SplashActive(void);
	WXIMPORT bool TrayActive(void);
	WXIMPORT wxString GetShareDir(void);
	#ifdef _BIL_INSTALLEDUPDATE
		WXIMPORT bool GetCheckUpdates(void);
		WXIMPORT void fnCheckUpdate(void);
	#endif // _BIL_INSTALLEDUPDATE

	#ifdef __WXGTK__
		WXIMPORT wxString GetUserConfigDir(void);
	#endif // __WXGTK__

#endif
