#ifndef TIMEDATASET_H_INCLUDED
#define TIMEDATASET_H_INCLUDED

#include <wx/axis/dateaxis.h>
#include <wx/xy/xylinerenderer.h>

class TimeSeriesDataset:public XYDataset, public DateTimeDataset{
	//DECLARE_CLASS(TimeSeriesDataset)
public:
	TimeSeriesDataset(double *data, time_t *times, size_t count);
	virtual ~TimeSeriesDataset();
	virtual size_t GetSerieCount();
	virtual wxString GetSerieName(size_t serie);
	virtual size_t GetCount(size_t serie);
	virtual double GetX(size_t index, size_t serie);
	virtual double GetY(size_t index, size_t serie);
	virtual DateTimeDataset *AsDateTimeDataset();
	virtual time_t GetDate(size_t index);
	virtual size_t GetCount();
private:
	double *m_data;
	time_t *m_times;
	size_t m_count;
};
//IMPLEMENT_CLASS(TimeSeriesDataset, XYDataset)

#endif // TIMEDATASET_H_INCLUDED
