/***************************************************************
 * Name:      dataconverter.h
 * Purpose:   convertion Code for Bilancio Application Class
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2016-11-01
 * Copyright: Igor Calì (http://igisw-bilancio.sourceforge.net/)
 * License:		GNU
 **************************************************************/

#ifndef DATACONVERTER_H
#define DATACONVERTER_H

#ifndef WX_PRECOMP
	#include <wx/wx.h>
#else
	#include <wx/wxprec.h>
#endif

#if(! wxCHECK_VERSION(3,0,0))
	#include <wx/datetime.h>
	#include <wx/filename.h>
#endif

#include "../bil31core.h"

class dataconverter : public TData
{
	public:
		/** Default constructor */
		dataconverter(void);
		/** Default destructor */
		//virtual ~dataconverter();
		wxString LoadFromFile_0301(wxString AName, bool App);
		bool AddOper_0301(wxDateTime D, wxDateTime O, TOpType T, wxString V, wxString M, wxString N);

		wxString LoadFromFile_0302(/*bool Auto, */wxString AName, /*wxString F, */bool App);
		void BuildDatabase(int num_funds, int num_credits, int num_debits, int num_loans, int num_borrows, int num_transactions,
																	 int num_categories, int num_shoplists, wxString defaultFund);

		#ifdef _BIL_OLDFORMATSAVE_FEATURE
			bool SaveToFile_0301(bool Auto,bool Archive, wxString AFile,wxString F);
			bool SaveToFile_0302(bool Auto, bool Archive, wxString AFile);
		#endif // _BIL_OLDFORMATSAVE_FEATURE

	protected:

	private:
		wxDateTime Bil_StrToTime(wxString S);
		#if (wxCHECK_VERSION(3, 0, 0) )
			bool SubstLocaleDecimalSeparator(wxString &S,char ToSub);
		#endif
		//wxString DoubleQuote(wxString S);
		wxString Crip(wxString S);
};

/*
// Calls to module igilogo
WXIMPORT wxString iUpperCase(wxString S);
*/
extern wxString iUpperCase(wxString S);
extern wxString DoubleQuote(wxString S);
#endif // DATACONVERTER_H

