/***************************************************************
 * Name:      bil31opt.cpp
 * Purpose:   Code for Bilancio Application Class
 * Author:    Igor Cal (igor.cali0@gmail.com)
 * Created:   2017-01-11
 * Copyright: Igor Cal (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

#ifndef BIL31OPT_CPP_INCLUDED
#define BIL31OPT_CPP_INCLUDED

#ifndef WX_PRECOMP
	#include <wx/wx.h>
#else
	#include <wx/wxprec.h>
#endif

#include "bil31opt.h"

#if(! wxCHECK_VERSION(3, 0, 0))
	#include <wx/filename.h>    // For wxFileName
#endif	// wxCHECK_VERSION

#ifdef __WXMSW__
  #ifdef _BIL_USEREGISTRY
    #include <wx/msw/registry.h>
  #endif // _BIL_USEREGISTRY
  //extern wxString SWKey;
#else
  extern wxFileConfig *INI;
#endif // __WXMSW__

#ifdef __BORLANDC__
	#pragma hdrstop
	#pragma package(smart_init)
#endif

TOpt::TOpt(void){
	SuccessfulCreated=false;
	//LogStrings=new String[15];
	LogStrings=new wxArrayString();
	LogStrings->Clear();
	for(int i=0;i<15;i++)LogStrings->Add(wxEmptyString);
#ifdef _BIL_USEREGISTRY
#ifdef __WXMSW__
  SWKey = "SOFTWARE\\igiSW\\Bilancio\\3.1";   // root registry key
	wxRegKey *K=new wxRegKey(wxRegKey::HKLM,SWKey,wxRegKey::WOW64ViewMode_Default);
	if(K->HasValue("Path"))K->QueryValue("Path",InstallationPath);
	if(InstallationPath.IsEmpty()){
		Error(/*INI,Lan,*/6,wxEmptyString);
		delete K;
		wxTheApp->ExitMainLoop();
		return;}
#endif
#endif // _BIL_USEREGISTRY
	///*InstConv=*/InstWiz=InstTray=InstUpdate=false;	// DON'T REMOVE - May be restore with new Product version
	//if(K->ValueExists("Conv"))InstConv=K->ReadBool("Conv");	// DON'T REMOVE - May be restore with new Product version
#ifdef __WXMSW__
#ifdef _BIL_USEREGISTRY
/*
	if(K->HasValue("Wiz"))K->QueryValue("Wiz",&InstWiz);
	if(K->HasValue("Tray"))K->QueryValue("Tray",&InstTray);
	if(K->HasValue("Update"))K->QueryValue("Update",&InstUpdate);
*/
#endif // _BIL_USEREGISTRY
#else
	//wxFileConfig *ini=new wxFileConfig(wxEmptyString,wxEmptyString,L"bilancio.ini",wxEmptyString,wxCONFIG_USE_GLOBAL_FILE,wxConvAuto());
/*
	ini->SetPath(L"/Optional Modules");
	if(ini->HasEntry(L"Wiz"))InstWiz=ini->Read(L"Wiz",0l);
	if(ini->HasEntry(L"Tray"))InstTray=ini->Read(L"Tray",0l);
	if(ini->HasEntry(L"Update"))InstUpdate=ini->Read(L"Update",0l);
*/
#endif

/* TODO -cEnhancement : Preparation for future enhancement */
/*
#ifdef __WXMSW__
	TVersion instVer=GetInstalledVersion();
	TVersion lrVer=GetLastRunVersion();
	if(instVer.Maj>lrVer.Maj)goto Update;
	else if(instVer.Min>lrVer.Min)goto Update;
	else if(instVer.Rel>lrVer.Rel)goto Update;
	else if(instVer.Bui>lrVer.Bui)goto Update;
	else goto NoUpdate;
	Update:{
#endif
*/
/* TODO -cEnhancement : Preparation for future enhancement */
/*
#ifdef __WXMSW__
#ifdef _BIL_USEREGISTRY

		// __________________________________________________________
		K->SetValue("MajVer_lr",instVer.Maj);
		K->SetValue("MinVer_lr",instVer.Min);
		K->SetValue("RelVer_lr",instVer.Rel);
		K->SetValue("BuiVer_lr",instVer.Bui);
#endif // _BIL_USEREGISTRY
#else

		// __________________________________________________________
		INI->SetPath(L"/Version lr");
		INI->Write(L"MajVer_lr",instVer.Maj);
		INI->Write(L"MinVer_lr",instVer.Min);
		INI->Write(L"RelVer_lr",instVer.Rel);
		INI->Write(L"BuiVer_lr",instVer.Bui);
    INI->Flush();
    //delete INI;
#endif
#ifdef __WXMSW__
  }
	NoUpdate:
#endif
*/

#ifdef __WXMSW__
#ifdef _BIL_USEREGISTRY
	//delete K;
	//Key=_T("HKEY_CURRENT_USER\\SoftWare\\igiSW\\Bilancio");
	K->SetName(wxRegKey::HKCU,SWKey);
	K->Create(true);
	// First run check
	if(K->HasValue("FirstRun"))K->QueryValue("FirstRun",&FirstRunEver);
	else FirstRunEver=true;
	// General tab
	K->SetName(wxRegKey::HKCU,SWKey+"\\General");
	K->Create(true);
	/*
	K->RootKey=HKEY_LOCAL_MACHINE;
	K->RootKey=HKEY_CURRENT_USER; // Necessary to reset KeyPath
	*/
	//K=new wxRegKey(Key);
	if(K->HasValue("AutoOpen"))K->QueryValue("AutoOpen",&GAutoOpen);
	else{
		K->SetValue("AutoOpen",false);
		GAutoOpen=false;}
	//if(!GAutoOpen)goto NoFile;

	/*
	if(K->HasValue("LastFile"))K->QueryValue("LastFile",GLastFile);
	else GLastFile=wxEmptyString;
	*/

	//NoFile:

	if(K->HasValue("Default")){
		K->QueryValue("Default",GDDoc);
		if(!GDDoc.IsEmpty())if(!::wxFileExists(GDDoc))GDDoc==wxEmptyString;}
	else GDDoc=wxEmptyString;

	bool docdir_set = false;
	if(K->HasValue("Docs"))K->QueryValue("Docs",GDoc_folder);
	else{
		if(! GDDoc.IsEmpty()){

			wxString Path;
			::wxFileName::SplitPath(GDDoc, NULL, &Path, NULL, NULL, wxPATH_NATIVE);
			if(::wxFileName::DirExists(Path)){
				K->SetValue(L"Docs", Path);
				GDoc_folder = Path;
				docdir_set = true;}}
		if(! docdir_set){
			GDoc_folder = GetOSDocDir();
			K->SetValue("Docs", GDoc_folder);
		}
	}

	GMaster_db = wxEmptyString;
	if(K->HasValue("MasterDB"))K->QueryValue("MasterDB", GMaster_db);
	if(GMaster_db.IsEmpty()){
		if(! GDoc_folder.IsEmpty()){
			GMaster_db = GDoc_folder + "\\bilancio_master.bildb";
			K->SetValue("MasterDB", GMaster_db);
		}
	}

	if(K->HasValue("Bar"))K->QueryValue("Bar",&GBar);
	else{
		K->SetValue("Bar",true);
		GBar=true;}
	if(K->HasValue("Splash"))K->QueryValue("Splash",&GSplash);
	else{
		K->SetValue("Splash",true);
		GSplash=true;}
	if(K->HasValue("Conv"))K->QueryValue("Conv",&GConv);
	else{
		K->SetValue("Conv",false);
		GConv=false;}
	if(K->HasValue("Icon"))K->QueryValue("Icon",&GIcon);
	// Chart tab
	K->SetName(wxRegKey::HKCU,SWKey+"\\Charts");
	K->Create(true);
	if(K->HasValue("Trend"))K->QueryValue("Trend",&CTrendGraph);
	else {
		K->SetValue("Trend",true);
		CTrendGraph=true;}
	if(K->HasValue("Fund"))K->QueryValue("Fund",&CFundGraph);
	else{
		K->SetValue("Fund",true);
		CFundGraph=true;}
	// Strings tab
	K->SetName(wxRegKey::HKCU,SWKey+"\\Strings");
	K->Create(true);
	for(int i=0;i<15;i++)ReadLogString(K,/*INI,*/i);
	//delete Ini;

	#ifdef _BIL_INSTALLEDUPDATE
    // Advanced tab
    K->SetName(wxRegKey::HKCU,SWKey+"\\Advanced");
    K->Create(true);
    if(K->HasValue("NewVersionCheck"))K->QueryValue("NewVersionCheck",&CheckUpdates);
    else{
      K->SetValue("NewVersionCheck",false);
      CheckUpdates=false;}
  #endif // _BIL_INSTALLEDUPDATE

	// External tools tab
	Tools=new wxArrayString();
	Tools->Clear();
	K->SetName(wxRegKey::HKCU,SWKey+"\\Tools");
	K->Create(true);
	if(K->Open(wxRegKey::Read)){
		long ind = 1;
		wxString t;
		wxString strTemp;
		wxArrayString *Tls=new wxArrayString();
		size_t nSubValues;
		K->GetKeyInfo(NULL,NULL,&nSubValues,NULL);
		K->GetFirstValue(strTemp, ind);
		for(unsigned int i=0;i<nSubValues;i++){
			Tls->Add(strTemp,1);
			K->GetNextValue(strTemp, ind);}
		for(unsigned int j=0;j<Tls->Count();j++){
			K->QueryValue(Tls->Item(j),t);
			if(::wxFileExists(t))Tools->Add(t,1);}
		Tls->Clear();
    delete Tls;}
	SuccessfulCreated=true;
	delete K;
#endif // _BIL_USEREGISTRY
#else
	//ini=new wxFileConfig(wxEmptyString,wxEmptyString,L"bilancio.ini",wxEmptyString,wxCONFIG_USE_LOCAL_FILE,wxConvAuto());
	// First run check
	INI->SetPath(L"/Tools");
  if(INI->HasEntry(L"FirstRun"))FirstRunEver=INI->Read(L"FirstRun",0l);
	else FirstRunEver=true;

	INI->SetPath(L"/General");
	/*
	if(INI->HasEntry(L"AutoOpen"))GAutoOpen=INI->Read(L"AutoOpen",0l);
	else{
		INI->Write(L"AutoOpen",false);
		GAutoOpen=false;}
	//if(!GAutoOpen)goto NoFile;
	if(INI->HasEntry(L"LastFile"))GLastFile=INI->Read(L"LastFile",wxEmptyString);
	else GLastFile=wxEmptyString;
	*/

	if(INI->HasEntry(L"Default")){
	  GDDoc=INI->Read(L"Default",wxEmptyString);
		if(!GDDoc.IsEmpty())if(!::wxFileExists(GDDoc))GDDoc==wxEmptyString;}
	else GDDoc=wxEmptyString;

	bool docdir_set = false;
	if(INI->HasEntry(L"Docs")) GDoc_folder = INI->Read(L"Docs",wxEmptyString);
	else{
		if(! GDDoc.IsEmpty()){
			wxString Path;
			::wxFileName::SplitPath(GDDoc, NULL, &Path, NULL, NULL, wxPATH_NATIVE);
			if(::wxFileName::DirExists(Path)){
				INI->Write(L"Docs", Path);
				GDoc_folder = Path;
				docdir_set = true;}}
		if(! docdir_set){
			GDoc_folder = GetOSDocDir();
			INI->Write(L"Docs", GDoc_folder);
		}
	}

	GMaster_db = wxEmptyString;
	if(INI->HasEntry(L"MasterDB"))GMaster_db = INI->Read(L"MasterDB", wxEmptyString);
	if(GMaster_db.IsEmpty()){
		#ifdef __WXGTK__
			wxString usr_data_dir;
			wxGetEnv(L"XDG_DATA_HOME",&usr_data_dir);
			if(usr_data_dir.IsEmpty()) usr_data_dir = wxGetHomeDir() + L"/.local/share";
			usr_data_dir += L"/bilancio";
			GMaster_db = usr_data_dir + L"/bilancio_master.bildb";
			if(! wxDirExists(usr_data_dir)){
				wxFileName::Mkdir(usr_data_dir, 0777, wxPATH_MKDIR_FULL);
				wxString old_file = GDoc_folder + L"/bilancio_master.bildb";
				if(wxFileExists(old_file)) wxRenameFile(old_file, GMaster_db, false);
			}
			INI->Write(L"MasterDB", GMaster_db);
		#else
			if(! GDoc_folder.IsEmpty()){
				GMaster_db = GDoc_folder + L"/bilancio_master.bildb";
				INI->Write(L"MasterDB", GMaster_db);
			}
		#endif // __WXGTK__
	}

	if(INI->HasEntry(L"Bar"))GBar=INI->Read(L"Bar",1l);
	else{
		INI->Write(L"Bar",true);
		GBar=true;}
	if(INI->HasEntry(L"Splash"))GSplash=INI->Read(L"Splash",1l);
	else{
		INI->Write(L"Splash",true);
		GSplash=true;}
	if(INI->HasEntry(L"Conv"))GConv=INI->Read(L"Conv",0l);
	else{
		INI->Write(L"Conv",false);
		GConv=false;}
	if(INI->HasEntry(L"Icon"))GIcon=INI->Read(L"Icon",0l);
	else{
		INI->Write(L"Icon",false);
		GIcon=false;}

	// TODO (igor#1#): To be restored when SQL encryption is available
	/*
	// Password check;
	INI->SetPath(L"/Security");
  if(INI->HasEntry(L"Key")) pwd = INI->Read(L"Key", wxEmptyString);
	else pwd = wxEmptyString;
	*/

	// Chart tab
	INI->SetPath(L"/Charts");
	if(INI->HasEntry(L"Trend"))CTrendGraph=INI->Read(L"Trend",1l);
	else {
		INI->Write(L"Trend",true);
		CTrendGraph=true;}
	if(INI->HasEntry(L"Fund"))CFundGraph=INI->Read(L"Fund",1l);
	else{
		INI->Write(L"Fund",true);
		CFundGraph=true;}
	// Strings tab
	INI->SetPath(L"/LogStrings");
	for(int i=0;i<15;i++)ReadLogString(INI,i);

	#ifdef _BIL_INSTALLEDUPDATE
    // Advanced tab
    INI->SetPath("/Advanced");
    if(INI->HasEntry(L"NewVersionCheck")) CheckUpdates = INI->Read(L"NewVersionCheck", 0l);
    else{
      INI->Write(L"NewVersionCheck", false);
      CheckUpdates = false;}
  #endif // _BIL_INSTALLEDUPDATE

	// External tools tab
	Tools=new wxArrayString();
	Tools->Clear();
	INI->SetPath(L"/Tools");
	#ifdef __WXMSW__
    unsigned int entries;
	#else
    uint entries;
  #endif // __WXMSW__
  entries=INI->GetNumberOfEntries(false);
	long ind = 1;
	wxString strTemp;
	wxArrayString *Tls=new wxArrayString();
	INI->GetFirstEntry(strTemp, ind);
  for(unsigned int i=0;i<entries;i++){
		Tls->Add(strTemp,1);
    INI->GetNextEntry(strTemp, ind);}
	for(unsigned int j=0;j<Tls->Count();j++){
		strTemp=INI->Read(Tls->Item(j),wxEmptyString);
		if(::wxFileExists(strTemp))Tools->Add(strTemp,1);}
	Tls->Clear();
  delete Tls;
	SuccessfulCreated=true;
	INI->Flush();
	//delete INI;
#endif // __WXMSW__
}

/*void TOpt::LastFile(wxString Name){
#ifdef __WXMSW__
#ifdef _BIL_USEREGISTRY
	wxString Key="HKEY_CURRENT_USER\\";
	Key=Key+SWKey;
	Key=Key+"\\General";
	wxRegKey *K=new wxRegKey(Key);
	if(K->Open(wxRegKey::Read))
		K->SetValue("LastFile",Name);
	delete K;
	GLastFile=Name;
#endif // _BIL_USEREGISTRY
#else
	//wxFileConfig *ini=new wxFileConfig(wxEmptyString,wxEmptyString,L"bilancio.ini",wxEmptyString,wxCONFIG_USE_LOCAL_FILE,wxConvAuto());
	INI->SetPath(L"/General");
	INI->Write(L"LastFile",Name);
	INI->Flush();
	GLastFile=Name;
	//delete ini;
#endif
}
*/

TOpt::~TOpt(){
	LogStrings->Clear();
	delete LogStrings;
	Tools->Clear();
	delete Tools;}

bool TOpt::SetDefaultDoc(wxString Doc){
#ifdef __WXMSW__
#ifdef _BIL_USEREGISTRY
  GDDoc=Doc;
	wxString Key="HKEY_CURRENT_USER\\"+SWKey+"\\General";
	wxRegKey *K=new wxRegKey(Key);
	K->Open(wxRegKey::Write);
	K->SetValue("Default", /*GDDoc*/ Doc);
  delete K;
#endif // _BIL_USEREGISTRY
#else
	//wxFileConfig *ini=new wxFileConfig(wxEmptyString,wxEmptyString,L"bilancio.ini",wxEmptyString,wxCONFIG_USE_LOCAL_FILE,wxConvAuto());
	INI->SetPath(L"/General");
  INI->Write(L"Default", /*GDDoc*/ Doc);
  INI->Flush();
  //delete ini;
#endif
  return true;}

#ifdef __WXMSW__
#ifdef _BIL_USEREGISTRY
void TOpt::ReadLogString(wxRegKey *Key, int S){
	wxString RegString="S";
	wxString value;
	if(S<10)RegString+="0";
	RegString+=::wxString::Format("%d",S);
	if(Key->HasValue(RegString)){
		Key->QueryValue(RegString,value);
		LogStrings->Item(S)=value;}
	else{
		//F->SetPath(L"/LogStrings");
		//F->Read(RegString+"_String",&value,RegString+"_String");
		switch(S){
			case 0:
				value=_("Total");
				break;
			case 1:
				value=_("Profit");
				break;
			case 2:
				value=_("Expense");
				break;
			case 3:
				value=_("New credit");
				break;
			case 4:
				value=_("Removed credit");
				break;
			case 5:
				value=_("Condoned credit");
				break;
			case 6:
				value=_("New debt");
				break;
			case 7:
				value=_("Removed debt");
				break;
			case 8:
				value=_("Condoned debt");
				break;
			case 9:
				value=_("Received object");
				break;
			case 10:
				value=_("Given object");
				break;
			case 11:
				value=_("Lent object");
				break;
			case 12:
				value=_("Object got back");
				break;
			case 13:
				value=_("Borrowed object");
				break;
			case 14:
				value=_("Object given back");
				break;
      default:
        value=wxEmptyString;}
		Key->SetValue(RegString,value);
		LogStrings->operator[](S)=RegString+"_String";}}
#endif // _BIL_USEREGISTRY
#else
void TOpt::ReadLogString(wxFileConfig *Key, int S){
	wxString RegString=L"S";
	wxString value;
	if(S<10)RegString+=L"0";
	#ifdef __WXMSW__
    RegString+=::wxString::Format("%d",S);
  #else
    RegString+=::wxString::Format(L"%d",S);
  #endif // __WXMSW__
	if(Key->HasEntry(RegString)){
		value=Key->Read(RegString,wxEmptyString);
		LogStrings->Item(S)=value;}
	else{
		/*F*/Key->SetPath(L"/LogStrings");
		switch(S){
			case 0:
				value=_("Total");
				break;
			case 1:
				value=_("Profit");
				break;
			case 2:
				value=_("Expense");
				break;
			case 3:
				value=_("New credit");
				break;
			case 4:
				value=_("Removed credit");
				break;
			case 5:
				value=_("Condoned credit");
				break;
			case 6:
				value=_("New debt");
				break;
			case 7:
				value=_("Removed debt");
				break;
			case 8:
				value=_("Condoned debt");
				break;
			case 9:
				value=_("Received object");
				break;
			case 10:
				value=_("Given object");
				break;
			case 11:
				value=_("Lent object");
				break;
			case 12:
				value=_("Object got back");
				break;
			case 13:
				value=_("Borrowed object");
				break;
			case 14:
				value=_("Object given back");
				break;
      default:
        value=wxEmptyString;}
		Key->Write(RegString,value);
		LogStrings->operator[](S)=/*RegString+L"_String"*/value;}}
#endif

void TOpt::FirstRunDone(void){
#ifdef __WXMSW__
#ifdef _BIL_USEREGISTRY
	//wxString Key="HKEY_CURRENT_USER\\Software\\igiSW\\Bilancio";
	//wxRegKey *K=new wxRegKey(Key);
	wxRegKey *K=new wxRegKey(wxRegKey::HKCU,SWKey,wxRegKey::WOW64ViewMode_Default);
	K->Open(wxRegKey::Write);
	K->SetValue("FirstRun",false);
	delete K;
#endif // _BIL_USEREGISTRY
#else
	//wxFileConfig *ini=new wxFileConfig(wxEmptyString,wxEmptyString,L"bilancio.ini",wxEmptyString,wxCONFIG_USE_LOCAL_FILE,wxConvAuto());
	INI->SetPath(L"/Tools");
	INI->Write(L"FirstRun",false);
	INI->Flush();
	//delete ini;
#endif
}

// TODO (igor#1#): To be restored when SQL encryption is available
/*
bool TOpt::SetKey(wxString key){
	#ifdef __WXMSW__

	#else
		INI->SetPath(L"/Security");
		INI->Write(L"Key", key);
		INI->Flush();
	#endif
	return true;
}
*/

#endif // BIL31OPT_CPP_INCLUDED
