/***************************************************************
 * Name:      bil30opt.h
 * Purpose:   Code for Bilancio Application Class
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2016-08-25
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

#ifndef Bil31OptH
#define Bil31OptH

#ifndef WX_PRECOMP
	#include <wx/wx.h>
#else
	#include <wx/wxprec.h>
#endif

//#include <wx/string.h>
#include <wx/fileconf.h> // For wxFileConfig

#ifdef __WXMSW__
	#include "../platformsetup.h"
  #ifdef _BIL_USEREGISTRY
    #include <wx/msw/registry.h> // For wxRegKey
  #endif // _BIL_USEREGISTRY
#endif

#include "../types.h"
//#include "constants.h"

#ifdef __BORLANDC__
	//#include <Registry.hpp>
#endif

class TOpt
{
//private:
public:
	bool SuccessfulCreated;     // true if Option are properly created
	// HKLM Options
	#ifdef __WXMSW__
		wxString SWKey;
		wxString InstallationPath;    // Program Folder
  #endif
	//bool InstConv;              // true if Conv utility is installed	// DON'T REMOVE - May be restore with new Product version
	//long InstWiz;     				  // true if Wizard utility is installed
	//long InstTray;              // true if BilTray utility is installed
	//long InstUpdate;						// true if Update utility is installed
	// HKCU Options
	long FirstRunEver;          // Very first launch of application;
	//bool FirstRunCurrVersion;   // First lauch of new version;
                              // Preparation for future updates
	long GAutoOpen;             // Automatic opening of last used file
	//wxString GLastFile;           // Latest opened document
	wxString	GDoc_folder,			// Document default folder
						GDDoc,						// Default document
						GMaster_db;				// Master database
	long GBar;                  // Toolbar display
	long GSplash;               // Show Splash-screen
	long GConv;                 // Automatic report export in text on new months
	long GIcon;                 // Open TrayIcon on exit
	long CTrendGraph;           // Trend Graph display
	long CFundGraph;						// Fund Pie display
	#ifdef _BIL_INSTALLEDUPDATE
		long CheckUpdates;					// Verify new version availability in the web
	#endif // _BIL_INSTALLEDUPDATE
	wxArrayString *LogStrings;
	wxArrayString *Tools;

	//wxString pwd;								// database password	// TODO (igor#1#): To be restored when SQL encryption is available

	TOpt(void);

	//void LastFile(wxString Name);
	bool SetDefaultDoc(wxString Doc);
	void SetCurrSymbol(void);
    #ifdef __WXMSW__
        #ifdef _BIL_USEREGISTRY
            void ReadLogString(wxRegKey *Key, int S);
        #endif // _BIL_USEREGISTRY
    #else
        void ReadLogString(wxFileConfig *Key, int S);
    #endif
	void FirstRunDone(void);

	//bool SetKey(wxString key);	// TODO (igor#1#): To be restored when SQL encryption is available

	~TOpt();
};

#ifdef __WXMSW__
  // Calls to module igiBil
  WXIMPORT TVersion GetInstalledVersion(void);
  WXIMPORT TVersion GetLastRunVersion(void);
  // Calls to module igiBErr.DLL
  WXIMPORT void Error(/*wxFileConfig *INI,LANGID L,*/int Err,wxString Opt);
#endif
WXIMPORT wxString GetOSDocDir(void);

#endif


