/***************************************************************
 * Name:      BilTrayApp.h
 * Purpose:   Defines Application Class
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2017-01-08
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License: GNU
 **************************************************************/

#ifndef BILTRAYAPP_H
	#define BILTRAYAPP_H

	#include <wx/app.h>
	#include <wx/taskbar.h>
	#include <wx/timer.h>
	#include <vector>

	#include "../types.h"
	#include "datawithalarms.h"

	class MyTaskBarIcon: public wxTaskBarIcon
	{
	private:
		/*
		std::vector<wxIcon>::const_iterator currentIcon;
		std::vector<wxIcon> icons;
		*/
		void ToggleAct(wxCommandEvent& event);
		void RunBilClick(wxCommandEvent& event);
		void OptionsClick(wxCommandEvent& event);
		//void AuthorClick(wxCommandEvent& event);
		//void DonateClick(wxCommandEvent& event);
	protected:
		enum
		{
			bilAct = 1000,
			bilRun,
			bilOpt,
			bilAut,
			bilDon,
			bilExi
		};
	public:
		bool Act; // Active
		//bool Animated;
		bool ringing;	// true when user input is requested
		wxMenu *menu;
		//wxTimer AnimTimer;
		MyTaskBarIcon();
		virtual wxMenu *CreatePopupMenu();
		//void Anim(/*wxTimerEvent& event*/void);
		void ExitClick(wxCommandEvent& event);
	DECLARE_EVENT_TABLE();
	};

	class BilTrayApp : public wxApp
	{
		private:
			#ifdef _BIL_USEUNITY
				bool	isUnity,					// true when active desktop is Unity
							Act,							// Enable status
							indicator_killed;	// true when KillIndicator routine is processed for the first time
				void SendStatus(void);
				void KillIndicator(long cmd);
			#endif // _BIL_USEUNITY
			MyTaskBarIcon *Tray;
			void DoChecks(void);
			void CheckTimerFire();
		public:
			virtual bool OnInit();
			void TimerFire(wxTimerEvent& event);
			int OnExit();
	};

	WXIMPORT wxLanguage FindLang(void);
	WXIMPORT wxString GetDefaultDocument(void);
	WXIMPORT bool ShowOptionsDialog(void);

	/*
	#ifndef __WXMSW__
		WXIMPORT void DonateWindow(void);
	#else
		WXIMPORT void DonateWindow(wxString Path);
	#endif
	*/

	WXIMPORT wxString GetShareDir(void);

	#ifdef __WXGTK__
		WXIMPORT wxString GetUserConfigDir(void);
	#endif // __WXGTK__

#endif // BILTRAYAPP_H
