/***************************************************************
 * Name:      wiz.h
 * Purpose:   Code for Bilancio Application Class
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2014-06-29
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

#include "wxwizard.h"

#ifndef WizH
#define WizH

#include <wx/string.h>

#ifndef WX_PRECOMP
	#include <wx/wx.h>
#else
	#include <wx/wxprec.h>
#endif

#ifdef __BORLANDC__
	/*
	#include <SysUtils.hpp>	// eliminare
	#include <Windows.hpp>	// eliminare
	#include <Messages.hpp>	// eliminare
	#include <Classes.hpp>	// eliminare
	#include <Graphics.hpp>	// eliminare
	#include <Controls.hpp>	// eliminare
	#include <StdCtrls.hpp>	// eliminare
	#include <ExtCtrls.hpp>	// eliminare
	#include <Forms.hpp>	// eliminare
	#include <ComCtrls.hpp>	// eliminare
	*/
#endif

class TWizard : public wxTWiz
{
/*
__published:
	TButton *ForwardBtn;
	TButton *BackBtn;
	TButton *CancelBtn;
	TPageControl *PageControl;
	TTabSheet *TabSheet1;
	TTabSheet *TabSheet2;
	TTabSheet *TabSheet3;
	TTabSheet *End_Sheet;
	TTabSheet *Wel_Sheet;
	TLabel *WelcomeText;
	TLabel *SavedLabel;
	TEdit *SavedEdit;
	TLabel *CashLabel;
	TEdit *CashEdit;
	TEdit *DocEdit;
	TButton *BrowseButton;
	TLabel *DocLabel;
	TCheckBox *DefaultBox;
	TLabel *FinishLabel;
*/
private:
	// GUI components
	Wel_Sheet *Wel_SheetP;
	End_Sheet *End_SheetP;

	// Non-GUI components
	bool UserChange;

	// Routines
	//void PageControlChanging(bool &AllowChange);
protected:
	void BackBtnClick(wxCommandEvent& event);
	void ForwardBtnClick(wxCommandEvent& event);
	void DisablePageChange(wxNotebookEvent& event);
public:
	// GUI components
	Saved_Sheet *Saved_SheetP;
	Cash_Sheet *Cash_SheetP;
	Doc_Sheet *Doc_SheetP;
	// Routines
	/*virtual*/ TWizard(wxWindow* parent);
};

WXIMPORT wxString CheckValue(wxString Val);
WXIMPORT void Error(int Err,wxString Opt);
WXIMPORT wxString GetOSDocDir(void);

#endif
