/***************************************************************
 * Name:      igibil.cpp
 * Purpose:   Code for Library Class
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2017-01-09
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License: GNU
 **************************************************************/

#ifndef IGIBIL_CPP_INCLUDED
	#define IGIBIL_CPP_INCLUDED

		#ifndef WX_PRECOMP
			#include <wx/wx.h>
		#else
			#include <wx/wxprec.h>
		#endif

	#ifndef __BILCONVERT_BIN__
		#include <wx/string.h>
		#include <wx/filename.h>
		#include <wx/fileconf.h> // For wxFileConfig
		#include <wx/dlimpexp.h>
		#include <wx/stdpaths.h> // For wxStandardPathsBase
	#endif // __BILCONVERT_BIN__

	#include "../platformsetup.h"

	extern wxString ShareDir;

	#ifndef __BILCONVERT_BIN__
		#if _BIL_HASNATIVEABOUT == 1
			#include <wx/aboutdlg.h>
		#endif // _BIL_HASNATIVEABOUT == 1

		#ifdef __WINDOWS__
		#ifdef _BIL_USEREGISTRY
			#include <wx/msw/registry.h> // For wxRegKey
		#endif // _BIL_USEREGISTRY
		#else
			//#include <wx/fileconf.h>  // For wxFileConfig
			#include <wx/intl.h>  // For wxLocale
		#endif

		#include <wx/datetime.h>	// For wxDateTime_t
		/*	// DON'T REMOVE - May be restored with new Product version
		#include <wx/utils.h>	// For wxSleep
		#include <wx/gdicmn.h>	// For wxSetCursor
		*/
		#include <wx/dynlib.h>	// For wxDynamicLibrary

		//#include "types.h"
		//#include "constants.h"
		#include "igibil.h"
		//#include "igilogoapp.h"
		//#include "../productversion.h"

		#ifndef __WXMSW__
		#include "../../rsrc/icons/Icon_Application.xpm"
		#endif

		#ifdef __BORLANDC__
			#pragma hdrstop
		#endif

	extern wxFileConfig *INI;
	extern wxString DataDir;

	extern wxString ProductName;
	extern wxString LongVersion;
	extern wxString Copyright;
	extern wxString WebAddress;
	extern wxString BugAddress;
	extern wxString DonateAddress;
	extern wxString freechart_version;
	#ifdef _BIL_INSTALLEDUPDATE
		extern int MajorVersion;
		extern int MinorVersion;
		extern int ReleaseVersion;
		extern char __BUILD_NUMBER;
		extern char   __BUILD_DATE;
		extern wxString VersionFile;
		extern wxString ShortVersion;
	#endif // _BIL_INSTALLEDUPDATE
	#endif // __BILCONVERT_BIN__

	wxString CheckValue(wxString Val){
		// NOTE (igor#1#): Do not remove: this function returns an error if the wrong decimal separator is entered
		double p=0;
		wxString Str=Val;
		if(Str.ToDouble(&p))return Str;
		return wxEmptyString;}

	wxString FormDigits(double Val){
		wxString Ret;
		return Ret.Format(L"%#.2hf",Val);}

	wxString IntToMonth(int M){
		/*
		wxString Ret;
		switch(M){
			case 1:
			Ret=_("January");
			break;
			case 2:
			Ret=_("February");
			break;
			case 3:
			Ret=_("March");
			break;
			case 4:
			Ret=_("April");
			break;
			case 5:
			Ret=_("May");
			break;
			case 6:
			Ret=_("June");
			break;
			case 7:
			Ret=_("July");
			break;
			case 8:
			Ret=_("August");
			break;
			case 9:
			Ret=_("September");
			break;
			case 10:
			Ret=_("October");
			break;
			case 11:
			Ret=_("November");
			break;
			case 12:
			Ret=_("December");
			break;
			default:Ret=wxEmptyString;}
		return Ret;
		*/
		// M: 1-based month

		if((0 < M) || (M < 13)){
			wxString month_name = wxDateTime::GetMonthName((wxDateTime::Month) (M - 1));
			#if(wxCHECK_VERSION(3, 0, 0))
				return month_name.Capitalize();
			#else
				return month_name;
			#endif // wxCHECK_VERSION
		}
		else return wxEmptyString;
	}

	wxDateTime Bil_StrToDate(wxString S){
		wxDateTime date;
		int Y;
		#ifdef __WXMSW__
			date.ParseFormat(S,"%d/%m/%Y",wxDateTime::Today());
		#else
			date.ParseFormat(S, L"%d/%m/%Y", wxDateTime::Today());
		#endif
		if(date.IsValid()){
			Y = date.GetYear();
			if(Y < 10) date.SetYear(Y + 2000);	// workaround for document with single digit year
			return date;}
		return double(NULL);}

	#ifndef __BILCONVERT_BIN__
		void DonateWindow(void){
			DonateDialog(DonateAddress);}
	#endif // __BILCONVERT_BIN__

	#ifdef _BIL_INSTALLEDUPDATE
		TVersion GetInstalledVersion(void){
			// Version calculation
			TVersion Version;
			Version.Maj = MajorVersion;
			Version.Min = MinorVersion;
			Version.Rel = ReleaseVersion;
			Version.Bui = (unsigned long) &__BUILD_NUMBER;
			return Version;
		}
	#endif

	/* TODO -cEnhancement : Preparation for future enhancement */
	/*
	#ifdef __WXMSW__
	TVersion GetLastRunVersion(void){	// TODO (igor#1#): Rework using ProductVersions.h ???
		// Version calculation
		TVersion lrVersion;
		TVersion instVersion=GetInstalledVersion();
		#ifdef _BIL_USEREGISTRY
			//wxString Key=_T("HKEY_LOCAL_MACHINE\\")+SWKey();
			wxString SWKey="SOFTWARE\\igiSW\\Bilancio\\3.0";
			//wxRegKey *K=new wxRegKey(Key);
			wxRegKey *K=new wxRegKey(wxRegKey::HKLM,SWKey);
			if(!K->QueryValue(_T("MajVer_lr"),&lrVersion.Maj)){
				lrVersion.Maj=instVersion.Maj;
				K->SetValue(_T("MajVer_lr"),lrVersion.Maj);}
			if(!K->QueryValue(_T("MinVer_lr"),&lrVersion.Min)){
				lrVersion.Min=instVersion.Min;
				K->SetValue(_T("MinVer_lr"),lrVersion.Min);}
			if(!K->QueryValue(_T("RelVer_lr"),&lrVersion.Rel)){
				lrVersion.Rel=instVersion.Rel;
				K->SetValue(_T("RelVer_lr"),lrVersion.Rel);}
			if(!K->QueryValue(_T("BuiVer_lr"),&lrVersion.Bui)){
				lrVersion.Bui=instVersion.Bui;
				K->SetValue(_T("BuiVer_lr"),lrVersion.Bui);}
			delete K;
		#endif // _BIL_USEREGISTRY
		#ifdef __WXGTK__
			//wxFileConfig *Ver=new wxFileConfig(wxEmptyString,wxEmptyString,L"bilancio.ini",wxEmptyString,wxCONFIG_USE_GLOBAL_FILE,wxConvAuto());
			INI->SetPath(L"/Version lr");
			if(INI->HasEntry(L"MajVer_lr"))INI->Read(L"MajVer_lr",lrVersion.Maj);
			else{
				INI->Write(L"MajVer_lr",instVersion.Maj);
				lrVersion.Maj=instVersion.Maj;}
			if(INI->HasEntry(L"MinVer_lr"))INI->Read(L"MinVer_lr",lrVersion.Min);
			else{
				INI->Write(L"MinVer_lr",instVersion.Min);
				lrVersion.Min=instVersion.Min;}
			if(INI->HasEntry(L"RelVer_lr"))INI->Read(L"RelVer_lr",lrVersion.Rel);
			else{
				INI->Write(L"RelVer_lr",instVersion.Rel);
				lrVersion.Rel=instVersion.Rel;}
			if(INI->HasEntry(L"BuiVer_lr"))INI->Read(L"BuiVer_lr",lrVersion.Bui);
			else{
				INI->Write(L"BuiVer_lr",instVersion.Bui);
				lrVersion.Bui=instVersion.Bui;}
			INI->Flush();
			//delete Ver;
		#endif // __WXGTK__
		return lrVersion;}
	#endif // __WXMSW__
	*/

	#ifdef __WXMSW__
		#ifndef __BILCONVERT_BIN__
		wxString GetGUID(void){
			wxString ret=_T("bilexec");
			#ifdef _BIL_USEREGISTRY
				//wxString Key=_T("HKEY_LOCAL_MACHINE\\");
				wxString SWKey="SOFTWARE\\igiSW\\Bilancio\\3.0";
				//Key=Key+SWKey;
				wxRegKey *K=new wxRegKey(wxRegKey::HKLM,SWKey);
				K->QueryValue(_T("GUID"),ret);
				delete K;
			#endif // _BIL_USEREGISTRY
			return ret;}
		#endif // __BILCONVERT_BIN__
	#endif // __WXMSW__

	/*
	#ifdef _BIL_INSTALLEDUPDATE
		void CheckUpdate(void){
			//UPDPROC Proc;
			#ifdef __WXMSW__
				wxDynamicLibrary Proc("BilUpdate.DLL");
			#else
				wxDynamicLibrary Proc("./libbilupdate.so");

				wxString name=Proc.CanonicalizeName("bilupdate");

			#endif // __WXMSW__
			if(Proc.IsLoaded()){
				typedef void (*CheckUpdate_func)(void);
				wxDYNLIB_FUNCTION(CheckUpdate_func,fnCheckUpdate,Proc);
				//if(pfnCheckUpdate)pfnCheckUpdate();
				if(pfnfnCheckUpdate)pfnfnCheckUpdate();
				Proc.Detach();
				//delete Proc;
			}
		}
	#endif // _BIL_INSTALLEDUPDATE
	*/

	#ifndef __BILCONVERT_BIN__
		void AuthorWindow(void){
			#if _BIL_HASNATIVEABOUT == 0
				#ifdef __WXMSW__
					About(ProductName,ShortVersion,LongVersion,wxString::Format("%u",(unsigned long) &__BUILD_DATE));
				#else
					About(ProductName,ShortVersion,LongVersion,wxString::Format(L"%u",(unsigned long) &__BUILD_DATE));
				#endif // __WXMSW__
			#else
				wxAboutDialogInfo info;
				info.SetName(ProductName);
				info.SetVersion(LongVersion);
				info.SetDescription(_("Budget management"));
				info.SetCopyright(Copyright);
				info.SetWebSite(WebAddress);

				info.SetIcon(wxICON(Logo));

				wxString lic = wxEmptyString;
				wxString LicenseFile = GetShareDir() + L"doc/bilancio/license/";
				wxLocale loc;
				loc.Init(wxLANGUAGE_DEFAULT, wxLOCALE_LOAD_DEFAULT);
				wxLanguage Lan = (wxLanguage)loc.GetLanguage();
				switch(Lan){
					case wxLANGUAGE_ITALIAN:
						LicenseFile += L"it/licenza.txt";
						break;
					default:
						LicenseFile += L"en/license.txt";}
				wxTextFile *license= new wxTextFile(LicenseFile);
				license->Open();
				lic += license->GetFirstLine() + L"\n";
				while(!license->Eof()){
					lic += license->GetNextLine() + L"\n";
				}
				license->Close();
				info.SetLicense(lic);

				info.AddDeveloper(Copyright);
				#if(wxCHECK_VERSION(3,0,0))
					info.AddDeveloper(wxEmptyString);
					info.AddDeveloper(wxString::Format(_("Coded using %s."),wxGetLibraryVersionInfo().GetVersionString()));
					#ifndef _BIL_CHART_MATLIBPLOT
						info.AddDeveloper(_("wxFreeChart library used.") + freechart_version);
					#endif // _BIL_CHART_MATLIBPLOT
				#endif	// WXCHECK_VERSION
				info.AddTranslator(_("English: ")+Copyright);
				info.AddTranslator(_("Italian: ")+Copyright);
				wxAboutBox(info);
			#endif // _BIL_HASNATIVEABOUT == 0
		}
	#endif // __BILCONVERT_BIN__

	wxString SubstSpecialChars(wxString S){
			// source: http://www.mrwebmaster.it/xml/xml-lettere-accentate-perche-errore_8390.html
		#ifdef __WXMSW__
			S.Replace("&", "&amp;", true);
			S.Replace("à", "&#224;", true);
			S.Replace("á", "&#225;", true);
			S.Replace("è", "&#232;", true);
			S.Replace("é", "&#233;", true);
			S.Replace("ì", "&#236;", true);
			S.Replace("í", "&#237;", true);
			S.Replace("ò", "&#242;", true);
			S.Replace("ó", "&#243;", true);
			S.Replace("ù", "&#249;", true);
			S.Replace("ú", "&#250;", true);
			S.Replace("Ì", "&#204;", true);
			S.Replace("[BIL_ESCAPEQUOTES]", "&quot;", true);
	 #else
			S.Replace(L"&", L"&amp;", true);
			S.Replace(L"à", L"&#224;", true);
			S.Replace(L"á", L"&#225;", true);
			S.Replace(L"è", L"&#232;", true);
			S.Replace(L"é", L"&#233;", true);
			S.Replace(L"ì", L"&#236;", true);
			S.Replace(L"í", L"&#237;", true);
			S.Replace(L"ò", L"&#242;", true);
			S.Replace(L"ó", L"&#243;", true);
			S.Replace(L"ù", L"&#249;", true);
			S.Replace(L"ú", L"&#250;", true);
			S.Replace(L"Ì", L"&#204;", true);
			S.Replace(L"[BIL_ESCAPEQUOTES]", L"&quot;", true);
		#endif // __WXMSW__
		return S;}

		wxString GetShareDir(void){
			return ShareDir;}

	#ifndef __BILCONVERT_BIN__
		wxString GetDataDir(void){
			return DataDir;}

		wxString GetOSDocDir(void){
			wxStandardPathsBase& Paths=::wxStandardPaths::Get();
			wxString Doc=Paths.GetDocumentsDir();

			#ifdef __WXGTK__
				#if(wxCHECK_VERSION(3, 0, 0))
					FILE* pipe = popen("echo -n $(xdg-user-dir DOCUMENTS)", "r");
					if (!pipe) return Doc;
					char buffer[128];
					std::string result = "";
					while(!feof(pipe)) {
						if(fgets(buffer, 128, pipe) != NULL)
							result += buffer;
					}
					pclose(pipe);
					wxString result_string = result;
					if(result_string.IsEmpty()) return Doc;
					else return result_string;
							#else
									return Doc;
				#endif
			#else
				return Doc;
			#endif // __WXGTK__
	}
	#endif // __BILCONVERT_BIN__

	wxString GetCurrencySymbol(void){
		setlocale (LC_MONETARY,"");
		struct lconv * lc;
		lc=localeconv();
		#if (wxCHECK_VERSION(3, 0, 0) )
					return lc->currency_symbol;
		#else
			return wxString::FromUTF8(lc->currency_symbol);
		#endif
	}

	#ifdef _BIL_INSTALLEDUPDATE
		wxString GetVersionFile(void){
			return VersionFile;}
	#endif

	#ifndef __BILCONVERT_BIN__
		wxString GetWebAddress(void){
			return WebAddress;}

		wxString GetBugAddress(void){
			return BugAddress;}
	#endif

	#if (! wxCHECK_VERSION(3, 0, 0) )
		bool SubstLocaleDecimalSeparator(wxString &S, char ToSub){
		int Pos;
		Pos=S.Find(ToSub,false);
		if(Pos==wxNOT_FOUND||Pos==-1)return false;
		else{
			wxChar *ar = new wxChar[1];
			ar[0] = ToSub;
			S.Replace(ar, L".", true);
			return true;}}
	#endif

	wxString DoubleQuote(wxString S){
		if(S.Find('\'') != wxNOT_FOUND) S.Replace(L"'", L"''", true);
		return S;}

	#ifndef __BILCONVERT_BIN__
		#ifdef __WXGTK__
			wxString GetUserConfigDir(void){
				wxString usr_config_dir;
				wxGetEnv(L"XDG_CONFIG_HOME",&usr_config_dir);	// https://specifications.freedesktop.org/basedir-spec/basedir-spec-latest.html
				if(usr_config_dir.IsEmpty()) usr_config_dir = wxGetHomeDir() + L"/.config";
				usr_config_dir += L"/bilancio";
				if(! wxDirExists(usr_config_dir)){
					wxString old_path = wxGetHomeDir() + L"/.bilancio";
					if(wxDirExists(old_path)) wxRenameFile(old_path, usr_config_dir, false);
					else wxFileName::Mkdir(usr_config_dir, 0777, wxPATH_MKDIR_FULL);
				}
				return usr_config_dir;
			}
		#endif // __WXGTK__
	#endif // __BILCONVERT_BIN__

#endif  // IGIBIL_CPP_INCLUDED
