/***************************************************************
 * Name:      igibil.h
 * Purpose:   Code for Bilancio Application Class
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2017-01-08
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

#ifndef IGIBIL_HEADER_INCLUDED
#define IGIBIL_HEADER_INCLUDED

#ifndef __BILCONVERT_BIN__
	#include <wx/wx.h>
	//#include <wx/fileconf.h> // For wxFileConfig

	//#include "constants.h"
	#include "../types.h"

	#if _BIL_HASNATIVEABOUT == 0
		WXIMPORT void About(wxString Name,wxString ShortVer,wxString LongVer,wxString Date);
	#endif // _BIL_HASNATIVEABOUT == 0
	WXIMPORT void DonateDialog(wxString olURL/*,bool EN*/);

	WXEXPORT wxString CheckValue(wxString Val);
	WXEXPORT wxString FormDigits(double Val);
	WXEXPORT wxString IntToMonth(/*wxFileConfig *INI,*/int M);
	WXEXPORT wxDateTime Bil_StrToDate(wxString S);

	#ifndef __WXMSW__
		WXEXPORT void DonateWindow(void);
	#else
		WXEXPORT void DonateWindow(wxString Path);
	#endif

	WXEXPORT wxString GetCurrencySymbol(void);

	#ifdef _BIL_INSTALLEDUPDATE
		WXEXPORT TVersion GetInstalledVersion(void);
	#endif // _BIL_INSTALLEDUPDATE

	/* TODO -cEnhancement : Preparation for future enhancement */
	/*
	#ifdef __WXMSW__
		WXEXPORT TVersion GetLastRunVersion(void);
	#endif // __WXMSW__
	*/

	WXEXPORT wxString GetOSDocDir(void);

	#ifdef _BIL_INSTALLEDUPDATE
		WXEXPORT void CheckUpdate(void);
		WXEXPORT wxString GetVersionFile(void);
	#endif // _BIL_INSTALLEDUPDATE

	WXEXPORT void AuthorWindow(void);
	WXEXPORT wxString SubstSpecialChars(wxString S);
	WXEXPORT wxString GetDataDir(void);
	WXEXPORT wxString GetShareDir(void);
	WXEXPORT /*const*/ wxString GetWebAddress(void);
	WXEXPORT /*const*/ wxString GetBugAddress(void);

	#if (! wxCHECK_VERSION(3, 0, 0) )
    WXEXPORT bool SubstLocaleDecimalSeparator(wxString &S, char ToSub);
  #endif

	WXEXPORT wxString DoubleQuote(wxString S);

	#ifdef __WXGTK__
		WXEXPORT wxString GetUserConfigDir(void);
	#endif // __WXGTK__

#endif

#endif // IGIBIL_HEADER_INCLUDED
