/***************************************************************
 * Name:      igiLogoApp.cpp
 * Purpose:   Code for Application Class
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2016-10-08
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License: GNU
 **************************************************************/

#include <wx/wx.h>

#ifndef __BILCONVERT_BIN__
	#ifdef WX_PRECOMP
	#include "wx_pch.h"
	#endif

	#include <math.h>	// for pow function

	#include <wx/mstream.h>
	#include <wx/image.h>
	#include <wx/bitmap.h>

	#include "../platformsetup.h"
	#include "igilogolib.h"
	#include "ui/wxsplash.h"
	#include "ui/splashf.h"
	#include "ProductVersions.h"
	//#include "ui/thumb.bmp.h"
	#if _BIL_HASNATIVEABOUT == 0
		#include "ui/wxabout.h"
		#include "ui/about.h"
	#endif // _BIL_HASNATIVEABOUT

	#ifdef __WXMSW__
		#include "../../rsrc/icons/Icon_Application.xpm"
	#endif // __WXMSW__

	#ifdef __BORLANDC__
	#pragma hdrstop
	#endif //__BORLANDC__
#endif // __BILCONVERT_BIN__

wxString iUpperCase(wxString S){
	wxString C=S.Mid(0,1);
	C.MakeUpper();
	S=S.Mid(1,S.Len()-1);
	S=C+S;
	return S;}

#ifndef __BILCONVERT_BIN__
	void Logo(wxString Product){
	TSplash *Splash=new TSplash((wxFrame *)NULL);
		Splash->Label1->SetLabel(Product);
		Splash->Show();
		Splash->Centre(wxBOTH);
	}
#endif // __BILCONVERT_BIN__

/*
wxDialog* LogoWithInfo(wxString Product){
// NOTE (igor#1#): experimental
	TSplash *Splash=new TSplash((wxFrame *)NULL);
	//Splash.Timer->Stop();	// to be debugged
	Splash->SetLabel(Product);
	Splash->Label1->SetLabel(Product);
	Splash->Info->Show(true);
	return (wxDialog *)Splash;}
*/

#ifndef __BILCONVERT_BIN__
	#if _BIL_HASNATIVEABOUT == 0
	void About(wxString Name,wxString ShortVer,wxString LongVer,wxString Date){
		TAboutBox *AboutBox=new TAboutBox(wxTheApp->GetTopWindow());

		#ifdef __WXMSW__
			AboutBox->SetIcon(wxIcon(Logo_xpm));
		#endif // __WXMSW__

		AboutBox->Product_lbl->SetLabel(Name);
		AboutBox->ShortVersion_lbl->SetLabel(ShortVer);
		AboutBox->LongVersion_lbl->SetLabel(LongVer);
		AboutBox->Date_lbl->SetLabel(Date);
		AboutBox->email_lbl->SetURL(AboutBox->email_lbl->GetURL()+email+L"?subject="+Name+L"_v"+LongVer);
		AboutBox->ShowModal();
		delete AboutBox;}
	#endif // _BIL_HASNATIVEABOUT == 0

	void DonateDialog(wxString olURL){
		wxLaunchDefaultBrowser(olURL);}
#endif // __BILCONVERT_BIN__

