/***************************************************************
 * Name:      platformsetup.h
 * Purpose:   Setup for Bilancio application
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2016-08-21
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

/***************************************************************
Setup settings:

	_BIL_HASNATIVEABOUT		:	Use available OS about dialog box
	_BIL_INSTALLEDCONV		:	Conversion tool for old document format included
	_BIL_INSTALLEDUPDATE	: Update tool included
	_BIL_USEREGISTRY			:	Use Registry instead of INI file - MSW only
 **************************************************************/

#ifndef PLATFORMSETUP_H_INCLUDED
#define PLATFORMSETUP_H_INCLUDED

#if wxCHECK_VERSION(2, 8, 10) == 0
	#error Minimum wxWidget version is 2.8.12!
#endif // wxCHECK_VERSION

#define _BIL_INSTALLEDCONV 1

#if __WXGTK__
	#define _BIL_HASNATIVEABOUT 1
	//#define _BIL_CHART_MATLIBPLOT	// set in makefile
#elif __WXMSW__
	#define _BIL_HASNATIVEABOUT 0
	#define _BIL_USEREGISTRY
	#define _BIL_CHART_WXFREECHART
	//#define _BIL_INSTALLEDUPDATE  // switched in makefile
#endif // __WXGTK__

// Deprecated features
	// #define _BIL_FORMAT2x
	// #define _BIL_OLDFORMATSAVE_FEATURE
// -------------------

// Patches
	// #define _BIL_PATCH_LP_1529994	// recover from bug lp: #1529994

#endif // PLATFORMSETUP_H_INCLUDED
