/***************************************************************
 * Name:      productversion.h
 * Purpose:   Code for Bilancio Application Class
 * Author:    Igor Calì (igor.cali0@gmail.com)
 * Created:   2016-11-27
 * Copyright: Igor Calì (igor.cali0@gmail.com)
 * License:		GNU
 **************************************************************/

#ifndef PRODUCTVERSIONS_CPP_INCLUDED
#define PRODUCTVERSIONS_CPP_INCLUDED

#ifndef WX_PRECOMP
	#include <wx/wx.h>
#else
	#include <wx/wxprec.h>
#endif

#include "platformsetup.h"
#include "productversion.h"

// PRODUCT INFORMATION
//const wxString Vendor=L"igi SW";	// Vendor is provided by the igiLogo library
wxString ProductName=L"Bilancio";
#if _BIL_HASNATIVEABOUT
	wxString Copyright=L"© 2000-2017 Igor Calì <igor.cali0@gmail.com>";
#endif // _BIL_HASNATIVEABOUT

// CONTACT INFORMATION
//wxString email=L"igor.cali0@gmail.com"; // email is provided by the igiLogo library
wxString WebAddress = L"http://igisw-bilancio.sourceforge.net/";	//Website
wxString BugAddress = L"https://bugs.launchpad.net/bilancio";
wxString DonateAddress = L"http://igisw-bilancio.sourceforge.net/donation.html";
wxString VersionFile=L"http://igisw-bilancio.sourceforge.net/version.txt";	// Version file URL
//wxString SiteURL=L"https://db.tt/JcGOQqDZ";									// Site URL

#ifdef _ALPHA_
	wxString MinorVersion_text=wxString::Format(L"%da",MinorVersion);
#elif defined ( _BETA )
	wxString MinorVersion_text=wxString::Format(L"%db",MinorVersion);
#elif defined ( _RELCANDIDATE )
	wxString MinorVersion_text=wxString::Format(L"%drc",MinorVersion);
#else
	wxString MinorVersion_text=wxString::Format(L"%d",MinorVersion);
#endif // _BETA

wxString freechart_version = L" v1.7 svn3179";

#ifdef __WXMSW__
  wxString LongVersion=::wxString::Format("%d.%s.%d.%u",MajorVersion,MinorVersion_text.c_str(),ReleaseVersion,(unsigned long) &__BUILD_NUMBER);
  wxString ShortVersion=::wxString::Format("%d.%s",MajorVersion,MinorVersion_text.c_str());
#else
  wxString LongVersion=::wxString::Format(L"%d.%s.%d.%u",MajorVersion,MinorVersion_text.c_str(),ReleaseVersion,(unsigned long) &__BUILD_NUMBER);
  wxString ShortVersion=::wxString::Format(L"%d.%s",MajorVersion,MinorVersion_text.c_str());
#endif

#endif
